function retcode = DSGE_MS_CS_regressions(model_name,io_dir)
% define another xls
settings_filename=[io_dir filesep model_name '_extensive_post_processing_settings.xlsx'];
[settings,stringv]=xlsread(settings_filename,1,'a1:a5');
M00=settings(1);
seed0=settings(2);
ndx_postmean=settings(3);
alt_param_filename=stringv{1};
yields_forwards_datafile=stringv{2};
io_dir1=[io_dir filesep 'extensive_postprocessing'];
io_dir2=[io_dir1 filesep 'campbell_shiller_regressions'];
if ~exist(io_dir1,'dir')
    mkdir(io_dir1);
end
if ~exist(io_dir1,'dir')
    mkdir(io_dir1);
end
eval(['load ' io_dir filesep model_name '_results;']);
if strcmp(alt_param_filename,'param')==0
    eval(['load ' io_dir filesep alt_param_filename ';']);
end
%%
rng('default');
rng(seed0);
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
ns_=log(ncs)/log(2);
Mthin=M/M00;
ndx_lf=1; % if ==0 in the linear cases we use same values for latent variables as in quadratic case 
n4_=zeros(1,numel(n4)); % to prep the extended vector of maturities, eg 12 13 40 41
for in=1:numel(n4)
    n4_((in-1)*2+1)=n4(in);
    n4_((in-1)*2+2)=n4(in)+1;
    
end
nspread=2;
Ierr=2;% ex post errors or N(0,1) 
Ispec=4; % LHo, LMS, QHo, QMS
Ime=2; % with and without me
%CScaa=zeros(2,nspread,Imom,Ispec,Ime,M0);
CScaa= zeros(2,nspread,Ispec,Ierr,Ime,M00); % no Imom, since no theoretical moments
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
ndxYo=[1:4 5 7]'; % to consider only the series used in Yo (not R13 and R41)
Ysimaa=zeros(T,nyo+2,Ispec,Ierr,Ime,M00);
Yo_=Yo;
Yo_(end,4)=Yo_(end-1,4); % just to get rid of the NA on short term int rate on 2009Q1 (last obs)
%
CSxa=zeros(T,2,M00); % to contain [R(t,n)-R(t,1)]/(n-1)
CSya=zeros(T,2,M00); % to contain E_t(R(t+1,n-1) - R(t,n) 
%
for im=1:M00
    %Ysima=zeros(T,nyo+2,Ispec,Ime);
    if ndx_postmean
    delta0=mean(param(:,1:np))';
    else
        delta0=param(Mthin*(im-1)+1,1:np)';
    end
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    % quadratic solution
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4_);']);
    delta0_=[delta0(1:end-2);reshape(repmat(delta0(end-1:end)',2,1),4,1)];% this is to accommodate the extra 2 maturities (13 and 41 quarters)
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    D=repmat(D,[1 1 Ime]);
    D(:,:,2)=0;
    % linear solution
    eval(['[retcode_,y__,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,premia_] = ' solution_routine_name '2(1,delta0,n1,n2,n3,n4_);']);
   % delta0_=[delta0(1:end-2);reshape(repmat(delta0(end-1:end)',2,1),4,1)];% this is to accommodate the extra 2 maturities (13 and 41 quarters)
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,delta0_);
    % next two lines not really necessary
    %D_=repmat(D_,[1 1 Ime]);
    %D_(:,:,2)=0;
    % next two lines create structures of matrices to be used to generate
    %     data using DSGE_MS_dynamic_simulation.m
    % with measurement errors
    D_me =squeeze(D(:,:,1));
    D_nme=squeeze(D(:,:,2));
    % next two lines to provide separate arguments to v2struct (otherwise
    %     lumps together repeated arguments
    a_i__=a_i_;
    A1_i__=A1_i_;
    solution_2=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D_me,a_i_,A1_i_);
    solution_1=v2struct(a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_me,a_i__,A1_i__);
    % without measurement errors
    solution_2_=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D_nme,a_i_,A1_i_);
    solution_1_=v2struct(a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_nme,a_i__,A1_i__);
    % now draw S,Z from P(S,Z|theta,Y)
    %  start with filtering but using only Yo (without r13 and r41)
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,sv,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,...
        c_j(ndxYo,:),C1_j(ndxYo,:,:),C2(ndxYo,:),D_me(ndxYo,:),Sigma_zz,ctp,pv,1,1,1);
    sv_=ones(T+1,1);
    % now back up the standardized shocks to be used to generate data
    sv=[sv(1);sv];
    wm=zeros(nz,T);
    em=zeros(nz2,T);
    vm=zeros(nyo+2,T);
    for it=2:T
        s1=sv(it);
        s0=sv(it-1);
        z1=zm(it  ,:)';
        z0=zm(it-1,:)';
        wm(:,it)=z1-a_i(:,s0)-A1_i(:,:,s0)*z0-A2*vech_(z0*z0');
        em( :,it)=wm(nz1+1:end,it)./diag(squeeze(B_i(nz1+1:end,:,s0)));
        yt=Yo_(it,:)';
        yt=[yt(1:4); yt(5)*ones(2,1); yt(6)*ones(2,1)];
        vm(:,it)=(yt-c_j(:,s1)-C1_j(:,:,s1)*z1-C2*vech_(z1*z1'))./diag(squeeze(D(:,:,1)));
    end
    z0=zm(1,:)';
    em=[em;vm]; % these are the ex post errors
    ema=repmat(em,1,1,2);
    ema(:,2:end,2)=randn(nz2+nyo+2,T-1); % Gaussian shocks
    for ierr=1:Ierr
        %Ysima=zeros(T,nyo+2,Ispec,Ime); % T x (nyo+2) x Ispec (number specs 4) x Ime (w or w/o me 2)
        em=squeeze(ema(:,:,ierr));
        % now construct the data
        % E1: Lin+Hom
        datam      = DSGE_MS_dynamic_simulation(solution_1, z0,em,sv_,1);
        datam_     = DSGE_MS_dynamic_simulation(solution_1_,z0,em,sv_,1);
        Ysimaa(:,:,1,ierr,1,im)=400*datam( nz+1:end,:)';
        Ysimaa(:,:,1,ierr,2,im)=400*datam_(nz+1:end,:)';
        % store the z's for computing theoretical CS conditional expected
        % values 
        if ierr==1 % use ex post shocks
            zm=datam_(1:9,:)'; % no measurement errors (it should be immaterial on the z variables)
        end
        % E2: Lin+Het
        datam      = DSGE_MS_dynamic_simulation(solution_1, z0,em,sv,1);
        datam_     = DSGE_MS_dynamic_simulation(solution_1_,z0,em,sv,1);
        Ysimaa(:,:,2,ierr,1,im)=400*datam( nz+1:end,:)';
        Ysimaa(:,:,2,ierr,2,im)=400*datam_(nz+1:end,:)';
        % E3: Quad+Hom
        datam      = DSGE_MS_dynamic_simulation(solution_2, z0,em,sv_,1);
        datam_     = DSGE_MS_dynamic_simulation(solution_2_,z0,em,sv_,1);
        Ysimaa(:,:,3,ierr,1,im)=400*datam( nz+1:end,:)';
        Ysimaa(:,:,3,ierr,2,im)=400*datam_(nz+1:end,:)';
        % E4: Quad+Het
        datam      = DSGE_MS_dynamic_simulation(solution_2, z0,em,sv,1);
        datam_     = DSGE_MS_dynamic_simulation(solution_2_,z0,em,sv,1);
        Ysimaa(:,:,4,ierr,1,im)=400*datam( nz+1:end,:)';
        Ysimaa(:,:,4,ierr,2,im)=400*datam_(nz+1:end,:)';
        % express everything in % at annual rate
        %Ysima=400*Ysima;
        %Ysimaa(:,:,:,ierr,:,im)=Ysima; % store both shocks specs and all draws and all iterations 
        for ispec=1:Ispec
            for ime=1:Ime
                % computation using sample moments
                Ysim=squeeze(Ysimaa(:,:,ispec,ierr,ime,im));
                Y0sim=Ysim(2:end,:);
                Y1sim=Ysim(1:end-1,:);
                Ycs1=Y0sim(:,5)-Y1sim(:,6);
                Ycs2=Y0sim(:,7)-Y1sim(:,8);
                Xcs1=[ones(T-1,1) (Y1sim(:,6)-Y1sim(:,4))/12];
                Xcs2=[ones(T-1,1) (Y1sim(:,8)-Y1sim(:,4))/40];
                %
                CScaa(:,:,ispec,ierr,ime,im)=[Xcs1\Ycs1 Xcs2\Ycs2];
            end
        end
    end
    % construct the exact arguments in the CS framework, i.e. E_t(R(t+1,n-1)) etc
    zt1_tm=zeros(T,nz);
    yt1_tm=zeros(T,nyo+2);
    ytm=zeros(T,nyo+2);
    for it=1:T-1
        z0=zm(it,:)';
        y0=c_j_(:,1)+C1_j_(:,:,1)*z0;
        ytm(it,:)=y0';
        z1=a_i_(:,1)+A1_i_(:,:,1)*z0;
        zt1_tm(it+1,:)=z1';
        y1=c_j_(:,1)+C1_j_(:,:,1)*z1;
        yt1_tm(it+1,:)=y1';
    end
    CSya(2:end,:,im)=400*(yt1_tm(2:end,[5 7])-ytm(1:end-1,[6 8]));
    CSxa(1:end-1,:,im)=400*[ytm(1:end-1,[4 6])*[-1;1]/12 ytm(1:end-1,[4 8])*[-1;1]/40];
    %
    clc;
    im/M00
end
%% work with mean of the simulated data
Ysima_=mean(Ysimaa,6);
CSca_=zeros(4,4,Ispec,Ierr,Ime);
for ierr=1:Ierr
    for ispec=1:Ispec
        for ime=1:Ime
            % computation using sample moments
            Ysim=Ysima_(:,:,ispec,ierr,ime);
            Y0sim=Ysim(2:end,:);
            Y1sim=Ysim(1:end-1,:);
            Ycs1=Y0sim(:,5)-Y1sim(:,6);
            Ycs2=Y0sim(:,7)-Y1sim(:,8);
            Xcs1=[ones(T-1,1) (Y1sim(:,6)-Y1sim(:,4))/12];
            Xcs2=[ones(T-1,1) (Y1sim(:,8)-Y1sim(:,4))/40];
            resultsCS1=ols(Ycs1,Xcs1);
            resultsCS2=ols(Ycs2,Xcs2);
            table_CS_regressions=[resultsCS1.beta resultsCS1.bstd resultsCS1.beta-1.96*resultsCS1.bstd resultsCS1.beta+1.96*resultsCS1.bstd;...
                resultsCS2.beta resultsCS2.bstd resultsCS2.beta-1.96*resultsCS2.bstd resultsCS2.beta+1.96*resultsCS2.bstd;...
                ];
            CSca_(:,:,ispec,ierr,ime)=table_CS_regressions;
        end
    end
end
%% do it now with actual data
eval(['load ' yields_forwards_datafile ';']);
T0=datesv(1);
T=datesv(end);
iT0=find(qdatesv==T0);
iT=find(qdatesv==T);
spotm=qseriesm(iT0:iT,:); % columns are y01 y12 
T=size(spotm,1);
spotm0=spotm(2:end,:); % contains the "t+1" series
spotm1=spotm(1:end-1,:);% contains the "t" series
Ycs1=spotm0(:,2)-spotm1(:,3); %y12(t+1) - y13(t) 
Ycs2=spotm0(:,4)-spotm1(:,5); %y40(t+1) - y41(t)
Xcs1=[ones(T-1,1) (spotm1(:,3)-spotm1(:,1))/12];
Xcs2=[ones(T-1,1) (spotm1(:,5)-spotm1(:,1))/40];
resultsCS1=ols(Ycs1,Xcs1);
resultsCS2=ols(Ycs2,Xcs2);
table_CS_regressions_data=[resultsCS1.beta resultsCS1.bstd resultsCS1.beta-1.96*resultsCS1.bstd resultsCS1.beta+1.96*resultsCS1.bstd;...
    resultsCS2.beta resultsCS2.bstd resultsCS2.beta-1.96*resultsCS2.bstd resultsCS2.beta+1.96*resultsCS2.bstd;...
    ];
%{
% now dump the series into an excel file and a mat file
str_cols={'est','std','lower_95q','upper_95q'};
Table_CS_regressions_data=array2table(table_CS_regressions,'VariableNames',str_cols);
writetable(Table_CS_regressions_data,'table_CS_regressions_data.xlsx');
save('table_CS_regressions_data','str_cols','table_CS_regressions');
%}
    
    
%% construct final table
bigtable=zeros(17,10,2); % 
for ime=1:2
    for ierr=1:Ierr
        for ispec=1:Ispec
            tm=squeeze(CSca_([2 4], :,ispec,ierr,ime));
            tv=reshape([tm  normcdf(1,tm(:,1),tm(:,2))]',[],1);
            bigtable((ierr-1)*Ispec+ispec,:,ime)=tv';
            tm=squeeze(CScaa(2,:,ispec,ierr,ime,:));
            tv_=zeros(5,2);
            for imat=1:2
                tv=sort(tm(imat,:))';
                tv_(1,imat)=mean(tv);
                tv_(2,imat)=std(tv);
                tv_(3:4,imat)=tv(floor(M00*[.025 .975]));
                tv_(5,imat)=find(tv<=1,1,'last')/M00;
            end
            bigtable(Ispec*Ierr+(ierr-1)*Ispec+ispec,:,ime)=tv_(:)';
        end
    end
end
% last row of the table to be used for the real data results
tm=table_CS_regressions_data([2 4],:);
tv=reshape([tm  normcdf(1,tm(:,1),tm(:,2))]',[],1);
for im=1:2
bigtable(17,:,im)=tv';
end
%
cols_strv={'mean','std','lower','upper','pvalue','mean','std','lower','upper','pvalue'};
rows_strv={ ...
    'Lin no MS ex post fd', 'Lin MS ex post fd', 'Quad no MS ex post fd', 'Quad MS ex post fd', ...
    'Lin no MS ex ante fd', 'Lin MS ex ante fd', 'Quad no MS ex ante fd', 'Quad MS ex ante fd', ...
    'Lin no MS ex post pm', 'Lin MS ex post pm', 'Quad no MS ex post pm', 'Quad MS ex post pm', ...
    'Lin no MS ex ante pm', 'Lin MS ex ante pm', 'Quad no MS ex ante pm', 'Quad MS ex ante pm', ...
    'Actual data' ...
    };

% make tables with and without meas errors 
for ime=1:2
input.data=squeeze(bigtable(:,:,ime));
    % Optional fields:
    
    % Set column labels (use empty string for no label):
    input.tableColLabels =cols_strv;
    input.tableRowLabels =rows_strv;
    input.transposeTable = 0;
    % Determine whether input.dataFormat is applied column or row based:
    input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
    % Formatting-string to set the precision of the table values:
    % For using different formats in different rows use a cell array like
    % {myFormatString1,numberOfValues1,myFormatString2,numberOfValues2, ... }
    % where myFormatString_ are formatting-strings and numberOfValues_ are the
    % number of table columns or rows that the preceding formatting-string applies.
    % Please make sure the sum of numberOfValues_ matches the number of columns or
    % rows in input.tableData!
    %
    input.dataFormat = {'%1.2f',size(input.data,2)}; % three digits precision for first two columns, one digit for the last
        % Define how NaN values in input.tableData should be printed in the LaTex table:
    input.dataNanString = '-';
        % Column alignment in Latex table ('l'=left-justified, 'c'=centered,'r'=right-justified):
    input.tableColumnAlignment = 'c';
        % Switch table borders on/off:
    input.tableBorders = 1;
    % LaTex table caption:
    input.tableCaption = ['Campbell Shiller Regressions output'];
        % LaTex table label:
    input.tableLabel = ['CSOutput' int2str(ime)];
        % Switch to generate a complete LaTex document or just a table:
    input.makeCompleteLatexDocument =0;
        % call latexTable:
    latex = latexTable(input);
    latex=strrep(latex,'H!','htbp');
    %latex=strrep(latex,'_','\_');
    if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
    end
    diary([input.tableLabel '.tex']);
    disp(char(latex));
    diary off;
end
%%  
    save('CS_results.mat','CScaa','CSca_','bigtable','rows_strv','cols_strv','CSxa','CSya');
    CSym=mean(CSya,3);
    CSxm=mean(CSxa,3);
    %{
    im=50;
    CSym=squeeze(CSya(:,:,im));
    CSxm=squeeze(CSxa(:,:,im));
    %}
    figure(1)
    for imat=1:2
        subplot(2,1,imat);
        plot(datesv(2:end),[CSym(2:end,imat) CSxm(1:end-1,imat)]);
    end
    print(1,'-dpdf','CS_conditional_expectations','-fillpage');
%{
    v=VideoWriter('v.mp4');
    open(v);
 for im=1:M0
     CSym=squeeze(CSya(:,:,im));
     CSxm=squeeze(CSxa(:,:,im));
     figure(2)
     for imat=1:2
        subplot(2,1,imat);
        plot(datesv(2:end),[CSym(2:end,imat) CSxm(1:end-1,imat)],'LineWidth',1);
     end
     frame=getframe(gcf);
     writeVideo(v,frame);
 end
 close(v);
print(2,'-dpdf',[io_dir2 filesep 'CS_conditional_expectations'],'-fillpage');
%}

CSfda=zeros(2,4,2,2,M00); % number of maturities x nmodels x Ierr x Ime x M0
for im=1:M00
    for ime=1:2
        for ierr=1:2
            for imod=1:4
                Ysim=squeeze(Ysimaa(:,4:end,imod,ierr,ime,im));
                Y0sim=Ysim(2:end,:);
                Y1sim=Ysim(1:end-1,:);
                Ycs1=Y0sim(:,2)-Y1sim(:,3); %R_{12}^{t+1} - R_{13}^{t}
                Ycs2=Y0sim(:,4)-Y1sim(:,5); %R_{40}^{t+1} - R_{41}^{t}

                Xcs1=[ones(T-1,1) (Y1sim(:,3)-Y1sim(:,1))/12];%[R_{13}^{t}-R_{1}^{t}]/12                
                Xcs2=[ones(T-1,1) (Y1sim(:,5)-Y1sim(:,1))/40];%[R_{41}^{t}-R_{1}^{t}]/40
                resultsCS1=ols(Ycs1,Xcs1);
                resultsCS2=ols(Ycs2,Xcs2);
                CSfda(:,imod,ierr,ime,im)=[resultsCS1.beta(2);resultsCS2.beta(2)];
                clc;
                im/M00
            end
        end
    end
end
%% report
xv=linspace(-3,3,100)';
pydatam=zeros(100,2);
  for imat=1:2
      pydatam(:,imat)=normpdf(xv,table_CS_regressions_data(2*imat,1),table_CS_regressions_data(2*imat,2));
  end
% combine charts for each maturity, different models, ex post and ex ante
%
model4_strv={'Lin no MS','Lin MS','Quad no MS','Quad MS'};
mat2_strv={'R12','R40'};
ierr_strv= {'ex post','ex ante'};
ierr_strv_={'ex_post','ex_ante'}; % for the pdf files to be saved

ime_strv={'with meas err','without meas err'};
nbins=20;
ifig=0;
for ierr=1:2
    ifig=ifig+1;
    figure(ifig);
    for imodel=1:4
        for imat=1:2
            subplot(4,2,2*(imodel-1)+imat);
            gxm=squeeze(CSfda(imat,imodel,ierr,:,:))';
            %hist(gxm,nbins);
            %histm=[squeeze(priorparama(:,ip,ifig)) squeeze(parama(:,ip,ifig))];
            %subplot(10,4,ip);
            pd1 = fitdist(gxm(:,1),'kernel');
            pd2 = fitdist(gxm(:,2),'kernel');
            y1 = pdf(pd1,xv);
            y2 = pdf(pd2,xv);
            plot(xv,[ y1 y2 pydatam(:,imat)],'LineWidth',2)
            xline(table_CS_regressions_data(2*imat,1),'LineWidth',2);
            title([mat2_strv{imat} ' ' model4_strv{imodel}]);
            if imodel==1 && imat==1
                legend({'with meas err','no meas err','actual data'},'Location','NorthWest','NumColumns',1);
                legend boxoff;
            end
        end
    end
    sgtitle(['CS regression coeffs distribution ' ierr_strv{ierr} ]);
    print(ifig,'-dpdf',['CS_coefficients_pdfs_' ierr_strv_{ierr}],'-fillpage');

end
%% move everything in the target directory
system(['mv CS* ' io_dir2 ';']);
retcode=1;
close all;