function [retcode,lnlv,Za,Qa,pm] = DSGE_MS_Kim_Filter_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,ind_ekf)
% this seems to be unused
% differs from DSGE_MS_Kim_Filter in allowing for missing values
Yo_am=1-isnan(Yo); % this is to create matrix with zero elements for elements of Yo which are NA 
[nz,nz2,ncs]=size(B_i);
[T,nyo]=size(Yo);
%nz1=nz-nz2;
%nyo=size(c_j,1);
T_=vec2vech_(nz);
z00m=zeros(nz,ncs);
Q00a=repmat((Sigma_zz+Sigma_zz')/2,[1 1 ncs]);
Q10a=zeros(nz,nz,ncs);
p0=pv;
BB_i=zeros(nz,nz,ncs);
for ics=1:ncs    
    BB_i(:,:,ics)=B_i(:,:,ics)*B_i(:,:,ics)';
end
%D=eye(6)*1e-4;
DD=D*D';
z10m=zeros(nz,ncs);
z11a=zeros(nz,ncs,ncs);
Q11a=zeros(nz,nz,ncs,ncs);
lnlv=zeros(T,1);
Za=zeros(T,nz,ncs);
Qa=zeros(T,nz,nz,ncs);
pm=zeros(T,ncs);
if ind_ekf==0
    A2=0*A2;
    C2=0*C2;
end
for it=1:T    
    % here select dimensions which are relevant at observation t
    ndx_ynm=find(Yo_am(it,:)'>0);
    yt=Yo(it,ndx_ynm)';
    % compute p(s_t,s_(t-1)|y_t_)
    P10=ctp.*repmat(p0,1,ncs);
    pytm_ij=zeros(ncs,ncs);
    if numel(yt)
        for ics=1:ncs
            D0i=T_*dk2v(z00m(:,ics));
            A1_i_=A1_i(:,:,ics)+A2*D0i;
            a_i_=a_i(:,ics)+A2*(quadc1(z00m(:,ics))-D0i*z00m(:,ics));
            z10m(:,ics)=a_i_+A1_i_*z00m(:,ics);
            Q10i=A1_i_*Q00a(:,:,ics)*A1_i_'+BB_i(:,:,ics);
            Q10a(:,:,ics)=(Q10i+Q10i')/2;
            D1i=T_*dk2v(z10m(:,ics));
            for jcs=1:ncs
                C1_j_=C1_j(ndx_ynm,:,jcs)+C2(ndx_ynm,:)*D1i;
                c_j_=c_j(ndx_ynm,jcs)+C2(ndx_ynm,:)*(quadc1(z10m(:,ics))-D1i*z10m(:,ics));
                K0ij=Q10a(:,:,ics)*C1_j_';
                Sigmay_ij=(C1_j_*K0ij+DD(ndx_ynm,ndx_ynm));
                Sigmay_ij=(Sigmay_ij+Sigmay_ij')/2;
                muy_ij=c_j_+C1_j_*z10m(:,ics);
                [retcode,p_ij]=GaussianPdfMatrix1_(yt,muy_ij,Sigmay_ij); % this is log
                if retcode == 0
                    return
                end
                pytm_ij(ics,jcs)=p_ij;
                Kij=K0ij/Sigmay_ij;
                z11a(:,ics,jcs)=z10m(:,ics)+Kij*(yt-muy_ij);
                Q11ij=Q10a(:,:,ics)-Kij*K0ij';
                Q11a(:,:,ics,jcs)=(Q11ij+Q11ij')/2;
            end
        end
    else
        % this is in the case no updating actually takes place
        % p_ij=zeros(ncs,ncs);
        pytm_ij=zeros(ncs,ncs);
        for ics=1:ncs
            D0i=T_*dk2v(z00m(:,ics));
            A1_i_=A1_i(:,:,ics)+A2*D0i;
            a_i_=a_i(:,ics)+A2*(quadc1(z00m(:,ics))-D0i*z00m(:,ics));
            z10m(:,ics)=a_i_+A1_i_*z00m(:,ics);
            Q10i=A1_i_*Q00a(:,:,ics)*A1_i_'+BB_i(:,:,ics);
            Q10a(:,:,ics)=(Q10i+Q10i')/2;
            for jcs=1:ncs
                z11a(:,ics,jcs)=z10m(:,ics);
                Q11ij=Q10a(:,:,ics);
                Q11a(:,:,ics,jcs)=(Q11ij+Q11ij')/2;
            end
        end
    end
    % now discrete part of the filter
        pytmax=max(max(pytm_ij));
        P11=P10.*exp(pytm_ij-pytmax);
        lnlt=sum(sum(P11));
        P11=P11/lnlt;
        if numel(yt)
            lnlv(it)=log(lnlt)+pytmax;
    else
        % no learning at all if yt=[]
        lnlv(it)=0;        
    end
    p0=sum(P11,1)';
%     p0(p0<1e-12)=1e-12;
%     p0=p0/sum(p0);
    pm(it,:)=p0';
    P01=P11./repmat(p0',ncs,1);
    % now assemble the matrices
    z00m=0*z00m;
    Q00a=0*Q00a;    
    for jcs=1:ncs
        for ics=1:ncs
            z00m(:,jcs)=z00m(:,jcs)+z11a(:,ics,jcs)*P01(ics,jcs);
        end
    end
    Za(it,:,:)=z00m;    
    for jcs=1:ncs
        for ics=1:ncs
            cmean_ij=z11a(:,ics,jcs)-z00m(:,jcs);
            Q00aj=Q00a(:,:,jcs)+(Q11a(:,:,ics,jcs)+cmean_ij*cmean_ij')*P01(ics,jcs);
            Q00a(:,:,jcs)=(Q00aj+Q00aj')/2;
        end
    end
    Qa(it,:,:,:)=Q00a;
end