function [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
    DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,ind_ekf,ind_sim_zm,ind_sim_sm)
% this is used in post processing and encompasses all previous versions which will be eliminated
% it also allows for missing values in the data
% gianni.amisano1@gmail.com
% 2019-06-17
% this is to inizialize all outputs, in case execution goes directly to end
lnlv=[];pyta_ij=[];Za=[];Qa=[];pm=[];P01a=[];Z10a=[];Q10aa=[];...
    p1m=[];sm=[];simstate=[];muy_ij_a=[];Sigmay_ij_a=[];y10m=[];zm=[];
%
Yo_am=1-isnan(Yo); % this is to create matrix with zero elements for elements of Yo which are NA 
simstate=[];
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
[T,nyo]=size(Yo);
T_=vec2vech_(nz);
z00m=zeros(nz,ncs);
A1_it_a=zeros(T,nz,nz,ncs);
Q00a=repmat(Sigma_zz,[1 1 ncs]);
Z10a=zeros(T,nz,ncs);
Q10aa=zeros(T,nz,nz,ncs);
P01a=zeros(T,ncs,ncs);
p1m=zeros(T,ncs);
muy_ij_a=zeros(T,nyo,ncs,ncs);
Sigmay_ij_a=zeros(T,nyo,nyo,ncs,ncs);
y10m=zeros(T,nyo);
pyta_ij=zeros(T,ncs,ncs);
p0=pv;
BB_i=zeros(nz,nz,ncs);
for ics=1:ncs
    BB_i(:,:,ics)=B_i(:,:,ics)*B_i(:,:,ics)';
end
DD=D*D';
lnlv=zeros(T,1);
Za=zeros(T,nz,ncs);
Qa=zeros(T,nz,nz,ncs);
pm=zeros(T,ncs);
if ind_ekf==0
    A2=0*A2;
    C2=0*C2;
end
for it=1:T    
    % here select dimensions which are relevant at observation t
    ndx_ynm=find(Yo_am(it,:)'>0);
    yt_=Yo(it,ndx_ynm)';
    % initialize
    z10m=zeros(nz,ncs);
    z11a=zeros(nz,ncs,ncs);
    Q11a=zeros(nz,nz,ncs,ncs);
    Q10a=zeros(nz,nz,ncs);
    % compute p(s_t,s_(t-1)|y_t_)
    P10=ctp.*repmat(p0,1,ncs);
    p1m(it,:)=sum(P10);
    pytm_ij=zeros(ncs,ncs);
    % construct all the necessary objects
    % projection
    for ics=1:ncs
            D0i=T_*dk2v(z00m(:,ics));
            A1_i_=A1_i(:,:,ics)+A2*D0i;
            A1_it_a(it,:,:,ics)=A1_i_;
            a_i_=a_i(:,ics)+A2*(quadc1(z00m(:,ics))-D0i*z00m(:,ics));
            z10m(:,ics)=a_i_+A1_i_*z00m(:,ics);
            Q10i=A1_i_*Q00a(:,:,ics)*A1_i_'+BB_i(:,:,ics);
            Q10a(:,:,ics)=(Q10i+Q10i')/2;
            D1i=T_*dk2v(z10m(:,ics));
            for jcs=1:ncs
                C1_j_=C1_j(:,:,jcs)+C2(:,:)*D1i;
                c_j_=c_j(:,jcs)+C2*(quadc1(z10m(:,ics))-D1i*z10m(:,ics));
                K0ij=Q10a(:,:,ics)*C1_j_';
                Sigmay_ij=C1_j_*K0ij+DD;
                Sigmay_ij=(Sigmay_ij+Sigmay_ij')/2;
                Sigmay_ij_a(it,:,:,ics,jcs) = Sigmay_ij;
                muy_ij=c_j_+C1_j_*z10m(:,ics);
                % added 2020-05-15 : store into muy_ij_a
                muy_ij_a(it,:,ics,jcs)=muy_ij;
                if numel(yt_)
                    muy_ij_=muy_ij(ndx_ynm);
                    Sigmay_ij_=Sigmay_ij(ndx_ynm,ndx_ynm);
                    K0ij_=K0ij(:,ndx_ynm);
                    [retcode,p_ij]=GaussianPdfMatrix1_(yt_,muy_ij_,Sigmay_ij_); % this is log
                    if retcode == 0
                        return
                    end
                    pytm_ij(ics,jcs)=p_ij;
                    Kij_=K0ij_/Sigmay_ij_;
                    z11a(:,ics,jcs)=z10m(:,ics)+Kij_*(yt_-muy_ij_);
                    Q11ij=Q10a(:,:,ics)-Kij_*K0ij_';
                    Q11a(:,:,ics,jcs)=(Q11ij+Q11ij')/2;
                else
                    % this is in the case no updating actually takes place
                    % p_ij=zeros(ncs,ncs);
                    z11a(:,ics,jcs)=z10m(:,ics);
                    Q11ij=Q10a(:,:,ics);
                    Q11a(:,:,ics,jcs)=(Q11ij+Q11ij')/2;
                end             
            end
    end
    Q10aa(it,:,:,:)=Q10a;
    Z10a(it,:,:)=z10m;
    pyta_ij(it,:,:)=pytm_ij;
    for iy=1:nyo
        y10m(it,iy)=sum(sum(squeeze(muy_ij_a(it,iy,:,:)).*P10));
    end
    % now discrete part of the filter
    pytmax=max(max(pytm_ij));
    P11=P10.*exp(pytm_ij-pytmax);
    lnlt=sum(sum(P11));
    P11=P11/lnlt;
    if numel(yt_)
        lnlv(it)=log(lnlt)+pytmax;
    else
        % no learning at all if yt=[]
        lnlv(it)=0;
    end
    p0=sum(P11,1)';
    %     p0(p0<1e-12)=1e-12;
    %     p0=p0/sum(p0);
    pm(it,:)=p0';
    % this is to get around issue that some elements of p0
    % (the vector 
    P01=zeros(ncs,ncs);
    for jcs=1:ncs
        if p0(jcs)>0
            P01(:,jcs)=P11(:,jcs)/p0(jcs);
        end
    end
    %P01=P11./repmat(p0',ncs,1);
    % now assemble the matrices
    z00m=0*z00m;
    Q00a=0*Q00a;
    for jcs=1:ncs
        for ics=1:ncs
            z00m(:,jcs)=z00m(:,jcs)+z11a(:,ics,jcs)*P01(ics,jcs);
        end
    end
    Za(it,:,:)=z00m;
    for jcs=1:ncs
        for ics=1:ncs
            cmean_ij=z11a(:,ics,jcs)-z00m(:,jcs);
            Q00aj=Q00a(:,:,jcs)+(Q11a(:,:,ics,jcs)+cmean_ij*cmean_ij')*P01(ics,jcs);
            Q00a(:,:,jcs)=(Q00aj+Q00aj')/2;
        end
    end
    Qa(it,:,:,:)=Q00a;
end
% now we do the smoothing part
sm=pm;
if ind_sim_sm
    simstate=zeros(T,1);
    simstate(end)=draw_multinom(pm(T,:)',1,ncs,1);
    for it=(T-1):-1:1
        p1=(pm(it,:)').*ctp(:,simstate(it+1));
        p1=p1/sum(p1);
        simstate(it)=draw_multinom(p1,1,ncs,1);
        %
        p10=ctp'*(pm(it,:)');
        p11=(pm(it,:)').*(ctp*((sm(it+1,:)')./p10));
        sm(it,:)=p11';
        %
    end
else
    for it=(T-1):-1:1
        p10=ctp'*(pm(it,:)');
        p11=(pm(it,:)').*(ctp*((sm(it+1,:)')./p10));
        sm(it,:)=p11';
    end
end
% implement the simulation smoother now
if ind_sim_zm
    zm=zeros(T,nz);
    s1=simstate(T);
    muz=Za(T,:,s1)';
    [rankQ,F]=factorise_semidefinitem(squeeze(Qa(T,:,:,s1)));
    zm(T,:)=(muz+F*randn(rankQ,1))';
    for it=T-1:-1:1
        s0=simstate(it);
        %s1=simstate(it+1);
        Q10=squeeze(Q10aa(it+1,nz1+1:end,nz1+1:end,s0));
        Q00=squeeze(Qa(it,:,:,s0));
        A1_=squeeze(A1_it_a(it,nz1+1:end,:,s0));
        z10=squeeze(Z10a(it+1,nz1+1:end,s0))';
        z00=squeeze(Za(it,:,s0))';
        z1=zm(it+1,nz1+1:end)';
        K0=Q00*A1_';
        K1=K0/Q10;
        z01=z00+K1*(z1-z10);
        Q01=Q00-K1*K0';
        Q01=(Q01+Q01')/2;
        [rankQ,F]=factorise_semidefinitem(Q01);
        z01_draw=z01+F*randn(rankQ,1);
        zm(it,:)=z01_draw';
    end
else
    zm=[];
end