function retcode = DSGE_MS_estimation_results_tables(model_name,io_dir)
io_dir1=[io_dir  filesep 'extensive_postprocessing']; 
io_dir2=[io_dir1 filesep 'estimation_results_tables'    ]; % this is the specific folder to be used to store results
eval(['load ' io_dir filesep model_name '_results;']); % read results file
%%
param_namev=parameter_name(sim1ndx);
table_data=testm(sim1ndx,[1 2 5 6]);
table_data(end-5:end,:)=400*table_data(end-5:end,:); % to express measurement errors in annual % terms
%% make table
column_label=[];
column_label{1}= 'posterior mean';
column_label{2}= 'posterior std dev';
column_label{3}= 'prior mean';
column_label{4}= 'prior std dev';
row_label=param_namev;
input.data=table_data;
% Optional fields:
% Set column labels (use empty string for no label):
input.tableColLabels =column_label;
input.tableRowLabels =row_label;
input.transposeTable = 0;
% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
% Formatting-string to set the precision of the table values:
% For using different formats in different rows use a cell array like
% {myFormatString1,numberOfValues1,myFormatString2,numberOfValues2, ... }
% where myFormatString_ are formatting-strings and numberOfValues_ are the
% number of table columns or rows that the preceding formatting-string applies.
% Please make sure the sum of numberOfValues_ matches the number of columns or
% rows in input.tableData!
%
input.dataFormat = {'%2.4f',4}; % three digits precision for first two columns, one digit for the last
% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';
% Column alignment in Latex table ('l'=left-justified, 'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'c';
% Switch table borders on/off:
input.tableBorders = 1;
% LaTex table caption:
input.tableCaption = 'Estimation output';
% LaTex table label:
input.tableLabel = 'EstimationOutput';
% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 1;
% call latexTable:
latex = latexTable(input);
latex=strrep(latex,'H!','h!');
latex=strrep(latex,'_','\_');
if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;
system(['mv *.tex ' io_dir2 ';']);

retcode=1;
