function retcode = DSGE_MS_forward_rates(model_name,io_dir)
%% Section 1: 
%file with setting for extensive post processing
settings_filename=[io_dir filesep model_name '_extensive_post_processing_settings.xlsx'];
[settings,stringv]=xlsread(settings_filename,1,'a1:a7');
M00=settings(1); % number of draws
seed0=settings(2); % seed of rng
ndx_postmean=settings(3); % whether or not post mean is used
Nh=settings(6); % max horizon for dynamic correlations, irfs, fevd,etc 
alt_param_filename=stringv{1}; % to specify an alternative file for parameters (for some special simulations)
%yields_forwards_datafile=stringv{2}; % not used here
forwards_filename=stringv{4};
%
io_dir1=[io_dir  filesep 'extensive_postprocessing']; 
io_dir2=[io_dir1 filesep 'forward_rates'    ]; % this is the specific folder to be used to store results
% check whether these directory exist. If not, create them
if ~exist(io_dir1,'dir')
    mkdir(io_dir1);
end
if ~exist(io_dir2,'dir')
    mkdir(io_dir2);
end
eval(['load ' io_dir filesep model_name '_results;']); % read results file
% if the settings file indicates a name different from "param", and if that file exists
% then it loads parameters from that source 
if strcmp(alt_param_filename,'param')==0 && exist([io_dir filesep alt_param_filename],'file') 
    eval(['load ' io_dir filesep alt_param_filename ';']);
end
%
M=size(param,1);
rng('default');
rng(seed0);
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
ns_=log(ncs)/log(2);
Mthin=M/M00;
%nss=length(s_str);
%ncs=2^nss;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,ns_); % construct indices for checking label permute
% this bloc is to create spreads and define (T x 8 ) matrix with data on
% spread too
nspread=numel(n4); 
Trm=zeros(nspread,nyo);
Trm(:,nyd-nspread)=-1;
Trm(:,nyd-nspread+1:end)=eye(nspread);
Trm_=[eye(nyo); Trm]; % this is matrix to transform Y into Ys (nyo+nspread) x 1
nyo_=nyo+nspread;
Yo_=Yo*Trm_';
%
%% section 4: compute all maturities from the model
n4_=2:(n4(end)+1); % extended vector of maturities
ndx_Yo=[1 2 3 4 3+n4];
%nspread=2;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
Ysa=zeros(T,44,M00);
Yfa=zeros(T,44,M00);
for im=1:M00
    if ndx_postmean
    delta0=mean(param(:,1:np))';
    else
        delta0=param(Mthin*(im-1)+1,1:np)';
    end
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4_);']);
    %delta0_=[delta0(1:end-2);reshape(repmat(delta0(end-1:end)',2,1),4,1)];
    %delta0_=[delta0;zeros(38,1)];
    deltame=zeros(40,1);
    deltame([1 n4])=delta0(end-2:end);
    delta0_=[delta0(1:end-3);deltame];
    [a_i,A1_i,A2,B_i,c_j_,C1_j_,C2_,D_,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    c_j=c_j_(ndx_Yo,:);
    C1_j=C1_j_(ndx_Yo,:,:);
    C2=C2_(ndx_Yo,:);
    D=D_(ndx_Yo,ndx_Yo);
    
    [retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
    DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);

    
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    Zfm=zeros(T,nx);
    Zsm=zeros(T,nx);
    for ics=1:ncs
        Zfm=Zfm+Za(:,:,ics).*repmat(Pm(:,ics),1,nx);
        Zsm=Zsm+Za(:,:,ics).*repmat(Sm(:,ics),1,nx);        
    end
    Yfm=Pm*c_j_'+Zfm*C1_j_(:,:,1)'+(C2_*quadc1(Zfm'))';
    Ysm=Sm*c_j_'+Zsm*C1_j_(:,:,1)'+(C2_*quadc1(Zsm'))';    
    Yfa(:,:,im)=Yfm;
    Ysa(:,:,im)=Ysm;   
    clc;
    im/M00
end
%Yfm=mean(Yfa,3);
%Ysm=mean(Ysa,3);
save([io_dir2 filesep 'all_maturities'],'datesv','Yo','Yfa','Ysa');

%% read forward data
opts = spreadsheetImportOptions("NumVariables", 12);
% Specify sheet and range
opts.Sheet = "Sheet1";
opts.DataRange = "A2:L237";
% Specify column names and types
opts.VariableNames = ["obs", "qdatesv", "f01", "f02", "f03", "f04", "f05", "f06", "f07", "f08", "f09", "f10"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];
% Import the data
RATTS2020fwd = readtable([io_dir filesep forwards_filename], opts, 'UseExcel', false);
% Convert to output type
forwardm = table2array(RATTS2020fwd);
fdatesv=forwardm(21:end,2);
forwardm=forwardm(21:end,3:end);
% Clear temporary variables
clear  opts RATTS2020fwd;
% now pair the sample size of forwards with the one of the estimated model 
forwardm=forwardm(find(fdatesv==datesv(1)):find(fdatesv==datesv(end)),:);
%% here compute filtered model-based forwards
ffilt = zeros(size(Yfm,1),size(Yfm,2)-4) ;
for im = 1:39
    ffilt(:,im) = (im+1)*Yfm(:,im+1+3) - im*Yfm(:,im+3) ;
end
save forward_ready_for_graphs datesv forwardm ffilt;
figure(1)
subplot(2,2,1)
plot1=plot(datesv,[forwardm(:,1) 400*ffilt(:,4)]);
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('1 year ahead forward rate','fontsize',20);
%xlabel('order','fontsize',12);
%ylabel('autocorrelation','fontsize',12);
xlim([datesv(1) datesv(end)]);


subplot(2,2,2)
plot1=plot(datesv,[forwardm(:,3) 400*ffilt(:,12)]);
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('3 year ahead forward rate','fontsize',20);
%xlabel('order','fontsize',12);
%ylabel('autocorrelation','fontsize',12);
xlim([datesv(1) datesv(end)]);

subplot(2,2,3)
plot1=plot(datesv,[forwardm(:,10) 400*ffilt(:,40)]);

set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('10 year head forward rate','fontsize',20);
legend({'Actual','Model based'},'Location','Best','FontSize',8);

figure_filename='forward_rates';
orient(1,'landscape');
saveas(1,figure_filename,'fig');
saveas(1,figure_filename,'png');
%export_fig(figure_filename,'-zbuffer','-r600')

saveas(1,figure_filename,'bmp');
print(1,'-dpsc2',figure_filename);
print(1,'-dpdf',figure_filename);

close(1);
system(['mv forward_rates*.* ' io_dir2 ';']);
retcode=1;
