function retcode = DSGE_MS_model_run_2021(model_name0,io_dir)
% function to run DSGE MS model
% differs from DSGE_MS_model_run for allowing datesv vector to be first
% column of data 
eval(['[model_name,x_str,y_str,s_str,np] = ' model_name0 '_define();']);
n1=length(x_str);
n2=length(y_str);
nss=length(s_str);
settings_filename=[io_dir filesep model_name '_estimation_settings.xlsx' ];
[settings,string_range]=xlsread(settings_filename,'a2:a4');
infilename=string_range(1);
string_range=string_range(2);
nyd=settings(1);
low_cell=4+nyd+6;
settings=xlsread(settings_filename,['a5:a' int2str(low_cell)]);
index_variables=settings(1:nyd);
ind_simdata=settings(nyd+1);
T_pre=settings(nyd+2);
Tini=settings(nyd+3);
seed0=settings(nyd+4);
order=settings(nyd+5);
nn3=settings(nyd+6);
n3=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+nn3)])';
low_cell=low_cell+nn3;
nlb=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+1)]);
n4=xlsread(settings_filename,['a' int2str(low_cell+2) ':a' int2str(low_cell+1+nlb)])';
low_cell=low_cell+1+nlb;
nyo=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+1)]);
subset_y=xlsread(settings_filename,['a' int2str(low_cell+2) ':a' int2str(low_cell+1+nyo)]);
low_cell=low_cell+1+nyo+1;
ind_label_constraints=xlsread(settings_filename,['a' int2str(low_cell) ':a' int2str(low_cell)]);
[settings,Vwritefilename]=xlsread(settings_filename,'i2:i12');
Vreadfilename=[io_dir filesep Vwritefilename{1}];
Vwritefilename=[io_dir filesep Vwritefilename{2}];
cV=settings(1);
Vreadndx=settings(2);
Vwritendx=settings(3);
M=settings(4);
burnInProp=settings(5);
nskip=settings(6);
ind_prior_predictive=settings(7); % this should be taken out input file
index_combine_output=settings(8);
clev=settings(9);
settings=xlsread(settings_filename,'i15:i32');
ind_ekf=settings(1);
index_max_SA=settings(2);
index_retrieve_starting_value=settings(3);
index_retrieve_max=settings(4);
index_Hessian_computation=settings(5);
rt=settings(6);
eps=settings(7);
ns=settings(8);
nt=settings(9);
neps=settings(10);
maxevl=settings(11);
iprint=settings(12);
t=settings(13);
c=settings(14);
vm=settings(15);
itermaxSA=settings(16);
tolSA=settings(17);
orderSA=settings(18);
solution_routine_name=[model_name '_modsol_Klein_'];
combine_output_filename=[io_dir filesep model_name '_combine'];
prior_specification_filename=[io_dir filesep model_name '_parameters_description'];
outfilename=[io_dir filesep model_name '_results'];
label_constraints=2*nss+reshape((1:2*nss)',2,nss);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
prior_specification_range=['b2:h' int2str(np+1)];
%% from this point onwards nothing should be changed
% to establish some coherence among mode computation
if index_combine_output
    % if index_combine_output is non zero then all other indexes linked to
    % max should be zero
    index_max_SA=0;
    index_retrieve_starting_value=0;
    index_retrieve_max=0;
    index_Hessian_computation=0;
else
    % if no previous output is to be combined
        if index_retrieve_max % if previous max is to be retrieved
            index_retrieve_starting_value=0;
            index_max_SA=0;
        end
end
%
quantv=[1-clev; 1+clev]/2;
outfilesheet=1;
[prior_data, prior_headertext] = xlsread(prior_specification_filename,prior_specification_range);
%
deltatrue=prior_data(:,1);
simparndx=prior_data(:,2);
prior_type_ndxv=prior_data(:,3);
Rm=prior_data(:,4:5);
parameter_name=prior_headertext(:,1);
parameter_explanation=prior_headertext(:,2);
format short
for ip=1:np
    eval([char(parameter_name(ip)) '=' num2str(deltatrue(ip)) ';']);
end
% initialise random seed
% corrected 10.22.2020
rng(seed0);
testm_str=cellstr(strvcat('post mean','post sd','post low q','post up q','prior mean','prior sd','prior low q','prior up q','calibrated'));
auxiliary_str=cellstr(strvcat('order','M','mov ratio','Vreadndx','cV','nskip','combined'));                        
%put all the parameters in the delta0 vector
delta0=deltatrue;
%%
T0=T_pre-Tini;
sim1ndx=find(simparndx>0);
nsimpar=sum(simparndx>0);
nby=length(n4);
nyo=size(n3,2)+nby;
%load dataset;
alldata=xlsread([io_dir filesep infilename{1}],1,string_range{1});
scalar_factor=xlsread(settings_filename,1,'e2');
Yo=alldata(1:end,index_variables)/scalar_factor;
%datesv=alldata(T0+1:end,4);
datesv=alldata(T0+1:end,1); % this is the innovation in the code
Yo=Yo(T0+1:end,:);
[T nyo]=size(Yo);
% ascertain whether there are missing values
ndx_mv=sum(sum(isnan(Yo))); % if nto zero there are missing values
% initial evaluation of the solution
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
nx=size(etastd,1); % number of state variables
nx3=log(size(eta,3))/log(2); % number of discrete state variables
nx2=size(etastd,2)-nx3; % number of Gaussian shocks
nx1=nx-nx2-nx3; % number of predetermined state variables
if ind_simdata
    i_KKSS=1;
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    [zm,csiv,Yo(:,subset_y),Sm]=DSGE_MS_simulate_data(T,1000,i_KKSS,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,emv);
    xm=[zm Sm];
end
% if index_combine_output==0
%     if ind_prior_predictive
%         [Cova,Cora,Covaa,Coraa,means,meanm,truncation_prop]=RATTS_prior_predictive(Npp,simparndx,bounds_gss,prior_type_ndxv,deltatrue,Rm,order,n1,n2,n3,n4,Yo(:,subset_y),Tm,var_str,nh,clev,ind_graph,i_KKSS);
%     end
% end
%%
% compute normalising constant for prior, once and for all
lnprior_const=DSGE_prior_lnconst1(Rm,prior_type_ndxv);
% extract from prior in order to initialise the MH algorithm
retcode1=0;
iprior=0;
while retcode1==0
    delta0=zeros(np,1);
    for iprior=1:100
        delta0=delta0+DSGE_priordraw(Rm,prior_type_ndxv)/100;
    end
    delta00=delta0(sim1ndx);
    delta0=DSGE_parameter_vector(delta00,simparndx,deltatrue);
    
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
    % label identification constraint
    if ind_label_constraints
        cond_label=zeros(nx3,1);
        for im=1:nx3
            cond_label(im)=(delta0(label_constraints(1,im))<=delta0(label_constraints(2,im)));
        end
        cond_label=sum(cond_label)==nx3;
    end
    retcode1=cond_label*retcode;
    clc;
    iprior=iprior+1;
end
[omega0,lnjac0,lnprior0]=DSGE_repar1(delta0,Rm,0,prior_type_ndxv);
omega00=omega0(sim1ndx);
lnprior0=lnprior0+lnjac0+lnprior_const;
lnprior0=sum(lnprior0(sim1ndx));
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
% if ndx_mv
%     [retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf);
% else
%     [retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf);
% end
[retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf);
lnl0=sum(lnlv(Tini+1:end));
%% this section is to perform combination with previous output
if index_combine_output
    load(combine_output_filename);
    % from this file we load param0,reparam0,delta0,omega0,omega00,H
    index_max_SA=0;
    delta0=param(end,1:np)';
    omega0=reparam(end,1:np)';
    lnl0=param(end,np+3);
    lnprior0=param(end,np+2);
    param0=param;
    reparam0=reparam;
    priorparam0=priorparam; % added 12.22.2020 
    M0=size(param0,1);
end
%% obtain the maximisation output from previous chain
[omegatrue,lnjac00,lnprior00]=DSGE_repar1(deltatrue,Rm,0,prior_type_ndxv);
% check if a file with previous mode exists
if isempty(dir([io_dir filesep 'maximisation_output.mat'])) & isempty(dir([io_dir filesep 'maximisation_output.xlsx']))
 index_retrieve_max=0;
end
if index_retrieve_max
    index_max_SA=0;
    %[prior_data, prior_headertext] = xlsread(prior_specification_filename,prior_specification_range);
    %
    if ~isempty(dir([io_dir filesep 'maximisation_output.xlsx']))
        omega00=xlsread([io_dir filesep 'maximisation_output.xlsx']);
    else
        load([io_dir filesep 'maximisation_output.mat']);
    end
    np0=sum(simparndx==1);
    H=omega00(1:np0,1+(1:np0));
    omega00=omega00(:,1);
    omega0=DSGE_parameter_vector(omega00,simparndx,omegatrue);
    [delta0,lnjac0,lnprior0]=DSGE_repar1(omega0,Rm,1,prior_type_ndxv);
    lnprior0=lnprior0-lnjac0+lnprior_const;
    lnprior0=sum(lnprior0(sim1ndx));
else
    index_Hessian_computation=1;
end
%% SA maximisation (actually minimises minus log post)
np0=sum(simparndx==1);
[omegatrue,lnjac00,lnprior00]=DSGE_repar1(deltatrue,Rm,0,prior_type_ndxv);
if index_combine_output==0
    if index_max_SA
        % same as for retrieving modal value
        if isempty(dir([io_dir filesep 'maximisation_output.mat'])) & isempty(dir('maximisation_output.xlsx'))
            index_retrieve_starting_value=0;
        end
        if index_retrieve_starting_value
            if ~isempty(dir([io_dir filesep 'maximisation_output.xlsx']))
                omega00=xlsread([io_dir filesep 'maximisation_output.xlsx']);
            else
                load([io_dir filesep 'maximisation_output.mat']);
            end
           omega00=omega00(1:np0,1);
        else
            omega00=omega0(sim1ndx);
        end
        option=[0 rt eps ns nt neps maxevl iprint t];
        c  = c*ones(np0,1);
        vm = vm*ones(np0,1);
        lb=-50*ones(np0,1); % check this 2014 08 14
        ub= 50*ones(np0,1); 
        %
%         if ndx_mv
%         [omega00, fopt, nacc, nfcnev, nobds, ier, t, vm]=simulan1('DSGE_MS_Kim_Filter_one_output_mv',omega00,option,lb,ub,c,vm,...
%             omegatrue,solution_routine_name,orderSA,n1,n2,n3,n4,...
%             Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
%         else
%         [omega00, fopt, nacc, nfcnev, nobds, ier, t, vm]=simulan1('DSGE_MS_Kim_Filter_one_output',omega00,option,lb,ub,c,vm,...
%             omegatrue,solution_routine_name,orderSA,n1,n2,n3,n4,...
%             Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
%         end
        [omega00, fopt, nacc, nfcnev, nobds, ier, t, vm]=simulan1('DSGE_MS_Kim_Filter_one_output_mv',omega00,option,lb,ub,c,vm,...
            omegatrue,solution_routine_name,orderSA,n1,n2,n3,n4,...
            Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
end
%
omega0=DSGE_parameter_vector(omega00,simparndx,omegatrue);
[delta0,lnjac0,lnprior0]=DSGE_repar1(omega0,Rm,1,prior_type_ndxv);
lnprior0=lnprior0-lnjac0+lnprior_const;
lnprior0=sum(lnprior0(sim1ndx));
%evaluation of Hessian
if index_Hessian_computation
    epsg=1e-4;
    [notPDHessian_index,H] = DSGE_MS_postpdf_invHessian(solution_routine_name,n1,n2,n3,n4,order,omega0,omegatrue,1e-4,Yo,subset_y,Tini,ind_ekf,simparndx,Rm,prior_type_ndxv);
else
    H=eye(np0);
end
% next block is to run csminwel using the output of simulated
% annealing as initial value
if index_max_SA==0
    if index_retrieve_starting_value
        if ~isempty(dir([io_dir filesep 'maximisation_output.xlsx']))
            omega00=xlsread([io_dir filesep 'maximisation_output.xlsx']);
        else
            load([io_dir filesep 'maximisation_output.mat']);
        end
        omega00=omega00(1:np0,1);
    end
end
%
if index_retrieve_max==0
%     if ndx_mv
%         [fh,omega00,gh,H_,itct,fcount,retcodeh] = csminwel('DSGE_MS_Kim_Filter_one_output_4csminwel_mv',omega00,H,[],1e-8,1e+4,...
%             omegatrue,solution_routine_name,order,n1,n2,n3,n4,Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
%         
%     else
%         [fh,omega00,gh,H_,itct,fcount,retcodeh] = csminwel('DSGE_MS_Kim_Filter_one_output_4csminwel',omega00,H,[],1e-8,1e+4,...
%             omegatrue,solution_routine_name,order,n1,n2,n3,n4,Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
%     end
[fh,omega00,gh,H_,itct,fcount,retcodeh] = csminwel('DSGE_MS_Kim_Filter_one_output_4csminwel_mv',omega00,H,[],1e-8,1e+4,...
    omegatrue,solution_routine_name,order,n1,n2,n3,n4,Rm,prior_type_ndxv,simparndx,Yo(:,subset_y),Tini,ind_ekf);
end
%clc;
omega0=DSGE_parameter_vector(omega00,simparndx,omegatrue);
[delta0,lnjac0,lnprior0]=DSGE_repar1(omega0,Rm,1,prior_type_ndxv);
% 2014 09 27: insert this to impose labelling constraints on output
% of maximisation
% check the objects defined here
np=numel(omega0);
H_=zeros(np,np);
H_(sim1ndx,sim1ndx)=H;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
if ind_label_constraints
    ind_perm=ones(3,1);
    for iim=1:nss % bug uncovered and fixed 2013/10/07
        ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
    end
    delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    H_=H_(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))),squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    H_=H_(sim1ndx,sim1ndx);
end
%
lnprior0=lnprior0-lnjac0+lnprior_const;
lnprior0=sum(lnprior0(sim1ndx));
% if H_ computed by csminwel is PD, we use that
H_=(H_+H_')/2;
if min(eig(H_))
    H=H_;
end
%     omega0=DSGE_parameter_vector(omega00,simparndx,omegatrue);
%     [delta0,lnjac0,lnprior0]=DSGE_repar1(omega0,Rm,1,prior_type_ndxv);
if ispc
    xlswrite('maximisation_output.xlsx',[omega00 H]);
    xlswrite('maximisation_output.xlsx',parameter_name,2,'a1');
    xlswrite('maximisation_output.xlsx',delta0,2,'b1');
    xlswrite('maximisation_output.xlsx',fh,2,'c1');
else
    omega00_=omega00;
    omega00=[omega00 H];
    save([io_dir filesep 'maximisation_output'],'omega00','parameter_name','delta0','fh');
    omega00=omega00_;
end
end
%% MCMC algorithm implementation
[aaa,bbb]=chol(H);
% 2014 09 24 : modified to eliminate issues on non PD H
if bbb<np0
    scalarf=0;
    ipd=0;
    while ipd==0
        scalarf=scalarf+1;
        Hmodified=H+scalarf*eye(np0)*sqrt(rcond(H));
        ipd=min(eig(Hmodified))>0;
    end
    P0=cV*chol(Hmodified)';
else
    P0=cV*chol(H)';
end
M1=floor((1+burnInProp)*M);
initial=round(burnInProp*M)+1;
nskip1=nskip+1;
M2=M1*nskip1;
param=zeros(M1,np+5);
reparam=zeros(M1,np);
priorparam=zeros(M1,np);
movingratio=0;
invcondviol=0;
singularKF=0;
deltasingularKF=zeros(np,1);
deltaviolate=zeros(np,1);
epsi=zeros(np,1);

if isempty(dir([Vreadfilename '.mat'])) && isempty(dir([Vreadfilename '.mat']))
    Vreadndx=0;
end
if Vreadndx~=0
    if ~isempty(dir([Vreadfilename '.xlsx']))
        V0=xlsread(Vreadfilename);
    else
        load(Vreadfilename)
    end
    P0=chol(V0)';
end
iskip=1;
timer=clock;
acceptProb=0;
for im=1:M2
    % now draw theta via MH step
    omega0_=omega0(sim1ndx);
    %draw from candidate
    e1=randn(nsimpar,1);
    epsi1=cV*P0*e1;
    omega1_=omega0_+epsi1;
    omega1=DSGE_parameter_vector(omega1_,simparndx,omegatrue);
    %map onto model parameters using repar
    [delta1,lnjac1,lnprior1]=DSGE_repar1(omega1,Rm,1,prior_type_ndxv);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta1,n1,n2,n3,n4);']);
    if retcode==0
        invcondviol=invcondviol+1;
        lnprior1=lnprior0;
        lnl1=lnl0;
        u=0;
    else
        lnprior1=lnprior1-lnjac1+lnprior_const;
        lnprior1=sum(lnprior1(sim1ndx));
        % re-evaluate the likelihood
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta1);
        %         if ndx_mv
        %             [retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,ind_ekf);
        %         else
        %             [retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,ind_ekf);
        %         end
        [retcode,lnlv,Za,Qa,Pm] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,ind_ekf);
        lnl1=sum(lnlv(Tini+1:end));
        acceptProb=retcode*exp(lnprior1+lnl1-lnprior0-lnl0);
        u=rand(1,1)<acceptProb;
    end
    movingratio=movingratio+u;
    delta0=u*delta1+(1-u)*delta0;
    omega0=u*omega1+(1-u)*omega0;
    lnprior0=u*lnprior1+(1-u)*lnprior0;
    lnl0=u*lnl1+(1-u)*lnl0;
    if iskip==nskip1
        clc;
        iskip=1;
        %record
        [deltaprior]=DSGE_priordraw(Rm,prior_type_ndxv);
        deltaprior=simparndx.*deltaprior+(1-simparndx).*deltatrue;
        deltareport=[ deltaprior delta0];
        if ind_label_constraints
            for ik=1:2
                ind_perm=ones(3,1);
                for iim=1:nss % bug corrected 2013/10/07
                    ind_perm(iim)=2-(deltareport(label_constraints(1,iim),ik)<deltareport(label_constraints(2,iim),ik));
                end
                deltareport(:,ik)=deltareport(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))),ik);
            end
        end
        priorparam(im/nskip1,:)=deltareport(:,1)';
        param(im/nskip1,:)=[deltareport(:,2)' acceptProb lnprior0 lnl0 lnprior1 lnl1 ];
        reparam(im/nskip1,:)=omega0';
        [im/M2 movingratio/im invcondviol/M2 singularKF/M2]
    else
        iskip=iskip+1;
    end
end
timer=etime(clock,timer);
deltaviolate=deltaviolate(:,2:end);
deltasingularKF=deltasingularKF(:,2:end);
movingratio=movingratio/M2;
invcondviol=invcondviol/M2;
singularKF=singularKF/M2;
'cputime per iteration'
if M>0
    timer/M2
    movingratio
    invcondviol
    singularKF
end
%% post processing: I: trimming to allow for burn-in
if M > 0
    fig_str=parameter_name;
    param=param(initial:end,:);
    priorparam=priorparam(initial:end,:);
    reparam=reparam(initial:end,:);
    if index_combine_output
        param=[param0;param];
        reparam=[reparam0;reparam];
        priorparam=[priorparam0;priorparam];
        clear param0 reparam0 priorparam0;
        M=size(param,1);
    end
    V1=cov(reparam(:,sim1ndx));
    rows_graph=7;
    cols_graph=6;
    figure(1);
    for ip=1:np
        subplot(rows_graph,cols_graph,ip);
        plot(param(:,ip));
        title(fig_str(ip));
    end
    figure(2);
    for ip=1:np
        subplot(rows_graph,cols_graph,ip);
        plot(reparam(:,ip));
        title(fig_str(ip));
    end
    figure(3);
    for ip=1:np
        subplot(rows_graph,cols_graph,ip);
        hist([param(:,ip) priorparam(:,ip)],M/50);
        title(fig_str(ip));
    end
    figure(4);
    for ip=1:np
        subplot(rows_graph,cols_graph,ip);
        hist(reparam(:,ip),M/50);
        title(fig_str(ip));
    end
    if Vreadndx
        figure(5);
        plot([diag(V0) diag(V1)]);
    end
    %sorting prior and posterior matrices to obtain the quantiles
    priorparams=sort(priorparam);
    params=sort(param(:,1:np));
    priorquantiles=priorparams(round(quantv*M),:)';
    postquantiles=params(round(quantv*M),:)';
    testm=[mean(param(:,1:np))' sqrt(var(param(:,1:np)))' postquantiles ...
        mean(priorparam)' sqrt(var(priorparam))' priorquantiles deltatrue];
    if ispc
        xlswrite([outfilename '.xlsx'],cellstr(strvcat(datestr(now))),outfilesheet,'a1');
        xlswrite([outfilename '.xlsx'],auxiliary_str,outfilesheet,'l1');
        xlswrite([outfilename '.xlsx'],[order M movingratio Vreadndx cV nskip (index_combine_output~=0)]',outfilesheet,'m1');
        xlswrite([outfilename '.xlsx'],(1:np)',outfilesheet,'a2');
        xlswrite([outfilename '.xlsx'],fig_str,outfilesheet,'b2');
        xlswrite([outfilename '.xlsx'],testm_str',outfilesheet,'c1');
        xlswrite([outfilename '.xlsx'],testm,outfilesheet,'c2');
    else
        logofftime=cellstr(strvcat(datestr(now)));
        one2np=(1:np)';
        auxiliary_output=[order M movingratio Vreadndx cV nskip (index_combine_output~=0)]';
        save(outfilename,'logofftime','auxiliary_str','auxiliary_output','one2np','fig_str','testm_str','testm');
    end
    if Vwritendx~=0
        if ispc
            xlswrite([Vwritefilename '.xlsx'],V1);
        else
            %             if exist('V0')==1
            %                 V0_=V0;
            %             else
            %                 V0_=V1;
            %             end
            %             V0=V1;
            %             save(Vwritefilename,'V0');
            %             V0=V0_;
            %             clear V0_;
            save(Vwritefilename,'V1');
        end
    end
end
%% 2014 09 24, changed to include mechanism to prevent crashes when saving
% probs with Matlab 12 in Citrix
isave=0;
while isave==0
    try
        eval(['save ' outfilename ';']);
        save(combine_output_filename,'priorparam','param','reparam','delta1','H','omega00');
        isave=1;
    catch savefilefailed
        clc;
        'saving file failed'
    end
end
