function retcode = DSGE_MS_post_processing_2021(model_name,io_dir) 
% Programme to do postprocessing
% differs from previous version in allowing datesv to be first column of
% data set
outfilename=[io_dir filesep model_name '_results'];
settings_filename=[io_dir filesep model_name '_estimation_settings.xlsx' ];
eval(['[model_name,x_str,y_str,s_str,np] = ' model_name '_define();']);
eval(['load ' outfilename '.mat']);
scalar_factor=xlsread(settings_filename,1,'e2');
settings=xlsread(settings_filename,'i35:i38');
N_prior_pred=settings(1);
Nh=settings(2);
nthin=settings(3);
index_only_max=settings(4);
cum_index=xlsread(settings_filename,['g35:g' int2str(34+nyo)]);
%%
nss=length(s_str);
ncs=2^nss;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
nz=n1;
nspread=numel(n4);
Trm=zeros(nspread,nyo);
Trm(:,nyd-nspread)=-1;
Trm(:,nyd-nspread+1:end)=eye(nspread);
Trm_=[eye(nyo); Trm]; % this is matrix to transform Y into Ys (nyo+nspread) x 1
nyo_=nyo+nspread;
% data moments, presample and all sample
Yo__=alldata(:,index_variables)/scalar_factor;
%datesv__=alldata(:,4);
datesv__=alldata(:,1); %novelty in the code
Yo_ps=Yo__(1:T0,:);
mean_y_ps=mean(Yo_ps*Trm_');
std_y_ps=sqrt(var(Yo_ps*Trm_'));
%
mean_y=mean(Yo*Trm_');
std_y=sqrt(var(Yo*Trm_'));
Cova=mk_sdca(Yo*Trm_',Nh);
diagsigma=diag(1./sqrt(diag(Cova(:,:,1))));
Cora=Cova;
for ih=1:Nh+1
    Cora(:,:,ih)=diagsigma*Cova(:,:,ih)*diagsigma;
end
%% prior predictive analysis
if N_prior_pred
    mu_z=zeros(nz,N_prior_pred);
    mu_y=zeros(nyo_,N_prior_pred);
    Sigma_z=zeros(nz,nz,Nh+1,N_prior_pred);
    Sigma_y=zeros(nyo_,nyo_,Nh+1,N_prior_pred);
    sig_y=zeros(nyo_,N_prior_pred); % to collect just std dev 
    Rho_z=zeros(nz,nz,Nh+1,N_prior_pred);
    Rho_y=zeros(nyo_,nyo_,Nh+1,N_prior_pred);
    h = waitbar(0,'Prior Predictive');
    ipp1=0;    
    for ipp=1:N_prior_pred
        retcode=0;
        while retcode==0
            ipp1=ipp1+1;
            delta0=DSGE_priordraw(Rm,prior_type_ndxv);
            delta0=delta0(sim1ndx);
            delta0=DSGE_parameter_vector(delta0,simparndx,deltatrue);
            if ind_label_constraints
                ind_perm=ones(3,1);
                for iim=1:nss % bug uncovered and fixed 2013/10/07
                    ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
                end
                delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
            end
            eval(['[retcode_,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
            retcode=retcode_*isreal(y_)*isreal(gx)*isreal(hx)*isreal(gxx)*isreal(hxx)*isreal(gss)*isreal(hss)*isreal(eta)*isreal(etastd);
        end
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
        [mu_z(:,ipp),mu_y(:,ipp),Sigma_z(:,:,:,ipp),Sigma_y(:,:,:,ipp),Rho_z(:,:,:,ipp),Rho_y(:,:,:,ipp)] = DSGE_MS_moments(Trm_*y_,a_i,A1_i(:,:,1),A2,B_i,Trm_*c_j,Trm_*C1_j(:,:,1),Trm_*C2,Trm_*D,pv,Nh);
        sig_y(:,ipp)=sqrt(diag(Sigma_y(:,:,1,ipp)));
        waitbar(ipp/N_prior_pred,h,['prior pred % completed: ' sprintf('%2.2f',100*ipp/N_prior_pred)]);
    end
    delete(h);
    % compute empirical quantiles
    % store them in array empirical_pval_prior(i,j)
    % i=variable, j = sample mean, sample std, presample, presample std 
    empirical_pval_prior=zeros(nyo_,4);
    empirical_pval_prior(:,1)=empirical_cum_dens(mu_y',mean_y',0);
    empirical_pval_prior(:,3)=empirical_cum_dens(mu_y',mean_y_ps',0);
    empirical_pval_prior(:,2)=empirical_cum_dens(sig_y',std_y',0);
    empirical_pval_prior(:,4)=empirical_cum_dens(sig_y',std_y_ps',0);
    empirical_pval_prior=100*empirical_pval_prior;
end
%
%%
str_var=[];
for iy=1:length(n3);
    str_var{iy}=y_str{n3(iy)};
end
for iy=1:length(n4);
    str_var{length(n3)+iy}=['R' int2str(n4(iy))];
end
for iy=1:nspread;
    str_var{nyo+iy}=['R' int2str(n4(iy)) ' - ' str_var{nyo-nspread}];
end
%
ndxm=npermutek([1;0],nss);
ndx_mg_states=zeros(ncs/2,nss);
for is=1:nss
    ndx_mg_states(:,is)=find(ndxm(:,is)==1);
end
qv=[(1-clev)/2; .5;(1+clev)/2]; 
%%
M0=M/nthin;
ncs=size(B_i,3);
ns_=log(ncs)/log(2);
y10a=zeros(T,nyo_,M0);
y10a_lev=zeros(T,nyo_,M0);
Zfa=zeros(T,nx,M0);
Zsa=zeros(T,nx,M0);
Pa_mg=zeros(T,ns_,M0);
Sa_mg=zeros(T,ns_,M0);
filpremia=zeros(T,length(n4),M0);
smopremia=zeros(T,length(n4),M0);
%
mu_z_=zeros(nz,M0,4);
mu_y_=zeros(nyo_,M0,4);
Sigma_z_=zeros(nz,nz,Nh+1,M0,4);
Sigma_y_=zeros(nyo_,nyo_,Nh+1,M0,4);
sig_y_=zeros(nyo_,M0,4);
Rho_z_=zeros(nz,nz,Nh+1,M0,4);
Rho_y_=zeros(nyo_,nyo_,Nh+1,M0,4);
h = waitbar(0,'Post processing');
retcode0=0;
cum_index1=find(cum_index==1);
Yo_lev=Yo*Trm_';
Yo_lev(:,cum_index1)=cumsum(Yo(:,cum_index1));
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
etaa=zeros(T,nz2,M0);
for im=1:M0
    delta0=param((im-1)*nthin+1,1:np)';
        if ind_label_constraints
        ind_perm=ones(3,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    %eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    % bug found 2019/12/05
    %[retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
     [retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
    DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    retcode0=retcode0+(retcode==0);
    Zm=array2mat(Za,sv);   
    % block 1 of post proc: compute theoretical moments based on p(theta|Y)    
    [mu_z_(:,im,1),mu_y_(:,im,1),Sigma_z_(:,:,:,im,1),Sigma_y_(:,:,:,im,1),Rho_z_(:,:,:,im,1),Rho_y_(:,:,:,im,1)] = DSGE_MS_moments(Trm_*y_,a_i,A1_i(:,:,1),A2,B_i,Trm_*c_j,Trm_*C1_j(:,:,1),Trm_*C2,Trm_*D,pv,Nh);
    sig_y_(:,im,1)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,1))));
    % block 2 of post proc: compute sample moments from data drawn from 
    %  p(Y_|theta, Z), p(Z|theta), p(theta|Y)
    s0=draw_multinom(pv,1,ncs,1);
    z0=mu_z_(:,im,1)+chol(squeeze(Sigma_z_(:,:,1,im,1)))'*randn(nz,1);
    Y_=zeros(T,nyo_);
    for it=1:T
        s1=draw_multinom(ctp(s0,:)',1,ncs,1);
        z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*vech_(z0*z0')+B_i(:,:,s0)*randn(size(B_i,2),1);
        y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y1'*Trm_';
        z0=z1;
        s0=s1;
    end
    mu_y_(:,im,2)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,2)=Cova__;
    sig_y_(:,im,2)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,2))));    
    Rho_y_(:,:,:,im,2)=Cora__;
    % block 3 of post proc: compute as before but initial state drawn from
    %  p(z_1|thetaY)   
    s0=sv(1);
    z0=Za(1,:,s0)';
    Y_=zeros(T,nyo_);
    y0=c_j(:,s0)+C1_j(:,:,s0)*z0+C2*vech_(z0*z0')+D*randn(size(D,2),1);
    Y_(1,:)=y0'*Trm_';
    for it=2:T
        s1=draw_multinom(ctp(s0,:)',1,ncs,1);
        z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*vech_(z0*z0')+B_i(:,:,s0)*randn(size(B_i,2),1);
        y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y0'*Trm_';
        z0=z1;
        s0=s1;
    end
    mu_y_(:,im,3)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,3)=Cova__;
    sig_y_(:,im,3)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,2))));    
    Rho_y_(:,:,:,im,3)=Cora__;
    % block 4 of post processing: simulate data from p(theta,Z|Y)
    Y_=zeros(T,nyo_);    
    for it=1:T
        z1=Zm(it,:)';
        y1=c_j(:,sv(it))+C1_j(:,:,sv(it))*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y1'*Trm_';
    end    
    mu_y_(:,im,4)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,4)=Cova__;
    sig_y_(:,im,4)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,4))));    
    Rho_y_(:,:,:,im,4)=Cora__;
    % this is to compute posterior distribution of smoothed shocks
    for it=2:T
        z1=Zm(it,:)';
        z0=Zm(it-1,:)';
        s0=sv(it-1);
        eta1=z1-a_i(:,s0)-A1_i(:,:,s0)*z0-A2*vech(z0*z0');
        eta1=B_i(nz1+1:end,:,s0)\eta1(nz1+1:end);
        etaa(it,:,im)=eta1';
    end       
    %
    premia=premia(n4,:);
    Pm_mg=zeros(T,ns_);
    Sm_mg=zeros(T,ns_);
    for is=1:ns_
        Pm_mg(:,is)=sum(Pm(:,ndx_mg_states(:,is)),2);
        Sm_mg(:,is)=sum(Sm(:,ndx_mg_states(:,is)),2);
    end    
    Zfm=zeros(T,nx);
    Zsm=zeros(T,nx);
    for ics=1:ncs
        Zfm=Zfm+Za(:,:,ics).*repmat(Pm(:,ics),1,nx);
        Zsm=Zsm+Za(:,:,ics).*repmat(Sm(:,ics),1,nx);        
    end
    filtered_premia=Pm*premia';
    smoothed_premia=Sm*premia';
    y10m_lev=y10m*Trm_';
    y10m_lev(:,cum_index1)=Yo_lev(:,cum_index1);
    for it=2:T
        y10m_lev(it,cum_index1)=y10m(it,cum_index1)+Yo_lev(it-1,cum_index1);
    end       
    %
    y10a(:,:,im)=y10m*Trm_';
    y10a_lev(:,:,im)=y10m_lev;
    Zfa(:,:,im)=Zfm;
    Zsa(:,:,im)=Zsm;
    Pa_mg(:,:,im)=Pm_mg;
    Sa_mg(:,:,im)=Sm_mg;
    filpremia(:,:,im)=filtered_premia;
    smopremia(:,:,im)=smoothed_premia;   
    waitbar(im/M0,h,['Post processing % completed: ' sprintf('%2.2f',100*im/M0)]);
end
delete(h);
y10a=mean_std_quantiles(y10a,qv);
y10a_lev=mean_std_quantiles(y10a_lev,qv);
Zfa=mean_std_quantiles(Zfa,qv);
Zsa=mean_std_quantiles(Zsa,qv);
Pa_mg=mean_std_quantiles(Pa_mg,qv);
Sa_mg=mean_std_quantiles(Sa_mg,qv);
filpremia=mean_std_quantiles(filpremia,qv);
smopremia=mean_std_quantiles(smopremia,qv);
%
empirical_pval_post=zeros(nyo_,4,4);
for ik=1:4
    empirical_pval_post(:,1,ik)=empirical_cum_dens(squeeze(mu_y_(:,:,ik))',mean_y',0);
    empirical_pval_post(:,3,ik)=empirical_cum_dens(squeeze(mu_y_(:,:,ik))',mean_y_ps',0);
    empirical_pval_post(:,2,ik)=empirical_cum_dens(squeeze(sig_y_(:,:,ik))',std_y',0);
    empirical_pval_post(:,4,ik)=empirical_cum_dens(squeeze(sig_y_(:,:,ik))',std_y_ps',0);

end
empirical_pval_post=100*empirical_pval_post;
%% 2014 09 24, changed to include mechanism to prevent crashes when saving
% probs with Matlab 12 in Citrix
isave=0;
while isave==0
    try
        eval(['save ' outfilename '_postproc.mat']);
        isave=1;
    catch savefilefailed
        clc;
        'saving file failed'
    end
end
%
%% Section 0 : prepare global limits for graphs
% general settings
% limits for graphs for prior and post pred analysis
max_mu_y_all=scalar_factor*max([max(mu_y,[],2) max(max(mu_y_,[],3),[],2) mean_y' mean_y_ps'],[],2);
min_mu_y_all=scalar_factor*min([min(mu_y,[],2) min(min(mu_y_,[],3),[],2) mean_y' mean_y_ps'],[],2);
max_sig_y_all=scalar_factor*max([max(sig_y,[],2) max(max(sig_y_,[],3),[],2) std_y' std_y_ps'],[],2);
min_sig_y_all=scalar_factor*min([min(sig_y,[],2) min(min(sig_y_,[],3),[],2) std_y' std_y_ps'],[],2);
% limits for posterior pred analysis
max_mu_y_post=scalar_factor*max([max(max(mu_y_,[],3),[],2) mean_y' mean_y_ps'],[],2);
min_mu_y_post=scalar_factor*min([min(min(mu_y_,[],3),[],2) mean_y' mean_y_ps'],[],2);
max_sig_y_post=scalar_factor*max([max(max(sig_y_,[],3),[],2) std_y' std_y_ps'],[],2);
min_sig_y_post=scalar_factor*min([min(min(sig_y_,[],3),[],2) std_y' std_y_ps'],[],2);
%% Section 1: prepare graphs prior processing
% figures with scatterplots for means and std devs for each variables
nfig=1;
figure(nfig);
for in=1:nyo_
    subplot(nyo_/2,2,in)
    scatm1=scalar_factor*[mu_y(in,:)' sig_y(in,:)'];
    scatm2=scalar_factor*[mean_y(in)*ones(N_prior_pred,1) std_y(in)*ones(N_prior_pred,1)];
    scatm3=scalar_factor*[mean_y_ps(in)*ones(N_prior_pred,1) std_y_ps(in)*ones(N_prior_pred,1)];
    scatter(scatm1(:,1),scatm1(:,2),'Marker','.');
    hold on;
    scatter(scatm2(:,1),scatm2(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','diamond');
    hold on;
    scatter(scatm3(:,1),scatm3(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','x');    
    hold off    
    xlabel('mean','fontsize',12);
    ylabel('std','fontsize',12);
    title(str_var(in),'fontsize',14,'color','red');
    xlim([min_mu_y_all(in) max_mu_y_all(in)]);
    ylim([min_sig_y_all(in) max_sig_y_all(in)]);
end
filename0=[io_dir filesep 'prior_pred' int2str(nfig)];
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
%
% graphs for dynamic correlations
nfig=nfig+1;
figure(nfig);
for iny=1:nyo_
    for jny=1:nyo_        
        true_corv=squeeze(Cora(iny,jny,:));
        subplot(nyo_,nyo_,(iny-1)*nyo_+jny);
        rho_mat=real(squeeze(Rho_y(iny,jny,:,:)))';
        rho_mat=sort(rho_mat);
        rho_mat=rho_mat(round(qv*N_prior_pred),:)';
        plot1=plot((0:Nh)',[rho_mat true_corv]);
        set(plot1(1),'Color','r','LineWidth',2);
        set(plot1(2),'Color','r','LineWidth',2);
        set(plot1(3),'Color','r','LineWidth',2);
        set(plot1(4),'Color','b','LineWidth',4);
        title([str_var{jny}],'fontsize',12);
        %xlabel('horizon','fontsize',12);        
        ylabel(str_var{iny},'fontsize',12); 
        xlim([0 Nh]);
    end
end
filename0=[io_dir filesep 'prior_pred' int2str(nfig)];
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
%% Section 2: graphs for post proc
% there are 4 sets of graphs
% i) theoretical moments 
% ii) sample moments, with p(theta|y) and p(Z|theta) P(Y_|theta Z)
% iii) as (ii) but initial state drawn from p(Z0|Y, theta)
% iv) draw Z from p(Z|theta Y)
str_pp_mode=[];
str_pp_mode{1}='theoretical_moments';
str_pp_mode{2}='sample_moments';
str_pp_mode{3}='sample_moments_smoothed_ini_state';
str_pp_mode{4}='sample_moments_smoothed_states';
%%
for ik = 1:4 % this is to cover all post proc exercises
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo_
        subplot(nyo_/2,2,in)
        scatm1=scalar_factor*[squeeze(mu_y_(in,:,ik))' squeeze(sig_y_(in,:,ik))'];
        scatm2=scalar_factor*[mean_y(in)*ones(N_prior_pred,1) std_y(in)*ones(N_prior_pred,1)];
        scatm3=scalar_factor*[mean_y_ps(in)*ones(N_prior_pred,1) std_y_ps(in)*ones(N_prior_pred,1)];
        scatter(scatm1(:,1),scatm1(:,2),'Marker','.');
        hold on;
        scatter(scatm2(:,1),scatm2(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
            'Marker','diamond');
        hold on;
        scatter(scatm3(:,1),scatm3(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
            'Marker','x');
        hold off
        xlabel('mean','fontsize',12);
        ylabel('std','fontsize',12);
        title(str_var(in),'fontsize',14,'color','red');
        xlim([min_mu_y_post(in) max_mu_y_post(in)]);
        ylim([min_sig_y_post(in) max_sig_y_post(in)]);
    end
    filename0=[io_dir filesep 'post_pred_moments_' str_pp_mode{ik}];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
    % dynamic correlations
    nfig=nfig+1;
    figure(nfig);
    for iny=1:nyo_
        for jny=1:nyo_
            true_corv=squeeze(Cora(iny,jny,:));
            subplot(nyo_,nyo_,(iny-1)*nyo_+jny);
            rho_mat=real(squeeze(Rho_y_(iny,jny,:,:,ik)))';
            rho_mat=sort(rho_mat);
            rho_mat=rho_mat(round(qv*M0),:)';
            plot1=plot((0:Nh)',[rho_mat true_corv]);
            set(plot1(1),'Color','r','LineWidth',2);
            set(plot1(2),'Color','r','LineWidth',2);
            set(plot1(3),'Color','r','LineWidth',2);
            set(plot1(4),'Color','b','LineWidth',4);
            title([str_var{jny}],'fontsize',12);
            %xlabel('horizon','fontsize',12);
            ylabel(str_var{iny},'fontsize',12);
            xlim([0 Nh]);
        end
    end
    filename0=[io_dir filesep 'post_pred_dyn_corr_' str_pp_mode{ik}];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
end
%% Section 3.1 one step ahead predictions for original series
% now we prapare graphs 
% first only with mean then also with quantiles
Yos=Yo*Trm_';
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    ygraphm=scalar_factor*[Yos(:,in) y10a(:,in,1)];
    ylimv=[min(min(ygraphm));max(max(ygraphm))];
    plot(datesv,scalar_factor*[Yos(:,in) y10a(:,in,1)]);
    if in==1
        title('true and one step ahead');
        end
    ylabel(str_var(in));
    subplot(nyo_/2,2,(in*2));
    plot(datesv,scalar_factor*[Yos(:,in)-y10a(:,in,1)]);
    ylabel(str_var(in));
    if in==1
        title('one step ahead error');
    end
end
if index_only_max
    filename0=[io_dir filesep 'actual_forecasts_max_1'];
else
    filename0=[io_dir filesep 'actual_forecasts_mean_1'];   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig)
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    plot(datesv,scalar_factor*[Yos(:,in+nyo/2) y10a(:,in+nyo/2,1)]);
    if in==1
        title('true and one step ahead');
    end
    ylabel(str_var(in+nyo/2));
    subplot(nyo_/2,2,(in*2));
    plot(datesv,scalar_factor*[Yos(:,in+nyo/2)-y10a(:,in+nyo/2,1)]);
    ylabel(str_var(in));
    if in==1
        title('one step ahead error');
    end
end
if index_only_max
    filename0=[io_dir filesep 'actual_forecasts_max_2'];
else
    filename0=[io_dir filesep 'actual_forecasts_mean_2'];   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig)
% now also with bands
if index_only_max==0
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo_/2;
        subplot(nyo_/2,2,(in-1)*2+1);
        plot(datesv,scalar_factor*[Yos(:,in) squeeze(y10a(:,in,3:end))]);
        if in==1
            title('true forecasts and bands');
        end
        ylabel(str_var(in+nyo/2));
        subplot(nyo_/2,2,(in*2));
        plot(datesv,scalar_factor*[repmat(Yos(:,in),1,3)-squeeze(y10a(:,in,3:end))]);
        if in==1
            title('forecast errors');
        end
        ylabel(str_var(in));
    end
    filename0=[io_dir filesep 'actual_forecasts_bands_1'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo_/2;
        subplot(nyo_/2,2,(in-1)*2+1);
        plot(datesv,scalar_factor*[Yos(:,in+nyo_/2) squeeze(y10a(:,in+nyo_/2,3:end))]);
        if in==1
            title('true forecasts and bands');
        end
        ylabel(str_var(in));
        subplot(nyo_/2,2,(in*2));
        plot(datesv,scalar_factor*[repmat(Yos(:,in+nyo_/2),1,3)-squeeze(y10a(:,in+nyo_/2,3:end))]);
        if in==1
            title('forecast errors');
        end
        ylabel(str_var(in));
    end
    filename0=[io_dir filesep 'actual_forecasts_bands_2'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
end
%% Section 3.2: one step ahead prediction for levels
% do the same for the levels
% now we prapare graphs 
% first only with mean then also with quantiles
% first part 
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    plot(datesv,scalar_factor*[Yo_lev(:,in) y10a_lev(:,in,1)]);
    if in==1
        title('actual and one step ahead');
    end
    if cum_index(in)
        ylabel(['cumulated ' str_var(in)]);
    else
        ylabel(str_var(in));
    end
    subplot(nyo_/2,2,(in*2));
    plot(datesv,scalar_factor*[Yo_lev(:,in)-y10a_lev(:,in,1)]);
    title('one step ahead errors');
    if cum_index(in)
        ylabel(['cumulated ' str_var(in)]);
    else
        ylabel(str_var(in));
    end
end
if index_only_max
    filename0=[io_dir filesep 'actual_forecasts_levels_max_1'];
else
    filename0=[io_dir filesep 'actual_forecasts_levels_mean_1'];   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
% second part
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    plot(datesv,scalar_factor*[Yo_lev(:,in+nyo_/2) y10a_lev(:,in+nyo_/2,1)]);
    if in==1
        title('actual and one step ahead');
    end
    if cum_index(in)
        ylabel(['cumulated ' str_var(in)]);
    else
        ylabel(str_var(in));
    end
    subplot(nyo_/2,2,(in*2));
    plot(datesv,scalar_factor*[Yo_lev(:,in+nyo_/2)-y10a_lev(:,in+nyo_/2,1)]);
    title('one step ahead errors');
    if cum_index(in)
        ylabel(['cumulated ' str_var(in)]);
    else
        ylabel(str_var(in));
    end
end
if index_only_max
    filename0=[io_dir filesep 'actual_forecasts_levels_max_2'];
else
    filename0=[io_dir filesep 'actual_forecasts_levels_mean_2'];   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
% now also with bands
if index_only_max==0
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo_/2;
        subplot(nyo_/2,2,(in-1)*2+1);
        plot(datesv,scalar_factor*[Yo_lev(:,in) squeeze(y10a_lev(:,in,3:end))]);
        if in==1;
            title('actual and forecasts with bands');
        end
        if cum_index(in)
            ylabel(['cumulated ' str_var(in)]);
        else
            ylabel(str_var(in));
        end
        subplot(nyo_/2,2,(in*2));
        plot(datesv,scalar_factor*[repmat(Yo_lev(:,in),1,3)-squeeze(y10a_lev(:,in,3:end))]);
        if in==1
            title('one step ahead errors with bands');
        end
        if cum_index(in)
            ylabel(['cumulated ' str_var(in)]);
        else
            ylabel(str_var(in));
        end
    end
    filename0=[io_dir filesep 'actual_forecasts_levels_bands_1'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo_/2;
        subplot(nyo_/2,2,(in-1)*2+1);
        plot(datesv,scalar_factor*[Yo_lev(:,in+nyo_/2) squeeze(y10a_lev(:,in+nyo_/2,3:end))]);
        if in==1;
            title('actual and forecasts with bands');
        end
        if cum_index(in)
            ylabel(['cumulated ' str_var(in)]);
        else
            ylabel(str_var(in));
        end
        subplot(nyo_/2,2,(in*2));
        plot(datesv,scalar_factor*[repmat(Yo_lev(:,in+nyo_/2),1,3)-squeeze(y10a_lev(:,in+nyo_/2,3:end))]);
        if in==1
            title('one step ahead errors with bands');
        end
        if cum_index(in)
            ylabel(['cumulated ' str_var(in)]);
        else
            ylabel(str_var(in));
        end
    end
    filename0=[io_dir filesep 'actual_forecasts_levels_bands_2'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
end
%% Section 4: continuous states, filtered and smoothed 
nfig=nfig+1;
figure(nfig);
ncols=2;
nrows=ceil(numel(x_str)/ncols);
for ix=1:nx;
    subplot(nrows,ncols,ix);
    plot(datesv,squeeze(scalar_factor*[Zfa(:,ix,1) Zsa(:,ix,1)]));
if ix==1
    title('filtered and smoothed means');
end
    ylabel(x_str(ix));
end
if index_only_max
    filename0=[io_dir filesep 'filtered_smoothed_continuous_states_max'];
else
    filename0=[io_dir filesep 'filtered_smoothed_continuous_states_mean'];
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
% this time with bands
if index_only_max==0    
    nfig=nfig+1;
    figure(nfig);
    for ix=1:nx;
        subplot(nrows,ncols,ix);
        plot(datesv,squeeze(scalar_factor*[squeeze(Zfa(:,ix,3:end)) squeeze(Zsa(:,ix,3:end))]));
        if ix==1
           title('filtered and smoothed bands');
        end
        ylabel(x_str(ix));
    end
    filename0=[io_dir filesep 'filtered_smoothed_continuous_states_bands'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
end
%% Section 5: marginal discrete states
n_points=xlsread(settings_filename,'i39:i39');
recession_dates0=xlsread(settings_filename,['i40:i' int2str(39+n_points)]);
recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
y_recession_dates=repmat([0 1 1 0]',length(recession_dates0)/2,1);
nfig=nfig+1;
figure(nfig);
for is=1:ns_;
    subplot(ns_,1,is);
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;    
    plot(datesv,squeeze([Pa_mg(:,is,1) Sa_mg(:,is,1)]));
    if is==1
        title('marginal discrete states filtered and smoothed');
    end
    ylabel(s_str{is});
end
if index_only_max
    filename0=[io_dir filesep 'filtered_smoothed_mg_dstates_max'];
else
    filename0=[io_dir filesep 'filtered_smoothed_mg_dstates_mean'];    
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
%
% now with bands
%
if index_only_max==0
    nfig=nfig+1;
    figure(nfig);
    for is=1:ns_;
        subplot(ns_,1,is);
        fill(recession_dates,y_recession_dates,[.9 .9 .9]);
        hold on;        
        plot(datesv,[squeeze(Pa_mg(:,is,3:end)) squeeze(Sa_mg(:,is,3:end))]);
        if is==1
            title('marginal discrete states filtered and smoothed with bands');
        end
        ylabel(s_str{is});
    end
        filename0=[io_dir filesep 'filtered_smoothed_mg_dstates_bands'];
        saveas(nfig,filename0,'fig');
        print('-dpdf','-r2400',filename0);
        print('-depsc2','-r2400',filename0);
        close(nfig);
end
%% Section 6: filtered and smoothed premia
nfig=nfig+1;
figure(nfig);
ymin=scalar_factor*min([filpremia(:);smopremia(:)]);
ymax=scalar_factor*max([filpremia(:);smopremia(:)]);
y_recession_dates=repmat([0 ymax ymax 0]',length(recession_dates0)/2,1);
subplot(2,1,1);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot(datesv,scalar_factor*squeeze(filpremia(:,1:2,1)));
axis([datesv(1) datesv(end) ymin ymax]);
title('filtered premia');
subplot(2,1,2);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot(datesv,scalar_factor*squeeze(smopremia(:,1:2,1)));
axis([datesv(1) datesv(end) ymin ymax]);
title('smoothed premia');  
if index_only_max
    filename0=[io_dir filesep 'premia_max'];
else
    filename0=[io_dir filesep 'premia_mean'];   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
if index_only_max==0
    nfig=nfig+1;
    figure(nfig);
    subplot(2,1,1);
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;
    plot(datesv,scalar_factor*[squeeze(filpremia(:,1,3:end)) squeeze(filpremia(:,2,3:end))]);
    axis([datesv(1) datesv(end) ymin ymax]);    
    title('filtered premia');
    subplot(2,1,2);
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;
    plot(datesv,scalar_factor*[squeeze(smopremia(:,1,3:end)) squeeze(smopremia(:,2,3:end))]);
    axis([datesv(1) datesv(end) ymin ymax]);    
    title('smoothed premia');
    filename0=[io_dir filesep 'premia_bands'];
    saveas(nfig,filename0,'fig');
    print('-dpdf','-r2400',filename0);
    print('-depsc2','-r2400',filename0);
    close(nfig);
end
%%
close all;