function retcode = DSGE_MS_prior_processing_2019(model_name0) 
% function to run DSGE MS model prior processing
%differs from previous version for allowing datesv to be first column of
%data matrix
eval(['[model_name,x_str,y_str,s_str,np] = ' model_name0 '_define();']);
n1=length(x_str);
n2=length(y_str);
nss=length(s_str);
settings_filename=[model_name '_estimation_settings.xlsx'];
[settings,string_range]=xlsread([settings_filename],'a2:a4');
infilename=string_range(1);
string_range=string_range(2);
nyd=settings(1);
low_cell=4+nyd+6;
settings=xlsread(settings_filename,['a5:a' int2str(low_cell)]);
index_variables=settings(1:nyd);
T_pre=settings(nyd+2);
Tini=settings(nyd+3);
seed0=settings(nyd+4);
order=settings(nyd+5);
nn3=settings(nyd+6);
n3=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+nn3)])';
low_cell=low_cell+nn3;
nlb=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+1)]);
n4=xlsread(settings_filename,['a' int2str(low_cell+2) ':a' int2str(low_cell+1+nlb)])';
low_cell=low_cell+1+nlb;
nyo=xlsread(settings_filename,['a' int2str(low_cell+1) ':a' int2str(low_cell+1)]); 
subset_y=xlsread(settings_filename,['a' int2str(low_cell+2) ':a' int2str(low_cell+1+nyo)]);
low_cell=low_cell+1+nyo+1;
ind_label_constraints=xlsread(settings_filename,['a' int2str(low_cell) ':a' int2str(low_cell)]);
[settings,Vwritefilename]=xlsread(settings_filename,'i2:i12');
clev=settings(9);
settings=xlsread(settings_filename,'i15:i32');
eps=settings(7);
solution_routine_name=[model_name '_modsol_Klein_'];
prior_specification_filename=[model_name '_parameters_description.xlsx'];
outfilename=[model_name '_prior_pred'];
label_constraints=2*nss+reshape((1:2*nss)',2,nss);
ndx_label_permute=DSGE_MS_ndx_label_permute(np,nss);
prior_specification_range=['b2:h' int2str(np+1)];
settings=xlsread(settings_filename,'i35:i38');
N_prior_pred=settings(1);
Nh=settings(2);
%% from this point onwards nothing should be changed
[prior_data, prior_headertext] = xlsread(prior_specification_filename,prior_specification_range);
deltatrue=prior_data(:,1);
simparndx=prior_data(:,2);
prior_type_ndxv=prior_data(:,3);
Rm=prior_data(:,4:5);
parameter_name=prior_headertext(:,1);
parameter_explanation=prior_headertext(:,2);
format short
for ip=1:np
    eval([char(parameter_name(ip)) '=' num2str(deltatrue(ip)) ';']);
end
% initialise random seed
rand('state',seed0);
randn('state',seed0);
testm_str=cellstr(strvcat('post mean','post sd','post low q','post up q','prior mean','prior sd','prior low q','prior up q','calibrated'));
auxiliary_str=cellstr(strvcat('order','M','mov ratio','Vreadndx','cV','nskip','combined'));                        
%put all the parameters in the delta0 vector
delta0=deltatrue;
%%
T0=T_pre-Tini;
sim1ndx=find(simparndx>0);
nsimpar=sum(simparndx>0);
nby=length(n4);
%load dataset;
alldata=xlsread(infilename{1},1,string_range{1});
scalar_factor=xlsread(settings_filename,1,'e2');
Yo=alldata(1:end,index_variables)/scalar_factor;
%datesv=alldata(T0+1:end,4);
datesv=alldata(T0+1:end,1); %novelty in the code
Yo=Yo(T0+1:end,:);
[T nyo]=size(Yo);
%
% initial evaluation of the solution
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
nx=size(etastd,1); % number of state variables
nx3=log(size(eta,3))/log(2); % number of discrete state variables
nx2=size(etastd,2)-nx3; % number of Gaussian shocks
nx1=nx-nx2-nx3; % number of predetermined state variables
%% data moments, presample and all sample
Yo__=alldata(1:end,index_variables)/scalar_factor;
datesv__=alldata(1:end,4);
Yo__=Yo__(1:T0,:);
Yo___=mean(Yo__);
Yo___std=sqrt(var(Yo__));
%
Yo_=mean(Yo);
Yo_std=sqrt(var(Yo));
Cova=mk_sdca(Yo,Nh);
diagsigma=diag(1./sqrt(diag(Cova(:,:,1))));
Cora=Cova;
for ih=1:Nh+1
    Cora(:,:,ih)=diagsigma*Cova(:,:,ih)*diagsigma;
end
nz=n1;
str_var=[];
for iy=1:length(n3);
    str_var{iy}=y_str{n3(iy)};
end
for iy=1:length(n4);
    str_var{length(n3)+iy}=['R' int2str(n4(iy))];
end
%% prior predictive analysis
mu_z=zeros(nz,N_prior_pred);
mu_y=zeros(nyo,N_prior_pred);
Sigma_z=zeros(nz,nz,Nh+1,N_prior_pred);
Sigma_y=zeros(nyo,nyo,Nh+1,N_prior_pred);
Rho_z=zeros(nz,nz,Nh+1,N_prior_pred);
Rho_y=zeros(nyo,nyo,Nh+1,N_prior_pred);
h = waitbar(0,'Prior Predictive');
ipp1=0;
prior_param=zeros(N_prior_pred,np);
for ipp=1:N_prior_pred
    retcode=0;
    while retcode==0
        ipp1=ipp1+1;
        delta0=DSGE_priordraw(Rm,prior_type_ndxv);
        delta0=delta0(sim1ndx);
        delta0=DSGE_parameter_vector(delta0,simparndx,deltatrue);
        if ind_label_constraints
            ind_perm=zeros(3,1);
            for iim=1:3
                ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
            end
            delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
        end
        eval(['[retcode_,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
        retcode=retcode_*isreal(y_)*isreal(gx)*isreal(hx)*isreal(gxx)*isreal(hxx)*isreal(gss)*isreal(hss)*isreal(eta)*isreal(etastd);
    end
    prior_param(ipp,:)=delta0';
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    [mu_z(:,ipp),mu_y(:,ipp),Sigma_z(:,:,:,ipp),Sigma_y(:,:,:,ipp),Rho_z(:,:,:,ipp),Rho_y(:,:,:,ipp)] = DSGE_MS_moments(y_,a_i,A1_i(:,:,1),A2,B_i,c_j,C1_j(:,:,1),C2,D,pv,Nh);
    waitbar(ipp/N_prior_pred,h,['prior pred % completed: ' sprintf('%2.2f',100*ipp/N_prior_pred)]);
end
delete(h);
%
%% Section 1.1 graphs for prior pred
max_mu_y_all=scalar_factor*max([max(mu_y,[],2) Yo_' Yo___'],[],2);
min_mu_y_all=scalar_factor*min([min(mu_y,[],2) Yo_' Yo___'],[],2);
% isolate std deviations
sigma_y=zeros(nyo,size(Sigma_y,4));
for in=1:nyo
    sigma_y(in,:)=squeeze(sqrt(Sigma_y(in,in,1,:)));
end
% limits for prior and post pred analysis
max_sig_y_all=scalar_factor*max([max(sigma_y,[],2) Yo_std' Yo___std'],[],2);
min_sig_y_all=scalar_factor*min([min(sigma_y,[],2) Yo_std' Yo___std'],[],2);
qv=[(1-clev)/2; .5;(1+clev)/2]; 

%censor the bounds
max_mu_y_all=min(max_mu_y_all,20);
min_mu_y_all=max(min_mu_y_all,-5);

max_sig_y_all=min(max_sig_y_all,20);
min_sig_y_all=max(min_sig_y_all,0);

%% figures with scatterplots for couples of means and std devs
nfig=1;
figure(nfig);
for ik=1:3
    subplot(3,2,2*(ik-1)+1)
    scatm1=scalar_factor*[mu_y(2*(ik-1)+1,:)' mu_y(2*(ik-1)+2,:)'];
    scatm2=scalar_factor*[Yo_(2*(ik-1)+1)*ones(N_prior_pred,1) Yo_(2*(ik-1)+2)*ones(N_prior_pred,1)];
    scatm3=scalar_factor*[Yo___(2*(ik-1)+1)*ones(N_prior_pred,1) Yo___(2*(ik-1)+2)*ones(N_prior_pred,1)];
    scatter(scatm1(:,1),scatm1(:,2),'Marker','.');
    hold on;
    scatter(scatm2(:,1),scatm2(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','diamond');
    hold on;
    scatter(scatm3(:,1),scatm3(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','x');    
    hold off
    xlabel(str_var(2*(ik-1)+1),'fontsize',14);
    ylabel(str_var(2*(ik-1)+2),'fontsize',14);
    if ik==1
        title('Mean','fontsize',12,'color','red');
    end;
    xlim([min_mu_y_all(2*(ik-1)+1) max_mu_y_all(2*(ik-1)+1)]);
    ylim([min_mu_y_all(2*(ik-1)+2) max_mu_y_all(2*(ik-1)+2)]);
    %
subplot(3,2,2*(ik-1)+2)
    scatm1=scalar_factor*sqrt([squeeze(Sigma_y(2*(ik-1)+1,2*(ik-1)+1,1,:)) squeeze(Sigma_y(2*(ik-1)+2,2*(ik-1)+2,1,:))]);
    scatter(scatm1(:,1),scatm1(:,2),'Marker','.');
    scatm2=scalar_factor*[Yo_std(2*(ik-1)+1)*ones(N_prior_pred,1) Yo_std(2*(ik-1)+2)*ones(N_prior_pred,1)];
    hold on;
    scatter(scatm2(:,1),scatm2(:,2),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','diamond');
    hold on;
    scatter(scalar_factor*Yo___std(2*(ik-1)+1)*ones(1,N_prior_pred),scalar_factor*Yo___std(2*(ik-1)+2)*ones(1,N_prior_pred),'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[1 0 0],...
        'Marker','x');
    hold off
    xlabel(str_var(2*(ik-1)+1),'fontsize',14);
    ylabel(str_var(2*(ik-1)+2),'fontsize',14);
    if ik==1;
        title('std dev','fontsize',12,'color','red');
    end;
    xlim([min_sig_y_all(2*(ik-1)+1) max_sig_y_all(2*(ik-1)+1)]);
    ylim([min_sig_y_all(2*(ik-1)+2) max_sig_y_all(2*(ik-1)+2)]);   
end
filename0=['prior_pred' int2str(nfig)];
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
% graphs for dynamic correlations
nfig=nfig+1;
figure(nfig);
for iny=1:nyo
    for jny=1:nyo
        true_corv=squeeze(Cora(iny,jny,:));
        subplot(nyo,nyo,(iny-1)*nyo+jny);
        rho_mat=real(squeeze(Rho_y(iny,jny,:,:)))';
        rho_mat=sort(rho_mat);
        rho_mat=rho_mat(round(qv*N_prior_pred),:)';
        plot1=plot((0:Nh)',[rho_mat true_corv]);
        set(plot1(1),'Color','r');
        set(plot1(2),'Color','r');
        set(plot1(3),'Color','r');
        set(plot1(4),'Color','b');
        if iny==1;
            title([str_var{jny}],'fontsize',12);
        end;
        %xlabel('horizon','fontsize',12);        
        if jny==1
            ylabel(str_var{iny},'fontsize',12);
        end
        xlim([0 Nh]);
    end
end
filename0=['prior_pred' int2str(nfig)];
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
%% compute empirical pvalues for sample means and std 
%% store them in array empirical_pval(i,j,h)
% i=variable, j = moment (mean, std), h=subsample (sample, presample)
empirical_pval=zeros(nyo,4); 
empirical_pval(:,1)=empirical_cum_dens(mu_y',Yo_',0);
empirical_pval(:,3)=empirical_cum_dens(mu_y',Yo___',0);
empirical_pval(:,2)=empirical_cum_dens(sigma_y',Yo_std',0);
empirical_pval(:,4)=empirical_cum_dens(sigma_y',Yo___std',0);
empirical_pval=100*empirical_pval;
empirical_pval_structure.pval=empirical_pval;
empirical_pval_structure.rows=str_var;
empirical_pval_structure.cols=[];
empirical_pval_structure.cols{1}='sample mean';
empirical_pval_structure.cols{2}='sample std';
empirical_pval_structure.cols{3}='presample mean';
empirical_pval_structure.cols{4}='presample std';
filename='moments_empirical_pval';
if ispc
    xlswrite(filename,empirical_pval_structure.rows',1,'a2');
    xlswrite(filename,empirical_pval_structure.cols,1,'b1');
    xlswrite(filename,empirical_pval_structure.pval,1,'b2');
else
    save(filename,'empirical_pval_structure');
end
%% write results to mat file
% 2014 09 24, inserted code to avoid crashing when saving (Citrix problem
% with Matlab R12
%% 2014 09 24, changed to include mechanism to prevent crashes when saving
% probs with Matlab 12 in Citrix
isave=0;
while isave==0
    try
        eval(['save ' model_name0 'prior_proc_results']);        
        isave=1;
    catch savefilefailed
        clc;
        'saving file failed'
    end
end