function structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution,pi_tt,xm_tt,Qa_tt,nh)
a_i=structure_DSGE_MS_solution.a_i;
A1=structure_DSGE_MS_solution.A1;
A2=structure_DSGE_MS_solution.A2;
B_i=structure_DSGE_MS_solution.B_i;
c_j=structure_DSGE_MS_solution.c_j;
C1=structure_DSGE_MS_solution.C1;
C2=structure_DSGE_MS_solution.C2;
D=structure_DSGE_MS_solution.D;
tpa=structure_DSGE_MS_solution.tpa;
y_=structure_DSGE_MS_solution.y_;
%
[nx,ns,nm]=size(B_i);
[ny,nme]=size(D);
ndstates=size(tpa,3);
%
P=tpa(:,:,end);
if ndstates > 1
    for ids=(ndstates-1):-1:1;
        P=kron(tpa(:,:,ids),P);
    end
end
%
DD=D*D';
muxm=zeros(nx,nh);
Sigxa_=zeros(nx,nx,nh);
Sigxa=zeros(nx,nx,nh);
pi_m=zeros(nm,nh);
muym=zeros(ny,nh);
Sigya_=zeros(ny,ny,nh);
Sigya=zeros(ny,ny,nh);
pi_00=pi_tt;
% compute initial first and second moments
mux0=xm_tt*pi_tt;
mux0_lin=mux0;
Sig0xm_=zeros(nx,nx);
for im=1:nm
    Sig0xm_=Sig0xm_+(Qa_tt(:,:,im)+xm_tt(:,im)*xm_tt(:,im)')*pi_tt(im);
end
Sig0xm=Sig0xm_-mux0_lin*mux0_lin';
% start the recursion across the horizons
for ih=1:nh
    BB_itm1=zeros(nx,nx);
    for im=1:nm
        BB_itm1=BB_itm1+B_i(:,:,im)*B_i(:,:,im)'*pi_00(im);
    end
    mux1=a_i*pi_00+A1*mux0+A2*vech_(Sig0xm_);
    mux1_lin=A1*mux0_lin;
    Sig1xm=A1*Sig0xm*A1'+BB_itm1;
    Sig1xm_=Sig1xm+mux1_lin*mux1_lin';
    pi_10=P'*pi_00;
    muy1_lin=y_+C1*mux1_lin;
    %
    Sig1ym=C1*Sig1xm*C1'+DD;
    Sig1ym_=Sig1ym+muy1_lin*muy1_lin';    
    muy1=c_j*pi_10+C1*mux1+C2*vech_(Sig1xm_);

    % storing 
    muxm(:,ih)=mux1;
    Sigxa_(:,:,ih)=Sig1xm_;
    Sigxa(:,:,ih)=Sig1xm;
    %
    muym(:,ih)=muy1;
    Sigya_(:,:,ih)=Sig1ym_;
    Sigya(:,:,ih)=Sig1ym;
    %
    pi_m(:,ih)=pi_10;
    % to allow for recursion
    pi_00=pi_10;
    mux0=mux1;
    mux0_lin=mux1_lin;
    Sig0xm=Sig1xm; 
    Sig0xm_=Sig1xm_;
    
end
% store everything into a structure
structure_conditional_moments.muxm=muxm;
structure_conditional_moments.Sigxa_=Sigxa_;
structure_conditional_moments.Sigxa=Sigxa;
structure_conditional_moments.muym=muym;
structure_conditional_moments.Sigya_=Sigya_;
structure_conditional_moments.Sigya=Sigya;
structure_conditional_moments.pi_m=pi_m;
%
