function retcode = DSGE_dynamic_correlations(model_name,io_dir)
%% Section 0: read inputs
%file with setting for extensive post processing
settings_filename=[io_dir filesep model_name '_extensive_post_processing_settings.xlsx'];
[settings,stringv]=xlsread(settings_filename,1,'a1:a6');
M00=settings(1); % number of draws
seed0=settings(2); % seed of rng
ndx_postmean=settings(3); % whether or not post mean is used
Nh=settings(6); % max horizon for dynamic correlations, irfs, fevd,etc 
alt_param_filename=stringv{1}; % to specify an alternative file for parameters (for some special simulations)
%yields_forwards_datafile=stringv{2}; % not used here
io_dir1=[io_dir  filesep 'extensive_postprocessing']; 
io_dir2=[io_dir1 filesep 'dynamic_correlations'    ]; % this is the specific folder to be used to store results
% check whether these directory exist. If not, create them
if ~exist(io_dir1,'dir')
    mkdir(io_dir1);
end
if ~exist(io_dir2,'dir')
    mkdir(io_dir2);
end
eval(['load ' io_dir filesep model_name '_results;']); % read results file
% if the settings file indicates a name different from "param", and if that file exists
% then it loads parameters from that source 
if strcmp(alt_param_filename,'param')==0 && exist([io_dir filesep alt_param_filename],'file') 
    eval(['load ' io_dir filesep alt_param_filename ';']);
end
%
M=size(param,1);
rng('default');
rng(seed0);
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
ns_=log(ncs)/log(2);
Mthin=M/M00;
%nss=length(s_str);
%ncs=2^nss;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,ns_); % construct indices for checking label permute
% this bloc is to create spreads and define (T x 8 ) matrix with data on
% spread too
nspread=numel(n4); 
Trm=zeros(nspread,nyo);
Trm(:,nyd-nspread)=-1;
Trm(:,nyd-nspread+1:end)=eye(nspread);
Trm_=[eye(nyo); Trm]; % this is matrix to transform Y into Ys (nyo+nspread) x 1
nyo_=nyo+nspread;
Yo_=Yo*Trm_';
%
mu_z_=zeros(nz,M00,4);
mu_y_=zeros(nyo_,M00,4);
Sigma_z_=zeros(nz,nz,Nh+1,M00,4);
Sigma_y_=zeros(nyo_,nyo_,Nh+1,M00,4);
sig_y_=zeros(nyo_,M00,4);
Rho_z_=zeros(nz,nz,Nh+1,M00,4);
Rho_y_=zeros(nyo_,nyo_,Nh+1,M00,4);
etaa=zeros(T,nz2,M00);
qv=[(1-clev)/2; .5;(1+clev)/2]; 
%% Section 1: loop over parameter draws
for im=1:M00
    if ndx_postmean
    delta0=mean(param(:,1:np))';
    else
        delta0=param(Mthin*(im-1)+1,1:np)';
    end
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    [retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    Zm=array2mat(Za,sv);
    % block 1 of post proc: compute theoretical moments based on p(theta|Y)
    [mu_z_(:,im,1),mu_y_(:,im,1),Sigma_z_(:,:,:,im,1),Sigma_y_(:,:,:,im,1),Rho_z_(:,:,:,im,1),Rho_y_(:,:,:,im,1)] = DSGE_MS_moments(Trm_*y_,a_i,A1_i(:,:,1),A2,B_i,Trm_*c_j,Trm_*C1_j(:,:,1),Trm_*C2,Trm_*D,pv,Nh);
    sig_y_(:,im,1)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,1))));
    % block 2 of post proc: compute sample moments from data drawn from 
    %  p(Y_|theta, Z), p(Z|theta), p(theta|Y)
    s0=draw_multinom(pv,1,ncs,1);
    z0=mu_z_(:,im,1)+chol(squeeze(Sigma_z_(:,:,1,im,1)))'*randn(nz,1);
    Y_=zeros(T,nyo_);
    for it=1:T
        s1=draw_multinom(ctp(s0,:)',1,ncs,1);
        z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*vech_(z0*z0')+B_i(:,:,s0)*randn(size(B_i,2),1);
        y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y1'*Trm_';
        z0=z1;
        s0=s1;
    end
    mu_y_(:,im,2)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,2)=Cova__;
    sig_y_(:,im,2)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,2))));    
    Rho_y_(:,:,:,im,2)=Cora__;
    % block 3 of post proc: compute as before but initial state drawn from
    %  p(z_1|thetaY)   
    s0=sv(1);
    z0=Za(1,:,s0)';
    Y_=zeros(T,nyo_);
    y0=c_j(:,s0)+C1_j(:,:,s0)*z0+C2*vech_(z0*z0')+D*randn(size(D,2),1);
    Y_(1,:)=y0'*Trm_';
    for it=2:T
        s1=draw_multinom(ctp(s0,:)',1,ncs,1);
        z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*vech_(z0*z0')+B_i(:,:,s0)*randn(size(B_i,2),1);
        y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y0'*Trm_';
        z0=z1;
        s0=s1;
    end
    mu_y_(:,im,3)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,3)=Cova__;
    sig_y_(:,im,3)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,2))));    
    Rho_y_(:,:,:,im,3)=Cora__;
    % block 4 of post processing: simulate data from p(theta,Z|Y)
    Y_=zeros(T,nyo_);    
    for it=1:T
        z1=Zm(it,:)';
        y1=c_j(:,sv(it))+C1_j(:,:,sv(it))*z1+C2*vech_(z1*z1')+D*randn(size(D,2),1);
        Y_(it,:)=y1'*Trm_';
    end    
    mu_y_(:,im,4)=mean(Y_);
    Cova__=mk_sdca(Y_,Nh);
    diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
    Cora__=Cova__;
    for ih=1:Nh+1
        Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
    end
    Sigma_y_(:,:,:,im,4)=Cova__;
    sig_y_(:,im,4)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,4))));    
    Rho_y_(:,:,:,im,4)=Cora__;
    % this is to compute posterior distribution of smoothed shocks
    for it=2:T
        z1=Zm(it,:)';
        z0=Zm(it-1,:)';
        s0=sv(it-1);
        eta1=z1-a_i(:,s0)-A1_i(:,:,s0)*z0-A2*vech(z0*z0');
        eta1=B_i(nz1+1:end,:,s0)\eta1(nz1+1:end);
        etaa(it,:,im)=eta1';
    end 
    clc;
    im/M00
end

%% section 2: extract relevant material for constructing the graphs
% section 2.0
% compute observed data dynamic correlations getting rid of NaN
% then stored in arrays Cova and Cora
yv_=sum(1-isnan(Yo),2)==nyo;
t1=find(yv_==1,1,'first');
t2=find(yv_==0,1,'first')-1;
if numel(t2)==0
    t2=size(Yo,1);
end
ym_=Yo_(t1:t2,:);
Cova=mk_sdca(ym_,Nh);
Cora=Cova;
for ih=1:size(Cova,3)
Cora(:,:,ih)=diag(1./sqrt(diag(Cova(:,:,1)))) * ...
    Cova(:,:,ih)*diag(1./sqrt(diag(Cova(:,:,1))));
end
% 2. 1 computation of cross correlations into blocks to produce graphs
str_Yo=[];
str_Yo{1}='Pi';
str_Yo{2}='Dc';
str_Yo{3}='Dy';
str_Yo{4}='I';
str_Yo{5}='R12';
str_Yo{6}='R40';
nblocs=2;
str_bloc=[];
str_bloc{1}='macro';
str_bloc{2}='rates';
%
graphya=zeros(Nh+1,4,3,3,2,2,4); 
% dimensions are horizon (0 to 20), 4 series (lower, median, upper and
% sample covariance), number of series in each bloc, number of series in
% each bloc, number of blocks, number of blocs, number of moments types (4).
% blocs are 1) macro, 2) yields
str_var=[];
for iy=1:length(n3)
    str_var{iy}=y_str{n3(iy)};
end
for iy=1:length(n4)
    str_var{length(n3)+iy}=['R' int2str(n4(iy))];
end
for iy=1:nspread
    str_var{nyo+iy}=['R' int2str(n4(iy)) ' - ' str_var{nyo-nspread}];
end
for ik=1:4 % select type of moments
    for ibloc=1:2 % select macro-rates bloc
        for jbloc=1:2 % select macro-rates bloc
            % write here the content for making the graph
            figure(1);
            icum=0;
            for iny=((1:3)+3*(ibloc-1))     % macro or rates block
                for jny=((1:3)+3*(jbloc-1)) % macro or rates block
                    icum=icum+1;
                    subplot(3,3,icum);
                    true_corv=squeeze(Cora(iny,jny,:));
                    subplot(3,3,icum);
                    rho_mat=real(squeeze(Rho_y_(iny,jny,:,:,ik)))';
                    rho_mat=sort(rho_mat);
                    rho_mat=rho_mat(round(qv*M00),:)';
                    %
                    % here define all that goes into the graph
                    graphym=[rho_mat true_corv];
                    graphxv=(0:Nh)';
                    plot1=plot(graphxv,graphym);
                    set(plot1(1),'Color','r','LineWidth',2);
                    set(plot1(2),'Color','r','LineWidth',2);
                    set(plot1(3),'Color','r','LineWidth',2);
                    set(plot1(4),'Color','b','LineWidth',4);
                    title([str_var{jny}],'fontsize',12);
                    %xlabel('horizon','fontsize',12);
                    ylabel(str_var{iny},'fontsize',12);
                    xlim([0 Nh]);
                    graphya(:,:,iny-3*(ibloc-1),jny-3*(jbloc-1),ibloc,jbloc,ik)=graphym;
                end
            end
            figure_filename=['dyn_corrs_' str_bloc{ibloc} '_' str_bloc{jbloc} ...
                '_' int2str(ik)];
            saveas(1,figure_filename,'fig');
            print(1,'-dpsc2',figure_filename,'-r2400');
            print(1,'-dpdf',figure_filename,'-r2400');
            close(1);
        end
    end
end
% move all the figure files in their dedicated directory (io_dir2)
system(['mv dyn_corrs_*.* ' io_dir2 ';']);
%
save [io_dir2 'dyn_correlation_storage'] graphxv graphya qv Nh str_bloc str_Yo M00
% note that graphpya is (21 x 4 x 3 x 3 x 2 x 2)
% fist dimension is horizon
% second dimension is number of series being plotted (lower, median, upper
% and sample correlation
% third dimension is y(i,t)
% fourth dimension is y(j,t-h)
% fifth dimension is bloc (macro or yields)
% sixth dimension is bloc (macro or yields)
% EXAMPLE:
%to plot dynamic correlations between macro and yields 
% you need to extract squeeze(graphya(:,:,:,:,1,2)) 
% order of variables is as in str_Yo
%% section 3: make diagonal only dyn corr graphs 
% add the other file that makes the other charts
%load 'dyn_correlation_storage.mat';
% need to extract only the diagonal dynamic covariances
% (auto covariances)
% note that graphpya is (21 x 4 x 3 x 3 x 2 x 2)
% fist dimension is horizon
% second dimension is number of series being plotted (lower, median, upper
% and sample correlation
% third dimension is y(i,t)
% fourth dimension is y(j,t-h)
% fifth dimension is bloc (macro or yields)
% sixth dimension is bloc (macro or yields)
% EXAMPLE:
%to plot dynamic correlations between macro and yields 
% you need to extract squeeze(graphya(:,:,:,:,1,2)) 
% order of variables is as in str_Yo
str_Yo{1}='\pi';
str_Yo{2}='\Delta c';
str_Yo{3}='\Delta y';
str_Yo{4}='R_{1}';
str_Yo{5}='R_{12}';
str_Yo{6}='R_{40}';
%
for ik=1:4
    diag_graphya=zeros(Nh+1,4,6); % 21 horizons, 4 lines being plotted, 6 variables
    % macro variables
    for in1=1:3
        diag_graphya(:,:,in1)=squeeze(graphya(:,:,in1,in1,1,1,ik)); % macro
        diag_graphya(:,:,3+in1)=squeeze(graphya(:,:,in1,in1,2,2,ik)); %yields
    end
    figure(1);
    for in=1:6
        subplot(3,2,in)
        graphym=squeeze(diag_graphya(:,:,in));
        plot(graphxv,graphym(:,4),'LineWidth',3,'Color','blue','LineStyle','--');
        hold on;
        plot(graphxv,graphym(:,2),'LineWidth',3,'Color','red');
        hh=fill([graphxv'  fliplr(graphxv') ],[graphym(:,1)' fliplr(graphym(:,3)')],'r');%         alpha(hh,.05);
        alpha(hh,.10);
        hold off;
        set(gca,'fontsize',20);
        title([str_Yo{in}],'fontsize',20);
        xlim([0 Nh]);
    end
    figure_filename=['diagonal_dyn_corrs' int2str(ik)];
    saveas(1,figure_filename,'fig');
    saveas(1,figure_filename,'bmp');
    saveas(1,figure_filename,'png');
    print(1,'-dpsc2',figure_filename);
    print(1,'-dpdf',figure_filename);
    close(1);
end
system(['mv diagonal_dyn_*.* ' io_dir2 ';']);
retcode=1;

