function prior_hessian = DSGE_prior_hessian(Rm,omegav,prior_type_ndxv)
% computes Hessian for prior
% this is returned as a vector (needed to be inserted into a diagonal
% matrix)
npar=size(omegav,1);
prior_hessian=zeros(npar,1);
% Beta distributed parameters
ndx=find(prior_type_ndxv==1);
prior_hessian(ndx)=-(Rm(ndx,1)+Rm(ndx,2))./(2+exp(omegav(ndx)+exp(-omegav(ndx))));
% Gamma and shifted Gamma distributed parameters
ndx=find(prior_type_ndxv==2 | prior_type_ndxv==3);
prior_hessian(ndx)=-(Rm(ndx,1)/2).*exp(omegav(ndx));
% Gaussian distributed parameters
ndx=find(prior_type_ndxv==4);
prior_hessian(ndx)=-1./((Rm(ndx,2)).^2);
% Inverse Gamma distributed parameters
ndx=find(prior_type_ndxv==5);
prior_hessian(ndx)=-2*Rm(ndx,2).*(Rm(ndx,1).^2)./(exp(omegav(ndx)).^2);
% uniform distributed parameters have Hessian = 0;


