function sm = make_multivariate_state_indicator(ns,csv_in)
% generates multivariate discrete state indicator from (N x 1) vector with
% composite state indicator
%works only with dichotomous states and up to 6 discrete state variables
% INPUTS: 
%        ns  =     integer number of dichotomous variables
%        csv_in  = (N x 1) vector with N values for composite state
% OUTPUT:
%        sm      = (ns x N) matrix with correspondig values for multivariate discrete states         
% ns=2; csv_in=[1 3 4 4]' => sm = 1 0 0 0
%                                 1 1 0 0                                  
% by Gianni Amisano, amisano@eco.unibs.it, 2007_08_08
N=length(csv_in);
sm=zeros(ns,N);
icum=0;
if ns==1
    sm=csv_in;
end
if ns==2
for is1=1:-1:0
    for is2=1:-1:0
    icum=icum+1;    
    ndx0=find(csv_in==icum);
    n0=prod(size(ndx0));
    sm(:,ndx0)=repmat([is1;is2],1,n0);
    end
end
elseif ns==3
    for is1=1:-1:0
        for is2=1:-1:0
            for is3=1:-1:0
                icum=icum+1;
                ndx0=find(csv_in==icum);
                n0=prod(size(ndx0));
                sm(:,ndx0)=repmat([is1;is2;is3],1,n0);
            end
        end
    end
elseif ns==4
    for is1=1:-1:0
        for is2=1:-1:0
            for is3=1:-1:0
                for is4=1:-1:0
                    icum=icum+1;
                    ndx0=find(csv_in==icum);
                    n0=prod(size(ndx0));
                    sm(:,ndx0)=repmat([is1;is2;is3;is4],1,n0);
                end
            end
        end
    end
elseif ns==5
    for is1=1:-1:0
        for is2=1:-1:0
            for is3=1:-1:0
                for is4=1:-1:0
                    for is5=1:-1:0
                        icum=icum+1;
                        ndx0=find(csv_in==icum);
                        n0=prod(size(ndx0));
                        sm(:,ndx0)=repmat([is1;is2;is3;is4;is5],1,n0);
                    end
                end
            end
        end
    end
elseif ns==6
    for is1=1:-1:0
        for is2=1:-1:0
            for is3=1:-1:0
                for is4=1:-1:0
                    for is5=1:-1:0
                        for is6=1:-1:0
                            icum=icum+1;
                            ndx0=find(csv_in==icum);
                            n0=prod(size(ndx0));
                            sm(:,ndx0)=repmat([is1;is2;is3;is4;is5;is6],1,n0);
                        end
                    end
                end
            end
        end
    end
end
    