function retcode = RATTS_2020_fevda(model_name,io_dir)
settings_filename=[io_dir filesep model_name '_extensive_post_processing_settings.xlsx'];
[settings,stringv]=xlsread(settings_filename,1,'a1:a6');
M00=settings(1); % number of draws
seed0=settings(2); % seed of rng
%ndx_postmean=settings(3); % whether or not post mean is used
Nh=settings(6); % max horizon for dynamic correlations, irfs, fevd,etc 
alt_param_filename=stringv{1}; % to specify an alternative file for parameters (for some special simulations)
%yields_forwards_datafile=stringv{2}; % not used here
io_dir1=[io_dir  filesep 'extensive_postprocessing']; 
io_dir2=[io_dir1 filesep 'fevda'    ]; % this is the specific folder to be used to store results
% check whether these directory exist. If not, create them
if ~exist(io_dir1,'dir')
    mkdir(io_dir1);
end
if ~exist(io_dir2,'dir')
    mkdir(io_dir2);
end
eval(['load ' io_dir filesep model_name '_results;']); % read results file
% if the settings file indicates a name different from "param", and if that file exists
% then it loads parameters from that source 
if strcmp(alt_param_filename,'param')==0 && exist([io_dir filesep alt_param_filename],'file') 
    eval(['load ' io_dir filesep alt_param_filename ';']);
end
%
M=size(param,1);
rng('default');
rng(seed0);
qv_=[.05 .5 .95];
%% section 1 load results and perform various computations
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
ns_=log(ncs)/log(2);
nthin=M/M00;
%nss=length(s_str);
%ncs=2^nss;
%ndx_label_permute=DSGE_MS_ndx_label_permute_(np,ns_); % construct indices for checking label permute
% this bloc is to create spreads and define (T x 8 ) matrix with data on
% spread too
nspread=numel(n4); 
Trm=zeros(nspread,nyo);
Trm(:,nyd-nspread)=-1;
Trm(:,nyd-nspread+1:end)=eye(nspread);
Trm_=[eye(nyo); Trm]; % this is matrix to transform Y into Ys (nyo+nspread) x 1
nyo_=nyo+nspread;
Yo_=Yo*Trm_';
%nthin=nthin_;
%qv=qv_;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% Section 2: computation of FEVD
% 2.1: computation of IRFs to regime switches
fevdaa=zeros(nyo_,ns_+nz2+nyo+1,Nh,M00);
param_=zeros(M00,np);
%
for im=1:M00
    delta0=param((im-1)*nthin+1,1:np)';
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    param_(im,:)=delta0';
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    [retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    %retcode0=retcode0+(retcode==0);
    structure_DSGE_MS_solution.a_i=a_i;
    structure_DSGE_MS_solution.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution.A2=A2;
    structure_DSGE_MS_solution.B_i=B_i;
    structure_DSGE_MS_solution.c_j=c_j;
    structure_DSGE_MS_solution.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution.C2=C2;
    structure_DSGE_MS_solution.D=D;
    structure_DSGE_MS_solution.tpa=tpa;
    structure_DSGE_MS_solution.y_=y_;
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution,Pm(end,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh);
    denm=zeros(nyo_,Nh); 
    for ih=1:Nh
        denm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    %
    fevda=zeros(nyo_,nss+nz2+nyo+1,Nh);
    %% set delta0__ with all variances set to zero and long term targets equal to each other (to switch off the switch)
    % FEV matrices based on this account only for the role of initial condition
    delta0__=delta0;
    delta0__([(9:15) (35:40)])=0;
    delta0__(7) = delta0__(8);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0__,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,~,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0__);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution__.a_i=a_i;
    structure_DSGE_MS_solution__.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution__.A2=A2;
    structure_DSGE_MS_solution__.B_i=B_i;
    structure_DSGE_MS_solution__.c_j=c_j;
    structure_DSGE_MS_solution__.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution__.C2=C2;
    structure_DSGE_MS_solution__.D=D;
    structure_DSGE_MS_solution__.tpa=tpa;
    structure_DSGE_MS_solution__.y_=y_;
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution__,Pm(end,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh);
    numm__=zeros(nyo_,Nh);
    for ih=1:Nh
        numm__(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,end,:)=numm__./denm;
    % now set also initial component to zero
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution__,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm___=zeros(nyo_,Nh);
    for ih=1:Nh
        numm___(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    % this has been checked to be equal to zero
    % now introduce the first shock, set stdxi>0, same order as in B_i matrix : 
%      {4}='xi';
%      {5}='z';
%      {6}='pol';
%      {7}='mu';
%      {8}='G';
    delta0_=delta0__;
    delta0_(15)=delta0(15);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    %
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+1,:)=numm./denm;
    % now second shock z (MS): start measuring its effect without MS
    delta0_=delta0__;
    delta0_(11:12)=delta0(11);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,nss+2,:)=numm./denm;
    % now, third shock monpol, again with MS inactive 
    delta0_=delta0__;
    delta0_(9:10)=delta0(9);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,nss+3,:)=numm./denm;
    % now 4th shock, mu
    delta0_=delta0__;
    delta0_(13)=delta0(13);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+4,:)=numm./denm;
    % now, fifth shock, g
    delta0_=delta0__;
    delta0_(14)=delta0(14);
    
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+5,:)=numm./denm;
    % now effect of MS on pistar  
    delta0_=delta0__;
    delta0_(7:8)=delta0(7:8);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,1,:)=numm./denm;
    % now effect of second MS (mon pol);
    delta0_=delta0__;
    delta0_(9:10)=delta0(9:10);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,2,:)=numm./denm;
    fevda(:,2,:)=fevda(:,2,:)-fevda(:,nss+3,:); % to net out the part of the effect due to std mon pol = low vol state
    
    % now 3rd MS state: zi
    delta0_=delta0__;
    delta0_(11:12)=delta0(11:12);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
    numm=zeros(nyo_,Nh);
    for ih=1:Nh
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,3,:)=numm./denm;
    fevda(:,3,:)=fevda(:,3,:)-fevda(:,nss+2,:);
    % now check for role of meas errors
    for in=1:nyo
        delta0_=delta0__;
        delta0_(34+in)=delta0(34+in);
        eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
        %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
        structure_DSGE_MS_solution_.a_i=a_i;
        structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
        structure_DSGE_MS_solution_.A2=A2;
        structure_DSGE_MS_solution_.B_i=B_i;
        structure_DSGE_MS_solution_.c_j=c_j;
        structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
        structure_DSGE_MS_solution_.C2=C2;
        structure_DSGE_MS_solution_.D=D;
        structure_DSGE_MS_solution_.tpa=tpa;
        structure_DSGE_MS_solution_.y_=y_;
        structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
            structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh);
        numm=zeros(nyo_,Nh);
        for ih=1:Nh
            numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        end
        fevda(:,nss+nz2+in,:)=numm./denm;
    end
    fevdaa(:,:,:,im)=100*fevda;% store as percentages
    clc;
    im/M00
end
%
save('fevdaa','fevdaa');
%% Section 2: make graphs
str_sources=[];
for is=1:ns_
    str_sources{is}=s_str{is};
end
%
str_var=[];
for iy=1:length(n3);
    str_var{iy}=y_str{n3(iy)};
end
for iy=1:length(n4);
    str_var{length(n3)+iy}=['R' int2str(n4(iy))];
end
for iy=1:nspread;
    str_var{nyo+iy}=['R' int2str(n4(iy)) ' - ' str_var{nyo-nspread}];
end
%
% here the ordering of the shocks is that in the
% columns of Beta_i
% str_shocks=[];
% str_shocks{1}='xi';
% str_shocks{2}='z';
% str_shocks{3}='pol';
% str_shocks{4}='mu';
% str_shocks{5}='G';
%
str_shocks=[];
str_shocks{1}='xi';
str_shocks{2}='z';
str_shocks{3}='pol';
str_shocks{4}='mu';
str_shocks{5}='G';
%
for iz2=1:nz2
    str_sources{ns_+iz2}=str_shocks{iz2};
end
for in=1:nyo
    str_sources{ns_+nz2+in}=[str_var{in} ' meas error'];
end
str_sources{ns_+nz2+nyo+1}='initial condition';
%
qv=[(1-clev)/2; .5;(1+clev)/2]; 
%
for is=1:ns_
    str_sources{is}=s_str{is};
end
% now fevdaa have responses of shocks in the following order
% 1 to 3: variance state allocation shocks 
% 4 to 8% structural shocks in the order reported for IRFs and Historical
%      Decomposition, ie corresponding to the columns of Beta_i:
%      {4}='xi';
%      {5}='z';
%      {6}='pol';
%      {7}='mu';
%      {8}='G';
% 9 to 15: measurement errors with the same ordering as variables 
% 16: initial condition
%
%
str_var_names=str_var;
str_var_names{7}='R12_I_t';
str_var_names{8}='R40_I_t';
%
fevdaa_=mean_std_quantiles(fevdaa,qv);
for in=1:nyo_
    figure(in);
    ymin=0;
    ymax=100;
    figure(in);
    ndx_source_in=[(1:ns_+nz2) ns_+nz2+find(Trm_(in,:)~=0) ns_+nz2+nyo+1];
    ig=0;
    for isou=ndx_source_in
        % work here 2015 12 15 @ 1810
        ig=ig+1;
        subplot(ceil(numel(ndx_source_in)/3),3,ig);
        yyymat=squeeze(fevdaa_(in,isou,1:Nh,[1 3 4 5]));
        plot((1:Nh)',yyymat(:,1),'LineWidth',2,'Color','red');
        hold on;
        plot((1:Nh)',yyymat(:,3),'LineWidth',1,'LineStyle','--','Color','blue');
        %
        hh=fill([(1:Nh) fliplr(1:Nh)],[yyymat(:,4)' fliplr(yyymat(:,2)')],'b');
        alpha(hh,.05);
        %
        hold off;
        ylabel(str_var(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([1 Nh]);
        ylim([ymin ymax]);
        title(str_sources(isou),'FontSize',12);
    end
    figure_filename=['figure_FEVD_' str_var_names{in}];
    saveas(in,figure_filename,'fig');
    print(in,'-dpsc2',figure_filename);
    print(in,'-dpdf',figure_filename);
end
close all;
str_sources1=str_sources;
str_shocks1=str_shocks;
save [io_dir2 'fevdaa'] fevdaa;
%% Section 2: make table(s)
ndx_separate_docs=1;
fevdaa_=mean_std_quantiles(fevdaa,qv);
fevdaa__=permute(squeeze(fevdaa_(:,:,ih,[1 3 5])),[2 1 3]);
hv=[1 floor(Nh/2) Nh];
%
%here permute to have the ordering with tech shocks together
% ordering will be 
% 1         2        3       4    5    6      7    8    9     10    11    12    13      14       15
% s_pistar  s_mpol   s_zi   xi    z    mpol   mu   G    pi_me dc_me dy_me i_me  i_12_me i_40_me  initial   
%
%modify str_var to avoid _;
    str_var_=str_var;
    str_var{1}='Pi';
    str_var{4}='R1';
    str_var{7}='R12-R1';
    str_var{8}='R40-R1';   
%
for ih=hv
    latex_table_content=[];
    if ndx_separate_docs
        latex_table_content{1,1}='\documentclass[a4paper,10pt]{article}';
        latex_table_content{2,1}='\begin{document}';
    else
        latex_table_content{1,1}=[];
        latex_table_content{2,1}=[];
    end
    latex_table_content{3,1}='\begin{table}[h!]';
    latex_table_content{4,1}='\centering';
    latex_table_content{5,1}=['\begin{tabular}{|' repmat('c|',1,nyo_+1) '}'];
    latex_table_content{6,1}='\hline';
    latex_table_content{7,1}=[];
    for in=1:nyo_
        latex_table_content{7,1}=[latex_table_content{7,1} ' & ' str_var{in}];
    end
    latex_table_content{7,1}=[latex_table_content{7,1} ' \\'];
    latex_table_content{8,1}='\hline';
    %
    for irow=1:ns_+nz2
        latex_table_content{8+2*(irow-1)+1,1}=str_sources{irow};
        for icol=1:nyo_
            ccontent=[int2str(round(fevdaa__(irow,icol,1))) '[' int2str(round(fevdaa__(irow,icol,2)))    '-'  int2str(round(fevdaa__(irow,icol,3)))      ']'];
            latex_table_content{8+2*(irow-1)+1,1}=[latex_table_content{8+2*(irow-1)+1,1} ...
                ' & ' ccontent];
        end
        % add \\
        latex_table_content{8+2*(irow-1)+1,1}=[latex_table_content{8+2*(irow-1)+1,1} ' \\'];
        latex_table_content{8+2*(irow-1)+2,1}='\hline';
        %
        % own measurement errors
    end
    latex_table_content{8+2*(ns_+nz2)+1,1}='own m.e.';
    for icol=1:nyo_
        if icol>nyo
            ccontent='--';
        else
            ccontent=[int2str(round(fevdaa__(ns_+nz2+icol,icol,1))) '[' int2str(round(fevdaa__(ns_+nz2+icol,icol,2)))    '-'  int2str(round(fevdaa__(ns_+nz2+icol,icol,3)))      ']'];
        end
        latex_table_content{8+2*(ns_+nz2)+1,1}=[latex_table_content{8+2*(ns_+nz2)+1,1} ...
            ' & ' ccontent];
    end
    % add \\
    latex_table_content{8+2*(ns_+nz2)+1,1}=[latex_table_content{8+2*(ns_+nz2)+1,1} ' \\'];
    latex_table_content{8+2*(ns_+nz2)+2,1}='\hline';
    % finish the table
    latex_table_content{8+2*(ns_+nz2)+3,1}='\end{tabular}';
    latex_table_content{8+2*(ns_+nz2)+4,1}=['\caption{Variance decomposition ' int2str(ih) '-step-ahead}'];
    latex_table_content{8+2*(ns_+nz2)+5,1}=['\label{table:FEVD_' int2str(ih) '}'];
    latex_table_content{8+2*(ns_+nz2)+6,1}='\end{table}';
    if ndx_separate_docs
        latex_table_content{8+2*(ns_+nz2)+7,1}='\end{document}';
    end
    % write the table
    tablefilename=['FEVD_' int2str(ih) '.tex'];
    if exist(tablefilename,'file')==2
        if ispc
            system(['del ' tablefilename ]);
        else
            system(['rm ' tablefilename ]);
        end
    end
    diary(['FEVD_' int2str(ih) '.tex']);
    disp(char(latex_table_content{:}));
    diary off
end
system(['mv *.tex ' io_dir2 ';']);
retcode=1;