close all;clc; clear all;
%% this is to compute GIRFs to continous shocks
% 2015 12 14
%
% this script is to evaluate IRFs to continuous shocks in MS_DSGE RATTS
%z0=[]; z0_=zeros(nz,1); % starting point for the simulation
% maybe draw from their conditional statea
load ../../RATTS_2020_results_postproc;
s0_=1; % starting point for simulation
ndx_other_shocks=1; % if zero, all other shocks are set to zero=1;
ndx_discrete_shocks=1; % if zero, keep fixed volatility states at s0_
shock_sizev=ones(nz2,1); % size of shock being inputed (here all =+1)
z_=[];
nthin=2;
qv=[.05 .5 .95];
Nh=80;
%%
M0=M/nthin;
irfaa=zeros(nyo_,nz2,Nh+1,M0); % this is the container for IRFs (across all draws)
for im=1:M0
    delta0=param((im-1)*nthin+1,1:np)';
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    param_(im,:)=delta0';
    % solve the model
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    retcode0=retcode0+(retcode==0);
    irfa=zeros(nyo_,nz2,Nh+1); % this is the container for IRFs
    % now simulate over the horizon
    s0__=s0_;
    Sm_=Sm;
    if ndx_discrete_shocks
        s_1Nhv=ones(Nh+1,1);
        s0_=draw_multinom(Sm_(end,:)',1,ncs,1);
        s0__=s0_;
        for ih=1:Nh+1
            s0_=draw_multinom(ctp(s0_,:)',1,ncs,1);
            s_1Nhv(ih)=s0_;
        end
    else
        s_1Nhv=s0*ones(Nh+1,1);
    end
    s_0Nhv=[s0__;s_1Nhv];
    if ndx_other_shocks
        wm=randn(nz2,Nh+1);
    else
        wm=zeros(nz2,Nh+1);
    end
    % now compute the IRFs for each of the shocks
    for iz2=1:nz2
        % think: move wm simulation in here
        
        wa=repmat(wm,[1 1 2]); % creates array with shock (nz2 x (Nh+1) x 2), where pages are two diffrent shock paths
        wa(iz2,1,2)=wa(iz2,1,2)+shock_sizev(iz2);
        % now compute the two different paths
        % think about how to set z_
        %
        if numel(z_) % if a starting point is specified, then it usedd, otherwise drawn from the relevant filtered distribution
            z0m=repmat(z_,[1 2]); % array with evolution of z's, first page is baseline, second is perturbed
        else
            [rankQ,F]=factorise_semidefinitem(squeeze(Qa(end,:,:,s_0Nhv(1))));
            z0m=repmat(squeeze(Za(end,:,s_0Nhv(1)))'+F*randn(rankQ,1),[1 2]);
        end
        ya=zeros(nyo,Nh+1,2); %same structure for Yo
        % rem to have a look at the line above
        for ih=1:Nh+1
            s0=s_0Nhv(ih);
            s1=s_0Nhv(ih+1);
            z1m=zeros(nz,2);
            % draw the z's (using previous state) and the Y
            % do not need to add meas err since they cancel out
            for ipath=1:2
                z1m(:,ipath)=a_i(:,s0)+A1_i(:,:,s0)*z0m(:,ipath)+...
                    A2*quadc1(z0m(:,ipath))+B_i(:,:,s0)*wa(:,ih,ipath);
                za(:,ih,ipath)=z1m(:,ipath);
                ya(:,ih,ipath)=c_j(:,s1)+C1_j(:,:,s1)*z1m(:,ipath)+...
                    C2*quadc1(z1m(:,ipath));
            end
            z0m=z1m;
            % now compute IRFs as differences across the two paths
            irfa(:,iz2,ih)=Trm_*squeeze(ya(:,ih,:))*[-1; 1];
        end
    end
    clc;
    im/M0
    irfaa(:,:,:,im)=irfa;
end
%% make graphs
str_shocks=[];
str_shocks{1}='xi';
str_shocks{2}='z';
str_shocks{3}='pol';
str_shocks{4}='mu';
str_shocks{5}='G';
%
irfaa(2:3,:,:,:)=cumsum(irfaa(2:3,:,:,:));

irfaa_=mean_std_quantiles(irfaa,qv);



str_var=str_var;
str_var{2}='C';
str_var{3}='Y';



figure(1);
for iz=1:nz2
    ymin=min(min(squeeze(irfaa_(:,iz,1:Nh+1,3))));
    ymax=max(max(squeeze(irfaa_(:,iz,1:Nh+1,5))));
    figure(iz);
    for in=1:nyo_
        subplot(nyo_/2,2,in);
        yyymat=squeeze(irfaa_(in,iz,1:Nh+1,[1 3 4 5]));
        plot((0:Nh)',yyymat(:,1),'LineWidth',3,'Color','red');
        hold on;
        plot((0:Nh)',yyymat(:,3),'LineWidth',1,'LineStyle','--','Color','blue');
        hh=fill([(0:Nh) fliplr(0:Nh)],[yyymat(:,4)' fliplr(yyymat(:,2)')],'b');
        alpha(hh,.05);
        hold off;
        ylabel(str_var(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([0 Nh]);
        ylim([ymin ymax]);
        if in==1
            title(strjoin(['response to shock ' str_shocks(iz)]),'FontSize',12);
        end
    end
    figure_filename=['figure_GIRF_' str_shocks{iz}];
    saveas(iz,figure_filename,'fig');
    print(iz,'-dpsc2',figure_filename);
    print(iz,'-dpdf',figure_filename);
end
close all; 


save('irfaa','irfaa');

    