close all;clc; clear all;
%% this is to compute GIRFs to continous shocks
% 2015 12 14
%
% this script is to evaluate IRFs to continuous shocks in MS_DSGE RATTS
%z0=[]; z0_=zeros(nz,1); % starting point for the simulation
% maybe draw from their conditional statea
qv=[.05 .5 .95];
Nh=21;
%%
nz2=5; 
nyo_=6;
load irfaa.mat;
%% make graphs
str_shocks=[];
str_shocks{1}='xi';
str_shocks{2}='z';
str_shocks{3}='pol';
str_shocks{4}='mu';
str_shocks{5}='G';
%
str_var={'Pi','C','Y','R_1','R_{12}','R_{40}'};
irfaa(2:3,:,:,:)=cumsum(irfaa(2:3,:,:,:));

irfaa_=mean_std_quantiles(irfaa,qv);
save irfaa_ irfaa_ qv
%figure(1);
for iz=1:nz2
    ymin=min(min(squeeze(irfaa_(:,iz,1:Nh+1,3))));
    ymax=max(max(squeeze(irfaa_(:,iz,1:Nh+1,5))));
    figure(iz);
    for in=1:nyo_
        subplot(nyo_/2,2,in);
        yyymat=squeeze(irfaa_(in,iz,1:Nh+1,[1 3 4 5]));
        plot((0:Nh)',yyymat(:,1),'LineWidth',3,'Color','red');
        hold on;
        plot((0:Nh)',yyymat(:,3),'LineWidth',1,'LineStyle','--','Color','blue');
        hh=fill([(0:Nh) fliplr(0:Nh)],[yyymat(:,4)' fliplr(yyymat(:,2)')],'b');
        alpha(hh,.05);
        hold off;
        ylabel(str_var(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([0 Nh]);
        ylim([ymin ymax]);
        if in==1
            title(strjoin(['response to shock ' str_shocks(iz)]),'FontSize',12);
        end
    end
    figure_filename=['figure_GIRF_' str_shocks{iz}];
    saveas(iz,figure_filename,'fig');
    print(iz,'-dpsc2',figure_filename);
    print(iz,'-dpdf',figure_filename);
end
close all;


save('irfaa80','irfaa');

    