clear; clc; close all;
%% section 0: general inputss
model_name='RATTS_2020';
M00=1e+3;
qv0=[.025 .5 .975]';
%% section 1 load results and perform various computations
load(['../' model_name '_results_postproc']);
% 1.1 compute one step ahead first and second moments
% this computation is done by extrapolating filtered variables
% caution: it is slow
%% Section 1: some inputs
qv=qv0;
M0=M00;
Mthin=M/M0;
qv_=[.05 .5 .95];
hf=12; % this is max horizon for forecasting
%% section 1 load results and perform various computations
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% save
load rmses_forecasts;
%datesv Yo str_var hf foreya foreea foreyaa foreeaa rmsm rwrmsm;
% make table
%% produce tables
table_relative_rmses=rmsm./rwrmsm;

input.data=table_relative_rmses;
% Optional fields:

% Set column labels (use empty string for no label):
input.tableColLabels =[];
for ih=hf
    input.tableColLabels{ih}=int2str(ih);
end
;
% Set row labels (use empty string for no label):
input.tableRowLabels = {str_var{1}, str_var{2}, str_var{3}, str_var{4}, str_var{5}, str_var{6} };

% Switch transposing/pivoting your table:
input.transposeTable = 0;

% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used

% Formatting-string to set the precision of the table values:
% For using different formats in different rows use a cell array like
% {myFormatString1,numberOfValues1,myFormatString2,numberOfValues2, ... }
% where myFormatString_ are formatting-strings and numberOfValues_ are the
% number of table columns or rows that the preceding formatting-string applies.
% Please make sure the sum of numberOfValues_ matches the number of columns or
% rows in input.tableData!
%
input.dataFormat = {'%4.2f',12}; % three digits precision for first two columns, one digit for the last

% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';

% Column alignment in Latex table ('l'=left-justified, 'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'c';

% Switch table borders on/off:
input.tableBorders = 1;

% LaTex table caption:
input.tableCaption = 'Relative RMSFEs for different horizons';

% LaTex table label:
input.tableLabel = 'Rel_RATTS_RMSFEs';

% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 1;
if exist([input.tableLabel '.tex'],'file');
    eval(['system(''rm ' input.tableLabel '.tex'')']);
end
% call latexTable:
latex = latexTable(input);
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;