clear;clc;close all;
%% section 0: general inputss
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
ndx_postmean=0;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results
%load(['../' model_name '_results_postproc']);
load(['../../' model_name '_results_postproc']); % to go where results are
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
%% section 2: extract relevant material for constructing the graphs
% section 2.0
% compute dynamic correlations getting rid of NaN
% 
yv_=sum(1-isnan(Yo),2)==nyo;
t1=find(yv_==1,1,'first');
t2=find(yv_==0,1,'first')-1;
if numel(t2)==0
    t2=size(Yo,1);
end
ym_=Y_(t1:t2,:);
Cova=mk_sdca(ym_,size(Cova,3)-1);
Cora=Cova;
for ih=1:size(Cova,3)
Cora(:,:,ih)=diag(1./sqrt(diag(Cova(:,:,1)))) * ...
    Cova(:,:,ih)*diag(1./sqrt(diag(Cova(:,:,1))));

end
% 1. 1 computation of cross correlations into blocks to produce graphs
str_Yo=[];
str_Yo{1}='Pi';
str_Yo{2}='Dc';
str_Yo{3}='Dy';
str_Yo{4}='I';
str_Yo{5}='R12';
str_Yo{6}='R40';
M0=size(Rho_y_,4);
nblocs=2;
str_bloc=[];
str_bloc{1}='macro';
str_bloc{2}='rates';
str_momtype=[];
str_momtype{1}='exante';
str_momtype{2}='expost';
momtypev=[2];
%
graphya=zeros(Nh+1,4,3,3,2,2); 
% dimensions are horizon (0 to 20), 4 series (lower, median, upper and
% sample covariance), number of series in each bloc, number of series in
% each bloc, number of blocks, number of blocs.
% blocs are 1) macro, 2) yields

for ik=1:numel(momtypev) % select type of moments
    for ibloc=1:2 % select macro-rates bloc
        for jbloc=1:2 % select macro-rates bloc
            % write here the content for making the graph
            figure(1);
            icum=0;
            for iny=((1:3)+3*(ibloc-1))     % macro or rates block
                for jny=((1:3)+3*(jbloc-1)) % macro or rates block
                    icum=icum+1;
                    subplot(3,3,icum);
                    true_corv=squeeze(Cora(iny,jny,:));
                    subplot(3,3,icum);
                    rho_mat=real(squeeze(Rho_y_(iny,jny,:,:,momtypev(ik))))';
                    rho_mat=sort(rho_mat);
                    rho_mat=rho_mat(round(qv*M0),:)';
                    
                    % here define all that goes into the graph
                    graphym=[rho_mat true_corv];
                    graphxv=(0:Nh)';
                    plot1=plot(graphxv,graphym);
                    set(plot1(1),'Color','r','LineWidth',2);
                    set(plot1(2),'Color','r','LineWidth',2);
                    set(plot1(3),'Color','r','LineWidth',2);
                    set(plot1(4),'Color','b','LineWidth',4);
                    title([str_var{jny}],'fontsize',12);
                    %xlabel('horizon','fontsize',12);
                    ylabel(str_var{iny},'fontsize',12);
                    xlim([0 Nh]);
                    graphya(:,:,iny-3*(ibloc-1),jny-3*(jbloc-1),ibloc,jbloc)=graphym;
                end
            end
            figure_filename=['dyn_corrs_' str_bloc{ibloc} '_' str_bloc{jbloc} ...
                '_' str_momtype{ik}];
            saveas(1,figure_filename,'fig');
            print(1,'-dpsc2',figure_filename,'-r2400');
            print(1,'-dpdf',figure_filename,'-r2400');
            close(1);
        end
    end
end
%%
save 'dyn_correlation_storage' graphxv graphya qv Nh str_bloc str_Yo M0
% note that graphpya is (21 x 4 x 3 x 3 x 2 x 2)
% fist dimension is horizon
% second dimension is number of series being plotted (lower, median, upper
% and sample correlation
% third dimension is y(i,t)
% fourth dimension is y(j,t-h)
% fifth dimension is bloc (macro or yields)
% sixth dimension is bloc (macro or yields)
% EXAMPLE:
%to plot dynamic correlations between macro and yields 
% you need to extract squeeze(graphya(:,:,:,:,1,2)) 
% order of variables is as in str_Yo