clc;close all; clear;
load 'dyn_correlation_storage.mat';
% need to extract only the diagonal dynamic covariances
% (auto covariances)
% note that graphpya is (21 x 4 x 3 x 3 x 2 x 2)
% fist dimension is horizon
% second dimension is number of series being plotted (lower, median, upper
% and sample correlation
% third dimension is y(i,t)
% fourth dimension is y(j,t-h)
% fifth dimension is bloc (macro or yields)
% sixth dimension is bloc (macro or yields)
% EXAMPLE:
%to plot dynamic correlations between macro and yields 
% you need to extract squeeze(graphya(:,:,:,:,1,2)) 
% order of variables is as in str_Yo
str_Yo{1}='\pi';
str_Yo{2}='\Delta c';
str_Yo{3}='\Delta y';
str_Yo{4}='R_{1}';
str_Yo{5}='R_{12}';
str_Yo{6}='R_{40}';


diag_graphya=zeros(21,4,6); % 21 horizons, 4 lines being plotted, 6 variables
% macro variables
for in1=1:3
    diag_graphya(:,:,in1)=squeeze(graphya(:,:,in1,in1,1,1)); % macro
    diag_graphya(:,:,3+in1)=squeeze(graphya(:,:,in1,in1,2,2)); %yields
end

figure(1);
for in=1:6
    subplot(3,2,in)
    graphym=squeeze(diag_graphya(:,:,in));
    plot(graphxv,graphym(:,4),'LineWidth',3,'Color','blue','LineStyle','--');
    hold on;
    plot(graphxv,graphym(:,2),'LineWidth',3,'Color','red');
%     hold on;
%     plot(graphxv,graphym(:,[1 3]),'LineWidth',3,'Color','red','LineStyle','--');
    
    
    hh=fill([graphxv'  fliplr(graphxv') ],[graphym(:,1)' fliplr(graphym(:,3)')],'r');%         alpha(hh,.05);
    alpha(hh,.10);

    hold off;
    
    
    set(gca,'fontsize',20);
%     set(plot1(1),'Color','r','LineWidth',2);
%     set(plot1(2),'Color','r','LineWidth',2);
%     set(plot1(3),'Color','r','LineWidth',2);
%     set(plot1(4),'Color','b','LineWidth',2);
    title([str_Yo{in}],'fontsize',20);
    %xlabel('order','fontsize',12);
    %ylabel('autocorrelation','fontsize',12);
    xlim([0 Nh]);
end
figure_filename='diagonal_dyn_corrs';
saveas(1,figure_filename,'fig');
saveas(1,figure_filename,'bmp');
saveas(1,figure_filename,'png');
print(1,'-dpsc2',figure_filename);
print(1,'-dpdf',figure_filename);
close(1);



%%

str_Yo{1}='Pi';
str_Yo{2}='Delta_c';
str_Yo{3}='Delta_y';
str_Yo{4}='R_1';
str_Yo{5}='R_12';
str_Yo{6}='R_40';



datam=[(0:Nh)' reshape(diag_graphya,21,24)];
str_Yo_=reshape(repmat(str_Yo,4,1),24,1)';
label_str={'lower','median','upper','sample'};
label_str_=repmat(label_str,1,6);

column_names{1}='horizon';
for ik=1:24
    column_names{1+ik}=[str_Yo_{ik} '_' label_str_{ik}];
end

% csvwrite('figure1_data.csv',str_Yo_,0)
% csvwrite('figure1_data.csv',label_str_,1)
% csvwrite('figure1_data.csv',reshape(diag_graphya,21,24),2);
%T=table(datam,'VariableNames',column_names);
T=table(datam);


