clear; clc; close all;
str_variants={'MS_IRFs_ini111_fixothers_perm.mat','MS_IRFs_ini111_fixothers_temp.mat', ...
    'MS_IRFs_ini111_swiothers_perm.mat', 'MS_IRFs_ini110_fixothers_perm.mat'};
irfaa_rep=zeros(30,81,3,2,9,numel(str_variants));
for iv=1:numel(str_variants)
    eval(['load ' str_variants{iv} ';']);
    irfaa_rep(:,:,:,:,:,iv)=irfa_rep;
end
%%
%pick type
itype=1; % all shocks set to zero
% pick state
istate=3; % zi state
% pick response of pi, dc, dy, r
ndx_select_vars=11:14;
ndx_select_moms=[1 5 7]; % posterior mean and 25% and 75% quantiles
nh_=20;
nfig=0;
xv_=(0:nh_)';
%compare responses ini111 permanent and temporary
ndx_variants=[1 2];
nfig=nfig+1; 
figure(nfig);
for in=1:numel(ndx_select_vars)
    for itype=1:2
        subplot(4,2,2*(in-1)+itype);
        ym=reshape(...
            400*squeeze(irfaa_rep(ndx_select_vars(in),1:(nh_+1),istate,itype,ndx_select_moms,ndx_variants)), ...
            nh_+1,numel(ndx_select_moms)*numel(ndx_variants),[]);
        plot1=plot(xv_,ym);
        set(plot1(1),'Color','r','LineWidth',3);
        set(plot1(2),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(3),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(4),'Color','b','LineWidth',3);
        set(plot1(5),'Color','b','LineWidth',2,'LineStyle',':');
        set(plot1(6),'Color','b','LineWidth',2,'LineStyle',':');
        title(str_var(ndx_select_vars(in)));
        if (in==numel(ndx_select_vars) && itype==2)
            legend({'perm mean','perm 25','perm 75','temp mean','temp 25','temp 75'},'NumColumns',6);
            legend('boxoff')
        end
    end
end
filename='compare_111_perm_temp';
sgtitle('effect of change of zi sigma: perm vs temp, initial state 1 1 1, type 1 (left) and type 2 (right)');
orient(nfig,'landscape');
%print(nfig,'-fillpage',filename,'-dpdf');
print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');
%
%
%
%compare responses ini111 and ini110 permanent
ndx_variants=[1 4];
nfig=nfig+1; 
figure(nfig);
for in=1:numel(ndx_select_vars)
    for itype=1:2
        subplot(4,2,2*(in-1)+itype);
        ym=reshape(...
            400*squeeze(irfaa_rep(ndx_select_vars(in),1:(nh_+1),istate,itype,ndx_select_moms,ndx_variants)), ...
            nh_+1,numel(ndx_select_moms)*numel(ndx_variants),[]);
        plot1=plot(xv_,ym);
        set(plot1(1),'Color','r','LineWidth',3);
        set(plot1(2),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(3),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(4),'Color','b','LineWidth',3);
        set(plot1(5),'Color','b','LineWidth',2,'LineStyle',':');
        set(plot1(6),'Color','b','LineWidth',2,'LineStyle',':');
        title(str_var(ndx_select_vars(in)));
        if (in==numel(ndx_select_vars) && itype==2)
            legend({'L2H mean','L2H 25','L2H 75','H2L mean','H2L 25','H2L 75'},'NumColumns',6);
            legend('boxoff')
        end
    end
end
filename='compare_110_111';
sgtitle('effect of change of zi sigma: from low to high and viceversa, type 1 (left) and type 2 (right)');
orient(nfig,'landscape');
%print(nfig,'-fillpage',filename,'-dpdf');
print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');


%

%compare responses ini111 permanent fix other states v. switching other states 
ndx_variants=[1 3];
nfig=nfig+1; 
figure(nfig);
for in=1:numel(ndx_select_vars)
    for itype=1:2
        subplot(4,2,2*(in-1)+itype);
        ym=reshape(...
            400*squeeze(irfaa_rep(ndx_select_vars(in),1:(nh_+1),istate,itype,ndx_select_moms,ndx_variants)), ...
            nh_+1,numel(ndx_select_moms)*numel(ndx_variants),[]);
        plot1=plot(xv_,ym);
        set(plot1(1),'Color','r','LineWidth',3);
        set(plot1(2),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(3),'Color','r','LineWidth',2,'LineStyle',':');
        set(plot1(4),'Color','b','LineWidth',3);
        set(plot1(5),'Color','b','LineWidth',2,'LineStyle',':');
        set(plot1(6),'Color','b','LineWidth',2,'LineStyle',':');
        title(str_var(ndx_select_vars(in)));
        if (in==numel(ndx_select_vars) && itype==2)
            legend({'fixed mean','fixed 25','fixed 75','switch mean','switch 25','switch 75'},'NumColumns',6);
            legend('boxoff')
        end
    end
end
filename='compare_others_fixed_switching';
sgtitle('effect of change of zi sigma: from low to high, permanent, other states fixed v. switching,  type 1 (left) and type 2 (right)');
orient(nfig,'landscape');
%print(nfig,'-fillpage',filename,'-dpdf');
print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');

