clear; clc; close all;
%% section 0: general inputss
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
ndx_postmean=0;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results and perform various computations

load(['../' model_name '_results_postproc']);
delta0=mean(param(:,1:np))';
if ind_label_constraints
    ind_perm=zeros(ns_,1);
    for iim=1:ns_
        ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
    end
    delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
end


tic;

eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution.a_i=a_i;
structure_DSGE_MS_solution.A1=A1_i(:,:,1);
structure_DSGE_MS_solution.A2=A2;
structure_DSGE_MS_solution.B_i=B_i;
structure_DSGE_MS_solution.c_j=c_j;
structure_DSGE_MS_solution.C1=C1_j(:,:,1);
structure_DSGE_MS_solution.C2=C2;
structure_DSGE_MS_solution.D=D;
structure_DSGE_MS_solution.tpa=tpa;
structure_DSGE_MS_solution.y_=y_;
structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution,Pm(T,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh_);
denm=zeros(nyo,Nh_);
for ih=1:Nh_
    denm(:,ih)=diag(squeeze(structure_conditional_moments.Sigya(:,:,ih)));
end
%
fevda=zeros(nyo,Nh_,nss+nz2+nyo);
%% set delta0__ with all variances set to zero 
% FEV matrices based on this account only for the role of initial condition
delta0__=delta0;
delta0__([(7:14) (35:40)])=0;
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0__,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0__);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
structure_DSGE_MS_solution__.a_i=a_i;
structure_DSGE_MS_solution__.A1=A1_i(:,:,1);
structure_DSGE_MS_solution__.A2=A2;
structure_DSGE_MS_solution__.B_i=B_i;
structure_DSGE_MS_solution__.c_j=c_j;
structure_DSGE_MS_solution__.C1=C1_j(:,:,1);
structure_DSGE_MS_solution__.C2=C2;
structure_DSGE_MS_solution__.D=D;
structure_DSGE_MS_solution__.tpa=tpa;
structure_DSGE_MS_solution__.y_=y_;
structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution__,Pm(end,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh_);
numm__=zeros(nyo,Nh_);
for ih=1:Nh_
    numm__(:,ih)=diag(squeeze(structure_conditional_moments.Sigya(:,:,ih)));
end
%% now set also initial component to zero
structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution__,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm___=zeros(nyo,Nh_);
for ih=1:Nh_
    numm___(:,ih)=diag(squeeze(structure_conditional_moments.Sigya(:,:,ih)));
end
% this has been checked to be equal to zero
%% now solve with std_G0<std_G1
delta0_=delta0__;
delta0_(7:8)=delta0(7:8);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
%
structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));    
end
fevda(:,:,1)=numm./denm;
%% now solve with std_pol0<std_pol1
delta0_=delta0__;
delta0_(9:10)=delta0(9:10);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
    
end
fevda(:,:,2)=numm./denm;
%% now solve with std_z0<std_z1
delta0_=delta0__;
delta0_(11:12)=delta0(11:12);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
    
end
fevda(:,:,3)=numm./denm;
%% now solve with std_G1=std_G0
delta0_=delta0__;
delta0_(7:8)=delta0(7);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
end
fevda(:,:,nss+1)=numm./denm;
%% now solve with std_pol1=std_pol0=0
delta0_=delta0__;
delta0_(9:10)=delta0(9);

eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
end
fevda(:,:,nss+2)=numm./denm;
%% now solve with std_z1=std_z0=0
delta0_=delta0__;
delta0_(11:12)=delta0(11);

eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
end
fevda(:,:,nss+3)=numm./denm;
%% now solve with stdmu=0;
delta0_=delta0__;
delta0_(13)=delta0(13);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
end
fevda(:,:,nss+4)=numm./denm;
%% now solve with stdxi=0;
delta0_=delta0__;
delta0_(14)=delta0(14);
eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
%[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);

structure_DSGE_MS_solution_.a_i=a_i;
structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
structure_DSGE_MS_solution_.A2=A2;
structure_DSGE_MS_solution_.B_i=B_i;
structure_DSGE_MS_solution_.c_j=c_j;
structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
structure_DSGE_MS_solution_.C2=C2;
structure_DSGE_MS_solution_.D=D;
structure_DSGE_MS_solution_.tpa=tpa;
structure_DSGE_MS_solution_.y_=y_;
structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
    structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
numm=zeros(nyo,Nh_);
for ih=1:Nh_
    numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
    
end
fevda(:,:,nss+5)=numm./denm;
%% now check for role of measeq
for in=1:nyo
    delta0_=delta0__;
    delta0_(34+in)=delta0(34+in);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(squeeze(structure_conditional_moments_.Sigya(:,:,ih)));
    end
    fevda(:,:,nss+nz2+in)=numm./denm;
end
%%
% remember now to take out the effect of low variance shock from the
% measure of MS role
fevda_=zeros(nyo,Nh_,size(fevda,3)+1);
fevda_(:,:,1:end-1)=fevda;
fevda_(:,:,1:nss)=fevda_(:,:,1:nss)-fevda_(:,:,nss+(1:nss));
fevda_(:,:,end)=numm__./denm;
check_sum=sum(fevda_,3);
fevda_percentage=100*fevda_;
toc;
save('fevda_percentage','fevda_percentage');

