clear; clc;close all;
qv=[.05 .5 .95];
%%
load fevdaa
% ordering of fevdaa  ( 8 x 15 x 41 x 1e+4)
% the 15 sources of shocks are
%  1) G state
%  2) mpol state
%  3) z state
%  4) g shock
%  5) monpol shock
%  6) z shock
%  7) mu
%  8) xi 
%  9) pi me
% 10) dc me
% 11) dy me
% 12) i me
% 13) R12 me
% 14) R40 me
% 15) initial condition
%
ndx_separate_docs=1;
fevdaa_=mean_std_quantiles(fevdaa,qv);
for is=1:ns_
    str_sources{is}=s_str{is};
end
str_shocks=[];
str_shocks{1}='G';
str_shocks{2}='pol';
str_shocks{3}='z';
str_shocks{4}='mu';
str_shocks{5}='xi';
%
for iz2=1:nz2
    str_sources{ns_+iz2}=str_shocks{iz2};
end

for in=1:nyo
    str_sources{ns_+nz2+in}=[str_var{in} ' meas error'];
end
str_sources{ns_+nz2+nyo+1}='initial condition';

str_sources_=str_sources;
str_sources_{1}='G st.'
str_sources_{2}='mpol st.'
str_sources_{3}='zi st.'


% extract what we need (mean, low, upp for sources
% MS shocks, continuous shocks and own meas error
hv=[1 12 40];
%
%here permute to have the ordering with tech shocks together
% ordering will be 
% 1    2        3      4    5    6    7    8    9    10    11    12    13      14       15
% s_G  s_mpol   s_zi   g    eta  z   xi   mu   pi_me dc_me dy_me i_me  i_12_me i_40_me  initial   
str_sources_=str_sources_([1:6 8 7 9:15]);
fevdaa_=fevdaa_(:,[1:6 8 7 9:15],:,:);
%
%modify str_var to avoid _;
    str_var_=str_var;
    str_var{1}='Pi';
    str_var{4}='R1';
    str_var{7}='R12-R1';
    str_var{8}='R40-R1';   
%
for ih=hv
    fevdaa__=permute(squeeze(fevdaa_(:,:,ih,[1 3 5])),[2 1 3]);
    latex_table_content=[];
    if ndx_separate_docs
        latex_table_content{1,1}='\documentclass[a4paper,10pt]{article}';
        latex_table_content{2,1}='\begin{document}';
    else
        latex_table_content{1,1}=[];
        latex_table_content{2,1}=[];
    end
    
    latex_table_content{3,1}='\begin{table}[h!]';
    latex_table_content{4,1}='\centering';
    latex_table_content{5,1}=['\begin{tabular}{|' repmat('c|',1,nyo_+1) '}'];
    latex_table_content{6,1}='\hline';
    latex_table_content{7,1}=[];
    
    for in=1:nyo_
        latex_table_content{7,1}=[latex_table_content{7,1} ' & ' str_var{in}];
    end
    latex_table_content{7,1}=[latex_table_content{7,1} ' \\'];
    latex_table_content{8,1}='\hline';
    
    
    for irow=1:ns_+nz2
        latex_table_content{8+2*(irow-1)+1,1}=str_sources_{irow};
        for icol=1:nyo_
            ccontent=[int2str(round(fevdaa__(irow,icol,1))) '[' int2str(round(fevdaa__(irow,icol,2)))    '-'  int2str(round(fevdaa__(irow,icol,3)))      ']'];
            latex_table_content{8+2*(irow-1)+1,1}=[latex_table_content{8+2*(irow-1)+1,1} ...
                ' & ' ccontent];
        end
        % add \\
        latex_table_content{8+2*(irow-1)+1,1}=[latex_table_content{8+2*(irow-1)+1,1} ' \\'];
        latex_table_content{8+2*(irow-1)+2,1}='\hline';
        %
        % own measurement errors
    end
    latex_table_content{8+2*(ns_+nz2)+1,1}='own m.e.';
    for icol=1:nyo_
        if icol>nyo
            ccontent='--';
        else
            ccontent=[int2str(round(fevdaa__(ns_+nz2+icol,icol,1))) '[' int2str(round(fevdaa__(ns_+nz2+icol,icol,2)))    '-'  int2str(round(fevdaa__(ns_+nz2+icol,icol,3)))      ']'];
        end
        latex_table_content{8+2*(ns_+nz2)+1,1}=[latex_table_content{8+2*(ns_+nz2)+1,1} ...
            ' & ' ccontent];
    end
    % add \\
    latex_table_content{8+2*(ns_+nz2)+1,1}=[latex_table_content{8+2*(ns_+nz2)+1,1} ' \\'];
    latex_table_content{8+2*(ns_+nz2)+2,1}='\hline';
    
    % finish the table
    latex_table_content{8+2*(ns_+nz2)+3,1}='\end{tabular}';
    latex_table_content{8+2*(ns_+nz2)+4,1}=['\caption{Variance decomposition ' int2str(ih) '-step-ahead}'];
    latex_table_content{8+2*(ns_+nz2)+5,1}=['\label{table:FEVD_' int2str(ih) '}'];
    latex_table_content{8+2*(ns_+nz2)+6,1}='\end{table}';
    if ndx_separate_docs
        latex_table_content{8+2*(ns_+nz2)+7,1}='\end{document}';
    end
    
    % write the table
    tablefilename=['FEVD_' int2str(ih) '.tex'];
    if exist(tablefilename,'file')==2
        if ispc
            system(['del ' tablefilename ]);
        else
            system(['rm ' tablefilename ]);
        end
    end
    diary(['FEVD_' int2str(ih) '.tex']);
    disp(char(latex_table_content{:}));
    diary off
end
%%

%