clear; clc; close all;
%% section 0: general inputss
model_name='RATTS_2020';
nthin_=20;
Nh_=41; % horizon for FEVD computations
nh=20;% horizon for graph display
qv_=[.05 .5 .95];
%% section 1 load results and perform various computations
load(['../../' model_name '_results_postproc']);
nthin=nthin_;
qv=qv_;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% Section 2: computation of FEVD
% 2.1: computation of IRFs to regime switches
M0=M/nthin;
fevdaa=zeros(nyo_,ns_+nz2+nyo+1,Nh_,M0);
param_=zeros(M0,np);
%
for im=1:M0
%for im=1:M0
    delta0=param((im-1)*nthin+1,1:np)';
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    param_(im,:)=delta0';
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    [retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    retcode0=retcode0+(retcode==0);
    structure_DSGE_MS_solution.a_i=a_i;
    structure_DSGE_MS_solution.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution.A2=A2;
    structure_DSGE_MS_solution.B_i=B_i;
    structure_DSGE_MS_solution.c_j=c_j;
    structure_DSGE_MS_solution.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution.C2=C2;
    structure_DSGE_MS_solution.D=D;
    structure_DSGE_MS_solution.tpa=tpa;
    structure_DSGE_MS_solution.y_=y_;
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution,Pm(end,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh_);
    denm=zeros(nyo_,Nh_); 
    for ih=1:Nh_
        denm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    %
    fevda=zeros(nyo_,nss+nz2+nyo,Nh_);
    %% set delta0__ with all variances set to zero
    % FEV matrices based on this account only for the role of initial condition
    delta0__=delta0;
    delta0__([(7:14) (35:40)])=0;
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0__,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,~,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0__);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution__.a_i=a_i;
    structure_DSGE_MS_solution__.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution__.A2=A2;
    structure_DSGE_MS_solution__.B_i=B_i;
    structure_DSGE_MS_solution__.c_j=c_j;
    structure_DSGE_MS_solution__.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution__.C2=C2;
    structure_DSGE_MS_solution__.D=D;
    structure_DSGE_MS_solution__.tpa=tpa;
    structure_DSGE_MS_solution__.y_=y_;
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution__,Pm(end,:)',squeeze(Za(end,:,:)),squeeze(Qa(end,:,:,:)),Nh_);
    numm__=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm__(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    %% now set also initial component to zero
    structure_conditional_moments =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution__,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm___=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm___(:,ih)=diag(Trm_*squeeze(structure_conditional_moments.Sigya(:,:,ih))*Trm_');
    end
    % this has been checked to be equal to zero
    %% now solve with std_G0<std_G1
    delta0_=delta0__;
    delta0_(7:8)=delta0(7:8);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    %
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,1,:)=numm./denm;
    %% now solve with std_pol0<std_pol1
    delta0_=delta0__;
    delta0_(9:10)=delta0(9:10);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,2,:)=numm./denm;
    %% now solve with std_z0<std_z1
    delta0_=delta0__;
    delta0_(11:12)=delta0(11:12);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,3,:)=numm./denm;
    %% now solve with std_G1=std_G0~=0
    delta0_=delta0__;
    delta0_(7:8)=delta0(7);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+1,:)=numm./denm;
    %% now solve with std_pol1=std_pol0~=0
    delta0_=delta0__;
    delta0_(9:10)=delta0(9);
    
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+2,:)=numm./denm;
    %% now solve with std_z1=std_z0=0
    delta0_=delta0__;
    delta0_(11:12)=delta0(11);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+3,:)=numm./denm;
    %% now solve with stdmu=0;
    delta0_=delta0__;
    delta0_(13)=delta0(13);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
    end
    fevda(:,nss+4,:)=numm./denm;
    %% now solve with stdxi=0;
    delta0_=delta0__;
    delta0_(14)=delta0(14);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    structure_DSGE_MS_solution_.a_i=a_i;
    structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
    structure_DSGE_MS_solution_.A2=A2;
    structure_DSGE_MS_solution_.B_i=B_i;
    structure_DSGE_MS_solution_.c_j=c_j;
    structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
    structure_DSGE_MS_solution_.C2=C2;
    structure_DSGE_MS_solution_.D=D;
    structure_DSGE_MS_solution_.tpa=tpa;
    structure_DSGE_MS_solution_.y_=y_;
    structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
        structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
    numm=zeros(nyo_,Nh_);
    for ih=1:Nh_
        numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        
    end
    fevda(:,nss+5,:)=numm./denm;
    %% now check for role of measeq
    for in=1:nyo
        delta0_=delta0__;
        delta0_(34+in)=delta0(34+in);
        eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0_,n1,n2,n3,n4);']);
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
        %[retcode,lnlv,pyta_ij,Za,Qa,Pm,P01a,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_2(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
        structure_DSGE_MS_solution_.a_i=a_i;
        structure_DSGE_MS_solution_.A1=A1_i(:,:,1);
        structure_DSGE_MS_solution_.A2=A2;
        structure_DSGE_MS_solution_.B_i=B_i;
        structure_DSGE_MS_solution_.c_j=c_j;
        structure_DSGE_MS_solution_.C1=C1_j(:,:,1);
        structure_DSGE_MS_solution_.C2=C2;
        structure_DSGE_MS_solution_.D=D;
        structure_DSGE_MS_solution_.tpa=tpa;
        structure_DSGE_MS_solution_.y_=y_;
        structure_conditional_moments_ =DSGE_MS_pruned_conditional_moments(...
            structure_DSGE_MS_solution_,Pm(end,:)',0*squeeze(Za(end,:,:)),0*squeeze(Qa(end,:,:,:)),Nh_);
        numm=zeros(nyo_,Nh_);
        for ih=1:Nh_
            numm(:,ih)=diag(Trm_*squeeze(structure_conditional_moments_.Sigya(:,:,ih))*Trm_');
        end
        fevda(:,nss+nz2+in,:)=numm./denm;
    end
    %%
    % remember now to take out the effect of low variance shock from the
    % measure of MS role
    fevda_=zeros(nyo_,size(fevda,2)+1,Nh_);
    fevda_(:,1:end-1,:)=fevda;
    fevda_(:,1:nss,:)=fevda_(:,1:nss,:)-fevda_(:,nss+(1:nss),:);
    fevda_(:,end,:)=numm__./denm;
%     sum(fevda_,3)
    fevda_percentage=100*fevda_;
%     save('fevda_percentage','fevda_percentage');
    fevdaa(:,:,:,im)=fevda_percentage;
    clc;
    im/M0
end
%
save('fevdaa','fevdaa');
%% make graphs
str_sources=[];
for is=1:ns_
    str_sources{is}=s_str{is};
end

% here the ordering of the shocks is different with respect to that in the
% columns of Beta_i
% str_shocks=[];
% str_shocks{1}='xi';
% str_shocks{2}='z';
% str_shocks{3}='pol';
% str_shocks{4}='mu';
% str_shocks{5}='G';
%
str_shocks=[];
str_shocks{1}='G';
str_shocks{2}='monpol';
str_shocks{3}='z';
str_shocks{4}='mu';
str_shocks{5}='xi';
%

for iz2=1:nz2
    str_sources{ns_+iz2}=str_shocks{iz2};
end

for in=1:nyo
    str_sources{ns_+nz2+in}=[str_var{in} ' meas error'];
end
str_sources{ns_+nz2+nyo+1}='initial condition';
%%
%
fevdaa_=mean_std_quantiles(fevdaa,qv);
for in=1:nyo_
    figure(in);
    ymin=0;
    ymax=100;
    figure(in);
    ndx_source_in=[(1:ns_+nz2) ns_+nz2+find(Trm_(in,:)~=0) ns_+nz2+nyo+1];
    ig=0;
    for isou=ndx_source_in
        % work here 2015 12 15 @ 1810
        ig=ig+1;
        subplot(ceil(numel(ndx_source_in)/3),3,ig);
        yyymat=squeeze(fevdaa_(in,isou,1:nh,[1 3 4 5]));
        plot((1:nh)',yyymat(:,1),'LineWidth',2,'Color','red');
        hold on;
        plot((1:nh)',yyymat(:,3),'LineWidth',1,'LineStyle','--','Color','blue');
        %
        hh=fill([(1:nh) fliplr(1:nh)],[yyymat(:,4)' fliplr(yyymat(:,2)')],'b');
        alpha(hh,.05);
        %
        hold off;
        ylabel(str_var(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([1 nh]);
        ylim([ymin ymax]);
        title(str_sources(isou),'FontSize',12);
    end
    figure_filename=['figure_FEVD_' str_var{in}];
    saveas(in,figure_filename,'fig');
    print(in,'-dpsc2',figure_filename);
    print(in,'-dpdf',figure_filename);
end
    close all;
    
% %% section to make the tables
% hv=[1 8 12 40];
% fevda_tables=zeros((ns_+nz2+nyo),nyo,3,numel(hv));
% ih_=0;
% for ih=hv
%     ih_=ih_+1;
%         
% end
%%
save fevdaa
