clear; clc; close all;
%% section 0: general inputss
model_name='RATTS_2020';
nthin_=2;
Nh_=41; % horizon for FEVD computations
nh=20;% horizon for graph display
qv_=[.05 .5 .95];
%% section 1 load results and perform various computations
load(['../../' model_name '_results_postproc']);
%load(['../' model_name '_results']);

nthin=nthin_;
qv=qv_;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% Section 2: computation of FEVD
% 2.1: computation of IRFs to regime switches
M0=M/nthin;
fevdaa=zeros(nyo_,ns_+nz2+nyo+1,Nh_,M0);
param_=zeros(M0,np);
%
load fevdaa;
%% make graphs
str_sources=[];
for is=1:ns_
    str_sources{is}=s_str{is};
end

% here the ordering of the shocks is different with respect to that in the
% columns of Beta_i
% str_shocks=[];
% str_shocks{1}='xi';
% str_shocks{2}='z';
% str_shocks{3}='pol';
% str_shocks{4}='mu';
% str_shocks{5}='G';
%
str_shocks=[];
str_shocks{1}='G';
str_shocks{2}='monpol';
str_shocks{3}='z';
str_shocks{4}='mu';
str_shocks{5}='xi';
%




for iz2=1:nz2
    str_sources{ns_+iz2}=str_shocks{iz2};
end

for in=1:nyo
    str_sources{ns_+nz2+in}=[str_var{in} ' meas error'];
end
str_sources{ns_+nz2+nyo+1}='initial condition';


% now rearrange fevdaa to have responses of shocks in the following order
% 1 to 3: variance state allocation shocks 
%
% 4 to 8% structural shocks in the order reported for IRFs and Historical
%      Decomposition, ie corresponding to the columns of Beta_i:
%      {4}='xi';
%      {5}='z';
%      {6}='pol';
%      {7}='mu';
%      {8}='G';
%
% str_shocks{4}='G';
% str_shocks{5}='monpol';
% str_shocks{6}='z';
% str_shocks{7}='mu';
% str_shocks{8}='xi';
%

% 
% 9 to 15: measurement errors with the same ordering as variables 
% 16: initial condition
%
ndx_shocks_perm=[(1:ns_)'; [8 6 5 7 4]'; (9:15)' ];
fevdaa=fevdaa(:,ndx_shocks_perm,:,:);
str_sources=str_sources(ndx_shocks_perm);
%%
str_var_names=str_var;
str_var_names{7}='R12_I_t';
str_var_names{8}='R40_I_t';
%%
%
fevdaa_=mean_std_quantiles(fevdaa,qv);
for in=1:nyo_
    figure(in);
    ymin=0;
    ymax=100;
    figure(in);
    ndx_source_in=[(1:ns_+nz2) ns_+nz2+find(Trm_(in,:)~=0) ns_+nz2+nyo+1];
    ig=0;
    for isou=ndx_source_in
        % work here 2015 12 15 @ 1810
        ig=ig+1;
        subplot(ceil(numel(ndx_source_in)/3),3,ig);
        yyymat=squeeze(fevdaa_(in,isou,1:nh,[1 3 4 5]));
        plot((1:nh)',yyymat(:,1),'LineWidth',2,'Color','red');
        hold on;
        plot((1:nh)',yyymat(:,3),'LineWidth',1,'LineStyle','--','Color','blue');
        %
        hh=fill([(1:nh) fliplr(1:nh)],[yyymat(:,4)' fliplr(yyymat(:,2)')],'b');
        alpha(hh,.05);
        %
        hold off;
        ylabel(str_var(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([1 nh]);
        ylim([ymin ymax]);
        title(str_sources(isou),'FontSize',12);
    end
    figure_filename=['figure_FEVD_' str_var_names{in}];
    saveas(in,figure_filename,'fig');
    print(in,'-dpsc2',figure_filename);
    print(in,'-dpdf',figure_filename);
end
    close all;
    
