clear; clc;
if isunix && ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/research/matlab_code'));
end
% ====================================================
% to read parameter values
load ../../RATTS_2020_results;
param=param(:,1:np);
save param.mat param;
clear all;
%%
M=5e+3;
nh=40;
% Number of predetermined variables
n1 = 9 ;
% Number of non-predetermined variables
n2 = 9 ;
% Position of observable in non-predetermined vector
% pie,deltaC,deltaY, r
% NOTE: it does not take into account the yield
n3 = [1,8,9,5];
% Maturities used in estimation (in quarters)
n4 = [12,40];   % 3 and 5 years

%
ns=8;
nz=n1;
nz2=5;
ny=length(n3)+length(n4);
nme=ny;

% ====================================================
% Parameters
% ====================================================
%load delta0;
%load deltam;
load param;
load Yo_mv;
Yo_mv=Yo;
load Yo;
%deltav=delta0;
M_=size(param,1);
nthin=M_/M;
param_=param;
param=param(1:nthin:M_,1:40);
%%

% inputs
T=length(datesv);
SRm=zeros(8,M);
smoSR=zeros(T,M);
filSR=zeros(T,M);
%
%T0=find(datesv==2009);
%
for im=1:M
    deltav=param(im,:)';
    %deltav=delta0;
    [retcode,y,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia,SR] =       RATTS_2020_modsol_Klein_3(2,deltav,n1,n2,n3,n4);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    SRm(:,im)=SR';
    smoSR(:,im)=sm*SR';
    filSR(:,im)=pm*SR';
    
    clc;
    im/M
end

save SRs datesv SRm smoSR filSR;
%%
figure(1);
plot(datesv,[mean(smoSR,2) mean(filSR,2)],'LineWidth',3);
title('Smoothed (blue) and filtered (red) maximal Sharpe Ratios');
    set(gca,'FontSize',16)
orient(1,'portrait');
print(1,'-fillpage','maximal_SRs.pdf','-dpdf');
