clear;clc;close all;
% 4 way premia comparison (exhprs,EH_premia,DS,ACM)
%
%load results from model
load forecasts;
load Yo;
load ../premia_with_bands/premia.mat;
load RS_premia.mat;
%
% compute model premia
model_premia=400*([Yo(:,5)-EHdatam(:,1) Yo(:,6)-EHdatam(:,2)]);
% compute exhprs
exhprs=400*squeeze(filpremia(:,:,1));
% compute DS premia
RS_premia=400*mean(squeeze(Yfa(:,5:6,1,:)-Yfa_EH(:,5:6,1,:)),3);

% Quarterly ACM premia
[ACMvar,ACMlabels,ACMraw]=xlsread('ACMTermPremium.xlsx','ACM Monthly','A1:AE710');
% dd=datetime(cell2str(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
dd=datetime(string(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
ACMlabels = ACMlabels(1,2:end) ;
% timeline = datetime(year(dd(1)),6,30):calmonths(3):datetime(year(dd(end)),month(dd(end)),30);
timeline = datetime(1966,3,31):calmonths(3):datetime(2019,12,31);
timeline = timeline';
ACMvarQ = zeros(length(timeline),size(ACMvar,2));
for i_yy = 1966:2019
    for i_qq = 1:4
        ACMvarQ(4*(i_yy-1966)+i_qq,:) = ACMvar(year(dd)==i_yy & month(dd)==3*i_qq,:) ;
    end
end
% ACMvarQ(end-1,:) = ACMvar(year(dd)==2020 & month(dd)==3,:) ;
% ACMvarQ(end,:) = ACMvar(year(dd)==2020 & month(dd)==6,:) ;

figure
plot(timeline, ACMvarQ(:,[20 13]));
legend(ACMlabels([20 13]));
title('Term premia in ACM model') ;

figure
plot(timeline, ACMvarQ(:,[30 23]));
legend(ACMlabels([30 23]));
title('Risk neutral yields in ACM model') ;
% premia comparisons
figure(3)
subplot(2,1,1)
plot(datesv,[ACMvarQ(1:end-3,13) model_premia(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,[ACMvarQ(1:end-3,20) model_premia(:,2)],'LineWidth',3);
set(gca,'FontSize',16)
sgtitle('Premia, ACM(blue) and MS-DSGE (red)','FontSize',16);
orient(3,'portrait');
print(3,'-fillpage','premia_comparison_ACM.pdf','-dpdf');


% risk neutral comparisons
figure(4)
subplot(2,1,1)
plot(datesv,[ACMvarQ(1:end-3,23) 400*EHdatam(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,[ACMvarQ(1:end-3,30) 400*EHdatam(:,2)],'LineWidth',3);
set(gca,'FontSize',16)
sgtitle('Risk neutral rates, ACM(blue) and MS-DSGE (red)','FontSize',16);
orient(4,'portrait');
print(4,'-fillpage','rn_rates_comparison_ACM.pdf','-dpdf');

% comparison ACM vs exhprs
figure(5)
subplot(2,1,1)
plot(datesv,ACMvarQ(1:end-3,13) ,'LineWidth',3);
hold on;
plot(datesv(1:size(exhprs,1)),exhprs(:,1),'LineWidth',3);
hold off;
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,ACMvarQ(1:end-3,20) ,'LineWidth',3);
hold on;
plot(datesv(1:size(exhprs,1)),exhprs(:,2),'LineWidth',3);
hold off;
set(gca,'FontSize',16)
sgtitle('Premia, ACM(blue) and MS-DSGE exhprs (red)','FontSize',16);
orient(5,'portrait');
print(5,'-fillpage','premia_comparison_exhprs_ACM.pdf','-dpdf');





% comparison ACM vs RS premia
figure(6)
subplot(2,1,1)
plot(datesv,[ACMvarQ(1:end-3,13) RS_premia(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,[ACMvarQ(1:end-3,20) RS_premia(:,2)],'LineWidth',3);
set(gca,'FontSize',16)
sgtitle('Premia, ACM(blue) and MS-DSGE RS (red)','FontSize',16);
orient(6,'portrait');
print(6,'-fillpage','premia_comparison_RS_ACM.pdf','-dpdf');
%%
% comparison exhprs premia_EH RS_premia
figure(7)
for in=1:2
    
    subplot(2,1,in)
    plot(datesv(1:size(exhprs),1),exhprs(:,in),'LineWidth',3);
    hold on;
    plot(datesv,[model_premia(:,in) RS_premia(:,in)],'LineWidth',3);
    hold off;    
    set(gca,'FontSize',16)
    xlim(datesv([1 end]));
    ylim([0 4]);
end
sgtitle('exhprs(blue), premia\_vs\_EH (red), RS\_premia (yellow)','FontSize',16);
orient(7,'portrait');
print(7,'-fillpage','exhprs_EH_RS.pdf','-dpdf');
%
% construct the correlation matrix
% exhprs premia_vs_EH RS_premia ACM
cm1=corr([exhprs(:,1) model_premia(1:size(exhprs,1),1) RS_premia(1:size(exhprs,1),1)  ACMvarQ(1:size(exhprs,1),13)]);
cm2=corr([exhprs(:,2) model_premia(1:size(exhprs,1),2) RS_premia(1:size(exhprs,1),2)  ACMvarQ(1:size(exhprs,1),20)]);
corm=cm1;
for im=2:4
    for jm=1:im-1
    corm(im,jm)=cm2(im,jm);
    end
end
for im=1:4
    corm(im,im)=NaN
end


    column_label={'exhprs','EH\_premia','RS\_premia','ACM'};
    row_label=column_label;
    input.data=corm;
    input.tableColLabels =column_label;
    input.tableRowLabels =row_label;
    input.transposeTable = 0;
    % Determine whether input.dataFormat is applied column or row based:
    input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
    input.dataFormat = {'%1.3f',4}; % three digits precision for first two columns, one digit for the last
    % Define how NaN values in input.tableData should be printed in the LaTex table:
    input.dataNanString = '-';
    % Column alignment in Latex table ('l'=left-justified,'c'=centered,'r'=right-justified):
    input.tableColumnAlignment = 'r';
    % Switch table borders on/off:
    input.tableBorders = 1;
    % LaTex table caption:
    input.tableCaption = ['Correlation matrix across premia'];
    % LaTex table label:
    input.tableLabel = 'Premia_correlation_matrix';
    % Switch to generate a complete LaTex document or just a table:
    input.makeCompleteLatexDocument = 0;
    % call latexTable:
    latex = latexTable(input);
    latex=strrep(latex,'H!','htbp');
    %latex=strrep(latex,'{table}','{sidewaystable}');
    %latex=strrep(latex,'_','\_');
    if exist([input.tableLabel '.tex'],'file')
        system(['rm ' input.tableLabel '.tex']);
    end
    diary([input.tableLabel '.tex']);
    disp(char(latex));
    diary off;





