clear;clc;close all;
%load results from model
load forecasts;
load Yo;

% compute model premia
model_premia=400*([Yo(:,5)-EHdatam(:,1) Yo(:,6)-EHdatam(:,2)]);


% Quarterly ACM premia

[ACMvar,ACMlabels,ACMraw]=xlsread('ACMTermPremium.xlsx','ACM Monthly','A1:AE710');
% dd=datetime(cell2str(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
dd=datetime(string(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
ACMlabels = ACMlabels(1,2:end) ;

% timeline = datetime(year(dd(1)),6,30):calmonths(3):datetime(year(dd(end)),month(dd(end)),30);
timeline = datetime(1966,3,31):calmonths(3):datetime(2019,12,31);
timeline = timeline';

ACMvarQ = zeros(length(timeline),size(ACMvar,2));
for i_yy = 1966:2019
    for i_qq = 1:4
        ACMvarQ(4*(i_yy-1966)+i_qq,:) = ACMvar(year(dd)==i_yy & month(dd)==3*i_qq,:) ;
    end
end
% ACMvarQ(end-1,:) = ACMvar(year(dd)==2020 & month(dd)==3,:) ;
% ACMvarQ(end,:) = ACMvar(year(dd)==2020 & month(dd)==6,:) ;

figure
plot(timeline, ACMvarQ(:,[20 13]));
legend(ACMlabels([20 13]));
title('Term premia in ACM model') ;

figure
plot(timeline, ACMvarQ(:,[30 23]));
legend(ACMlabels([30 23]));
title('Risk neutral yields in ACM model') ;
% premia comparisons
figure(3)
subplot(2,1,1)
plot(datesv,[ACMvarQ(1:end-3,13) model_premia(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,[ACMvarQ(1:end-3,20) model_premia(:,2)],'LineWidth',3);
set(gca,'FontSize',16)
sgtitle('Premia, ACM(blue) and MS-DSGE (red)','FontSize',16);
orient(3,'portrait');
print(3,'-fillpage','premia_comparison_ACM.pdf','-dpdf');


% risk neutral comparisons
figure(4)
subplot(2,1,1)
plot(datesv,[ACMvarQ(1:end-3,23) 400*EHdatam(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,1,2)
plot(datesv,[ACMvarQ(1:end-3,30) 400*EHdatam(:,2)],'LineWidth',3);
set(gca,'FontSize',16)
sgtitle('Risk neutral rates, ACM(blue) and MS-DSGE (red)','FontSize',16);
orient(4,'portrait');
print(4,'-fillpage','rn_rates_comparison_ACM.pdf','-dpdf');










