clear; clc;
if isunix && ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/research/matlab_code'));
end
% ====================================================
% to read parameter values
load ../../RATTS_2020_results;
param=param(:,1:np);
save param.mat param;
clear all;
%%
M=1e+4;
nh=40;
% Number of predetermined variables
n1 = 9 ;
% Number of non-predetermined variables
n2 = 9 ;
% Position of observable in non-predetermined vector
% pie,deltaC,deltaY, r
% NOTE: it does not take into account the yield
n3 = [1,8,9,5];
% Maturities used in estimation (in quarters)
n4 = [12,40];   % 3 and 5 years

%
ns=8;
nz=n1;
nz2=5;
ny=length(n3)+length(n4);
nme=ny;

% ====================================================
% Parameters
% ====================================================
%load delta0;
%load deltam;
load param;
load Yo_mv;
Yo_mv=Yo;
load Yo;
%deltav=delta0;
M_=size(param,1);
nthin=M_/M;
param_=param;
param=param(1:nthin:M_,1:40);
%%

% inputs
T=length(datesv);
%
% construct recipients for stored series
% T obs, ny vars, 2 modes(avg across discrete states and cond. on drawn state), M param draws
Yfa    = zeros(T,ny,2,M); 
Yfa_EH = zeros(T,ny,2,M); 
for im=1:M
    deltav=param(im,:)';
    %deltav=delta0;
    % solve the model with order =2
    [~,y,gx,hx,gxx,hxx,gss,hss,eta,etastd] =       RATTS_2020_modsol_Klein_(2,deltav,n1,n2,n3,n4);
    % now solve the model with routine that computes EH state space  matrices
    [~,y_,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,gx_EH,gxx_EH,gss_EH] = ...
        RATTS_2020_modsol_Klein_EH(2,deltav,n1,n2,n3,n4);
    % now compute the state space matrices used for filtering (both for baseline and EH) 
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [~,~,~,~,c_j_,C1_j_,C2_,D_,~,~,~,~,~,~,~] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_EH,hx_,gxx_EH,hxx_,gss_EH,hss_,eta_,etastd_,deltav);
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    solution_matrices=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,a_i_,A1_i_);
    % make room for
    
    for it=1:T
        Z_tt=squeeze(Za(it,:,:));
        Qa_tt=squeeze(Qa(it,:,:,:));
        pi_tt=pm(it,:)';
        % now take pi_tt, filtered prob od state s_t at time t
        pv=pi_tt;
        % 1) average across discrete states
        yt   =zeros(ny,1);
        yt_EH=zeros(ny,1);
        for is=1:ns
        z0=Z_tt(:,is);
            yt    = yt    + pi_tt(is)*((c_j(  :,is)+C1_j(  :,:,is)*z0+C2 * vech_(z0*z0')));
            yt_EH = yt_EH + pi_tt(is)*((c_j_( :,is)+C1_j_( :,:,is)*z0+C2_* vech_(z0*z0')));;
        end
        Yfa(   it,:,1,im) = yt'   ;
        Yfa_EH(it,:,1,im) = yt_EH';
        % 
        % 2) condition on a draw on state s_t
        s0=draw_multinom(pi_tt,1,ns,1);
        z0=Z_tt(:,s0);
        Yfa(   it,:,2,im) = (c_j( :,s0)+C1_j( :,:,s0)*z0+C2* vech_(z0*z0'))';
        Yfa_EH(it,:,2,im) = (c_j_(:,s0)+C1_j_(:,:,s0)*z0+C2_*vech_(z0*z0'))';
    end
    clc;
    im/M
end
%% save results on RS_premia
str_var={'Inflation','Delta C','Delta Y', 'I','R12','R40'};
save RS_premia datesv str_var Yfa Yfa_EH ;
Yf=mean(Yfa,4);
Yf_EH=mean(Yfa_EH,4);
%%
figure(1);
for in=1:6
    subplot(3,2,in);
    plot(datesv,squeeze(Yf(:,in,:)));
end
