clear; clc;
addpath(genpath('/Users/giovanniamisano/Documents/gianni/research/matlab_code'));
M=5e+3;
nh=40;
% Number of predetermined variables
n1 = 9 ;
% Number of non-predetermined variables
n2 = 9 ;
% Position of observable in non-predetermined vector
% pie,deltaC,deltaY, r
% NOTE: it does not take into account the yield
n3 = [1,8,9,5];
% Maturities used in estimation (in quarters)
n4 = [12,40];   % 3 and 5 years

%
ns=8;
nz=n1;
nz2=5;
ny=length(n3)+length(n4);
nme=ny;

% ====================================================
% Parameters
% ====================================================
load delta0;
load deltam;
load Yo_mv;
Yo_mv=Yo;
load Yo;
T_end=find(datesv==2009);
Yo=Yo(1:T_end,:);
datesv=datesv(1:T_end);

%%
%deltav=delta0;
param=deltam;
M_=size(param,1);
nthin=M_/M;
param_=param;
param=param(1:nthin:M_,1:40);
%%

% inputs
T=length(datesv);
dataa=zeros(nz+ny,T,nh+1,M);
%
%T0=find(datesv==2009);
%
for im=1:M
    deltav=param(im,:)';
    %deltav=delta0;
    [~,y,gx,hx,gxx,hxx,gss,hss,eta,etastd] =       RATTS_2020_modsol_Klein_(2,deltav,n1,n2,n3,n4);
    [retcode_,y_,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_] = RATTS_2020_modsol_Klein_(1,deltav,n1,n2,n3,n4);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,deltav);
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    solution_matrices=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,a_i_,A1_i_);
    for it=1:T
        Z_tt=squeeze(Za(it,:,:));
        Qa_tt=squeeze(Qa(it,:,:,:));
        pi_tt=pm(it,:)';
        % now get a draw from initial state
        sv0=zeros(nh+2,1);
        pv=pi_tt;
        %s0=draw_multinom(pi_tt,1,ns,0);
        %s0=sv0(1);
        for ih=1:nh+2
            s0=draw_multinom(pv,1,ns,1);
            pv=ctp(s0,:)';
            sv0(ih)=s0;
        end
        % now pick the starting point
        z0=Z_tt(:,sv0(1))+0*chol(Qa_tt(:,:,sv0(1)))*randn(nz,1);
        % specify continuous shocks
        em=randn(nz2+nme,nh+1);
        dataa(:,it,:,im) = DSGE_MS_dynamic_simulation(solution_matrices,z0,em,sv0,1);
        %}
    end
    clc;
    im/M
end
%%

forecast_array=mean_std_quantiles(dataa,[.05 .5 .95 ]');


% construct the EH rates
EHdatam=zeros(T,2);
for it=1:T
    % 12 period rate
    EHdatam(it,1)=mean([Yo(it,4);squeeze(forecast_array(nz+4,it,1:11,1))]);
    EHdatam(it,2)=mean([Yo(it,4);squeeze(forecast_array(nz+4,it,1:39,1))]);
    
end
save forecasts forecast_array datesv EHdatam;
%%
str_var={'Inflation','Delta C','Delta Y', 'I','R12','R40'};

figure(1);
for in=1:ny
    subplot(3,2,in);  
    plot(datesv,400*[ Yo(:,in) squeeze(forecast_array(9+in,:,[1 40],1))],'LineWidth',3);
    title(str_var{in});
    set(gca,'FontSize',16)
end
sgtitle('Actual (blue), 1 step (red), 40 step ahead forecast (yellow)','FontSize',16)
orient(1,'portrait');
print(1,'-fillpage','conditional_forecasts.pdf','-dpdf');

%
figure(2);
for in=1:ny
    subplot(3,2,in);
    plot(datesv,400*squeeze(forecast_array(9+in,:,[1 12 40],2)),'LineWidth',3);
    title(str_var{in});
    set(gca,'FontSize',16)
end
sgtitle('1 , 12, 40 step ahead standard deviations (blue, red, yellow)','FontSize',16);
orient(2,'portrait');
print(2,'-fillpage','conditional_std.pdf','-dpdf');


figure(3);
subplot(2,2,1);
plot(datesv,400*[Yo(:,5) EHdatam(:,1)],'LineWidth',3);
set(gca,'FontSize',16)
subplot(2,2,2);
plot(datesv,400*[Yo(:,5)-EHdatam(:,1)],'LineWidth',3)
set(gca,'FontSize',16)
subplot(2,2,3);
plot(datesv,400*[Yo(:,6) EHdatam(:,2)],'LineWidth',3)
set(gca,'FontSize',16)
subplot(2,2,4);
plot(datesv,400*[Yo(:,6)-EHdatam(:,2)],'LineWidth',3)
set(gca,'FontSize',16)
sgtitle('Long term rates, their EH equivalent and difference','FontSize',16);
orient(3,'portrait');
print(3,'-fillpage','EH_rates.pdf','-dpdf');

