%% new script for making charts with forward rates
clear; clc; close all;
if isunix & ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/ricerca/matlab_code'));
end
%% section 0: general inputs
model_name='RATTS_2020';
M00=1e+3;
qv0=[.025 .5 .975]';
ndx_postmean=0;
%% section 1 load results
% need to check on where to go and get the file
load(['../../' model_name '_results_postproc']);
%% section 4: compute all maturities from the model
M0=M00;
Mthin=M/M0;
n4_=2:41; % extended vector of maturities
ndx_Yo=[1 2 3 4 15 43];
%nspread=2;
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
Ysa=zeros(T,44,M0);
Yfa=zeros(T,44,M0);
for im=1:M0
    if ndx_postmean
    delta0=mean(param(:,1:np))';
    else
        delta0=param(Mthin*(im-1)+1,1:np)';
    end
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4_);']);
    %delta0_=[delta0(1:end-2);reshape(repmat(delta0(end-1:end)',2,1),4,1)];
    %delta0_=[delta0;zeros(38,1)];
    deltame=zeros(40,1);
    deltame([1 n4])=delta0(end-2:end);
    delta0_=[delta0(1:end-3);deltame];
    [a_i,A1_i,A2,B_i,c_j_,C1_j_,C2_,D_,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0_);
    c_j=c_j_(ndx_Yo,:);
    C1_j=C1_j_(ndx_Yo,:,:);
    C2=C2_(ndx_Yo,:);
    D=D_(ndx_Yo,ndx_Yo);
    
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
    DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);

    
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    Zfm=zeros(T,nx);
    Zsm=zeros(T,nx);
    for ics=1:ncs
        Zfm=Zfm+Za(:,:,ics).*repmat(Pm(:,ics),1,nx);
        Zsm=Zsm+Za(:,:,ics).*repmat(Sm(:,ics),1,nx);        
    end
    Yfm=Pm*c_j_'+Zfm*C1_j_(:,:,1)'+(C2_*quadc1(Zfm'))';
    Ysm=Sm*c_j_'+Zsm*C1_j_(:,:,1)'+(C2_*quadc1(Zsm'))';    
    Yfa(:,:,im)=Yfm;
    Ysa(:,:,im)=Ysm;   
    clc;
    im/M0
end
%Yfm=mean(Yfa,3);
%Ysm=mean(Ysa,3);
save('all_maturities','datesv','Yo','Yfa','Ysa');

%% read forward data
opts = spreadsheetImportOptions("NumVariables", 12);
% Specify sheet and range
opts.Sheet = "Sheet1";
opts.DataRange = "A2:L237";
% Specify column names and types
opts.VariableNames = ["obs", "qdatesv", "f01", "f02", "f03", "f04", "f05", "f06", "f07", "f08", "f09", "f10"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];
% Import the data
RATTS2020fwd = readtable("../../RATTS_2020_fwd.xlsx", opts, "UseExcel", false);
% Convert to output type
forwardm = table2array(RATTS2020fwd);
fdatesv=forwardm(21:end,2);
forwardm=forwardm(21:end,3:end);
% Clear temporary variables
clear  opts RATTS2020fwd;
% now pair the sample size of forwards with the one of the estimated model 
forwardm=forwardm(find(fdatesv==datesv(1)):find(fdatesv==datesv(end)),:);
%% here compute filtered model-based forwards
ffilt = zeros(size(Yfm,1),size(Yfm,2)-4) ;
for im = 1:39
    ffilt(:,im) = (im+1)*Yfm(:,im+1+3) - im*Yfm(:,im+3) ;
end
save forward_ready_for_graphs datesv forwardm ffilt;
figure(1)
subplot(2,2,1)
plot1=plot(datesv,[forwardm(:,1) 400*ffilt(:,4)]);
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('1 year ahead forward rate','fontsize',20);
%xlabel('order','fontsize',12);
%ylabel('autocorrelation','fontsize',12);
xlim([datesv(1) datesv(end)]);


subplot(2,2,2)
plot1=plot(datesv,[forwardm(:,3) 400*ffilt(:,12)])
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('3 year ahead forward rate','fontsize',20);
%xlabel('order','fontsize',12);
%ylabel('autocorrelation','fontsize',12);
xlim([datesv(1) datesv(end)]);

subplot(2,2,3)
plot1=plot(datesv,[forwardm(:,10) 400*ffilt(:,40)])

set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2);
set(plot1(2),'Color','b','LineWidth',2);
title('10 year head forward rate','fontsize',20);
legend({'Actual','Model based'},'Location','Best','FontSize',8);

figure_filename='forward_rates';
orient(1,'landscape');
saveas(1,figure_filename,'fig');
saveas(1,figure_filename,'png');
%export_fig(figure_filename,'-zbuffer','-r600')

saveas(1,figure_filename,'bmp');
print(1,'-dpsc2',figure_filename);
print(1,'-dpdf',figure_filename);

close(1);

