clear; clc; close all;
addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
%% section 0: general inputss
model_name='RATTS_2020';
M00=3e+2;
qv0=[.025 .5 .975]';
ind_postmean=0; % if not zero, uses just posterior mean for the parameters
%% section 1 load results and perform various computations
load(['../../' model_name '_results']);

load ../forecasts/Yo_mv;
Yo_mv=Yo;
load ../forecasts/Yo;

T=size(Yo_mv,1);
s_w_match=[0 3 2]'; % to match MS processes with cont. shocks (pistar matched with no cont, shock0

% 1.1 compute one step ahead first and second moments
% this computation is done by extrapolating filtered variables
% caution: it is slow
%% Section 1: some inputs
qv=qv0;
M0=M00;
Mthin=M/M0;
qv_=[.05 .5 .95];
%% section 1 load results and perform various computations
[nz,nz2,ncs]=size(B_i);
nz1=nz-nz2;
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% section 2: HD computations
% prep MCMC containers
    wa_=zeros(T,nz,M00);
    wa =zeros(T,nz2,M00);
    va_=zeros(T,nyo,M00);
    va =zeros(T,nyo,M00);
    dataa=zeros(T,nz+nyo,T,ns_+nz2+nyo+1,M00);
    for im=1:M00
        if ind_postmean
            delta0=param((im-1)*Mthin+1,1:np)';
        else
            delta0=mean(param(:,1:np))';
        end
    if ind_label_constraints
        ind_perm=ones(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    eval(['[retcode_,y__,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,premia_] = ' solution_routine_name '2(1,delta0,n1,n2,n3,n4);']);
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,delta0);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = ...
        DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    solution_str=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,a_i_,A1_i_);
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo_mv,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    sm=make_multivariate_state_indicator(ns_,simstate)';
    ndxm=npermutek([1 0]',ns_);
    %% taking the draws from the simulator smoother and mapping them into shocks
    % recipients
    wm_=zeros(T,nz);
    wm =zeros(T,nz2);
    vm_=zeros(T,nyo);
    vm =zeros(T,nyo);
    zm_=zm;
    ym_=Yo;
    %
    for it=2:T
        s0=simstate(it-1);
        s1=simstate(it);
        z1=	zm(it,:)'; %
        z0=zm(it-1,:)';
        w1_=z1-a_i(:,s0)-A1_i(:,:,s0)*z0-A2*quadc1(z0);
        %w1=B_i(nz1+1:end,:,s0)\w1_(nz1+1:end);
        w1=w1_(nz1+1:end)./diag(B_i(nz1+1:end,:,s0));
%         v1_=Yo(it,:)'-c_j(:,s1)-C1_j(:,:,s1)*z1-C2*quadc1(z1);
%         v1=D\v1_;
        wm_(it,:)=w1_';
        wm(it,:)= w1' ;
%         vm_(it,:)=v1_';
%         vm(it,:)= v1' ;
        %
        z0_=zm_(it-1,:)';
        z1_=a_i(:,s0)+A1_i(:,:,s0)*z0_+A2*quadc1(z0_)+B_i(:,:,s0)*w1;
        zm_(it,:)=z1_';
        %
        v1_=Yo(it,:)'-c_j(:,s1)-C1_j(:,:,s1)*z1_-C2*quadc1(z1_);
        %v1=D\v1_;
        v1=v1_./diag(D);

        vm_(it,:)=v1_';
        vm(it,:)= v1' ;
        ym_(it,:)=(c_j(:,s1)+C1_j(:,:,s1)*z1_+C2*quadc1(z1_)+D*v1);
        
    end
    zm=zm_;
    em=[wm vm]';
    % now create for each observations a history in which only one shock is
    % allowed to be active and all the others are seto to zero. This is
    % done for each t=1:T
    dataa(:,:,:,:,im)=repmat([zm Yo_mv],[1 1 T ns_+nz2+nyo+1]);
    for it=1:T-1
        T_=T-it;
        z0=zm(it,:)'; % starting point
        s0=simstate(it,:);
        % now compute baseline without continuous and discrete shocks
        em_=zeros(nz2+nyo,T_);
        s0v=s0*ones(T_+1,1);
        
        [datam] = DSGE_MS_dynamic_simulation_nh(solution_str,z0,em_,s0v,1);
        dataa(it+1:end,:,it+1,ns_+nz2+nyo+1,im)=datam';
        % now, introduce each of the continuous shocks 
        for ik=1:nz2+nyo
            em_=zeros(nz2+nyo,T_);
            em_(ik,:)=em(ik,it+1:end);
            [datam] = DSGE_MS_dynamic_simulation_nh(solution_str,z0,em_,s0v,1);
            dataa(it+1:end,:,it+1,ns_+ik,im)=datam';
        end
        % now the most complicated bit: allow for one switch at a time
        for is=1:ns_
            iw=s_w_match(is);
            
            T_=T-it;
            sm_=repmat(sm(it,:),T,1); % here we freeze all states to be as at time t
            sm_(:,is)=sm(:,is); % but allow is-th state to switch according to history
            s0v_=zeros(T_+1,1); %generate univariate indicator corresponding to sm_
            for it_=it:T
                s0v_(it_-it+1)=find(sum(ndxm==repmat(sm_(it_,:),ncs,1),2)==ns_);
            end
            em_=zeros(nz2+nyo,T_);
            if iw
                em_(iw,:)=em(iw,it+1:end);
            end
            [datam] = DSGE_MS_dynamic_simulation_nh(solution_str,z0,em_,s0v_,1);
            if iw==0
                dataa(it+1:end,:,it+1,is,im)=datam';
            else
                dataa(it+1:end,:,it+1,is,im)=datam'- ...
                    dataa(it+1:end,:,it+1,ns_+iw,im); % to avoid double counting of effect of cont shocks associated with MS
            end
        end
        
    end
    clc;
    im/M00
    end
    
    
    %{
    
    
    
    
    
    
    
    
    % now for each series plot history without each single shock
    % need to construct an array ya_ (T x nyo x nz2+ncs+1+1); (last page is
    % for series with all the shocks re-appended
    
    
    ya_=zeros(T,nyo,nz2+ns_+1+1);
    % history without single continuous shocks
    for iz=1:nz2
        ya_(1,:,iz)=Yo(1,:)';
        z0=zm(1,:)';
        for it=2:T
            s0=simstate(it-1);
            s1=simstate(it);
            w1=wm(it,:)';
            v1=vm(it,:)';
            w1(iz)=0;
            z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*quadc1(z0)+B_i(:,:,s0)*w1;
            z0=z1;
            y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1)+D*v1;
            ya_(it,:,iz)=y1';
        end
    end
    % history without switching
    for ics=1:ns_
        ya_(1,:,iz)=Yo(1,:)';
        sm_=sm;
        sm_(:,ics)=1; % no switching in column ics;
        % now construct modified indicator
        simstate_=zeros(T,1);
        tic;
        for it=1:T
            sv=sm_(it,:);
            sv=sum(ndxm==repmat(sv,ncs,1),2);
            [simstate_(it),~]=find(sv==ns_);
        end
        z0=zm(1,:)';
        for it=2:T
            s0=simstate_(it-1);
            s1=simstate_(it);
            w1=wm(it,:)';
            v1=vm(it,:)';
            z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*quadc1(z0)+B_i(:,:,s0)*w1;
            z0=z1;
            y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1)+D*v1;
            ya_(it,:,nz2+ics)=y1';
        end
    end
    % now construct story without measurement errors
    for in=1:nyo
        ya_(1,in,nz2+ns_+1)=Yo(1,in);
        z0=zm(1,:)';
        for it=2:T
            s0=simstate(it-1);
            s1=simstate(it);
            w1=wm(it,:)';
            v1=vm(it,:)';
            v1(in)=0;
            z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*quadc1(z0)+B_i(:,:,s0)*w1;
            z0=z1;
            y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1)+D*v1;
            ya_(it,in,nz2+ns_+1)=y1(in);
        end
    end
    %
    % history with all shocks
    ya_(1,:,end)=Yo(1,:)';
    z0=zm(1,:)';
    for it=2:T
        s0=simstate(it-1);
        s1=simstate(it);
        w1=wm(it,:)';
        v1_=vm_(it,:)';
        z1=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*quadc1(z0)+B_i(:,:,s0)*w1;
        z0=z1;
        
        z1=zm(it,:)';
        y1=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1)+v1_;
        ya_(it,:,nz2+ns_+1+1)=y1';
    end
    wa_(:,:,im)=wm_;
    wa(:,:,im) =wm ;
    va_(:,:,im)=vm_;
    va(:,:,im) =vm; 
    yaa_(:,:,:,im)=ya_;
    clc;
    im/M00
end
wm_=mean(wa_,3);
wm =mean(wa ,3);
vm_=mean(va_,3);
vm =mean(va ,3);
ya_=mean(yaa_,4);

%%
str_shocks=[];
str_shocks{1}='xi';
str_shocks{2}='z';
str_shocks{3}='pol';
str_shocks{4}='mu';
str_shocks{5}='G';

str_sources=[];
for iz=1:nz2
    str_sources{iz}=str_shocks{iz};
end
for ics=1:ns_
    str_sources{nz2+ics}=s_str{ics};
end
str_sources{nz2+ns_+1}='me';
str_sources{nz2+ns_+2}='all shocks';
for in=1:nyo
    figure(in);
    for ik=1:size(ya_,3)-1
        subplot(3,3,ik);
        plot(datesv,[Yo(:,in) squeeze(ya_(:,in,ik))]);
        title(str_sources{ik});
        ylabel(str_var{in});
    end
    figure_filename=['historical_decomposition_' str_var{in}];
    print(in,'-dpsc2',figure_filename);
    print(in,'-dpdf',figure_filename);
    saveas(in,figure_filename,'fig');

end
close all;
%%
% save everything
save historical_decomposition Yo yaa_ datesv

    
    
%}
    
    
    