clear;clc;close all;
system('rm *.eps');
system('rm *.pdf');
system('rm *.fig');
%% section 0: general inputss
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
ndx_postmean=0;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results
load(['../../' model_name '_results_postproc']);
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
%% section 2: extract relevant material for constructing the graphs
%
nfig=0;
%% Section 5: marginal discrete states
%n_points=xlsread(settings_filename,'i39:i39');
%recession_dates0=xlsread(settings_filename,['i40:i' int2str(39+n_points)]);
recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
y_recession_dates=repmat([0 1 1 0]',length(recession_dates0)/2,1);
nfig=nfig+1;
figure(nfig);
for is=1:ns_
    subplot(ns_,1,is);
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;    
    plot1=plot(datesv,1-squeeze([Pa_mg(:,is,1) Sa_mg(:,is,1)]));
    
    set(plot1(1),'Color','r','LineWidth',3);
    set(plot1(2),'Color','b','LineWidth',3);
    set(gca,'fontsize',16);

    xlim([datesv(1) datesv(end)]);

    
    if is==1
        title('marginal discrete states filtered and smoothed','FontSize',20);
        legend({'Filtered','Smoothed'},'Location','NorthWest');
    end
    ylabel(s_str{is});
end
if index_only_max
    filename0='f_s_mg_dstates_max';
else
    filename0='f_s_mg_dstates_mean';    
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);

% next figure scaled with values of MS parameters (expressed in % pa)
MS_limm=reshape(testm(2*ns_+1:4*ns_,1)',2,[]);
MS_limm(:,1)=MS_limm(:,1)-1;
MS_limm=MS_limm*400;

nfig=nfig+1;
figure(nfig);
for is=1:ns_
    ylimv=MS_limm(:,is);
    y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
    subplot(ns_,1,is);
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;    
    plot1=plot(datesv,ylimv(1)+(ylimv(2)-ylimv(1))*(1-squeeze([Pa_mg(:,is,1) Sa_mg(:,is,1)])));
    
    set(plot1(1),'Color','r','LineWidth',3);
    set(plot1(2),'Color','b','LineWidth',3);
    set(gca,'fontsize',16);

    xlim([datesv(1) datesv(end)]);
    ylim(MS_limm(:,is));

    
    if is==1
        title('marginal discrete states filtered and smoothed','FontSize',20);
        legend({'Filtered','Smoothed'},'Location','NorthWest');
    end
    ylabel(s_str{is});
end
if index_only_max
    filename0='f_s_mg_dstates_max_rescaled';
else
    filename0='f_s_mg_dstates_mean_rescaled';    
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
save marginal_states.mat Pa_mg Sa_mg datesv s_str MS_limm;