clear;clc;close all;
%% section 0: general inputss
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
ndx_postmean=0;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results
load(['../../' model_name '_results_postproc']);
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
%% section 2: extract relevant material for constructing the graphs
%
nfig=0;
%% Section 3.1 one step ahead predictions for original series
% now we prapare graphs 
% first only with mean then also with quantiles
Yos=Yo*Trm_';
ygrapha=zeros(T,2,nyo_);
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    ygraphm=scalar_factor*[Yos(:,in) y10a(:,in,1)];
    ygrapha(:,:,in)=ygraphm;
    %ylimv=[min();max()];
    plot(datesv,ygraphm);
    if in==1
        title('true and one step ahead');
    end
    ylabel(str_var(in));
    subplot(nyo_/2,2,(in*2));
    plot(datesv,ygraphm*[1;-1]);
    ylabel(str_var(in));
    if in==1
        title('one step ahead error');
    end
end
if index_only_max
    filename0='actual_forecasts_max_1';
else
    filename0='actual_forecasts_mean_1';   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig)
nfig=nfig+1;
figure(nfig);
for in=1:nyo_/2;
    subplot(nyo_/2,2,(in-1)*2+1);
    ygraphm=scalar_factor*[Yos(:,in+nyo_/2) y10a(:,in+nyo_/2,1)];
    ygrapha(:,:,in+nyo_/2)=ygraphm;
    plot(datesv,ygraphm);
    if in==1
        title('true and one step ahead');
    end
    ylabel(str_var(in+nyo_/2));
    subplot(nyo_/2,2,(in*2));
    plot(datesv,ygraphm*[1;-1]);
    ylabel(str_var(in+nyo_/2));
    if in==1
        title('one step ahead error');
    end
end
if index_only_max
    filename0='actual_forecasts_max_2';
else
    filename0='actual_forecasts_mean_2';   
end
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
%%
save 'one_step_ahed_forecast_storage' datesv ygrapha str_var
% datesv is (T x 1) vector with dates
%
% ygrapha is (T x 2 x 8)
%   fist dimension is sample size (T)
%   second dimension is number of series in L.H.S. plot (actual, forecast)
%   third dimension is number of series (8)
%
% str_var is (1 x8) cell with names of variables
%     {'Pi_t','del  taC','deltaY','I_t','R12','R40','R12 - I_t','R40 - I_t'}
