clear; clc; close all;
%% section 0: general inputs
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
Nh_=80; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results and perform various computations
load(['../' model_name '_results_postproc']);
% 1.1 compute one step ahead first and second moments
% this computation is done by extrapolating filtered variables
% caution: it is slow
%%
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
%% Section 2: computation of IRFs
% 2.1: computation of IRFs to regime switches
M0=M00;
nthin=M/M0;
z0_=zeros(nz,1);
%s0_=1;
s1p=[5;3;2];
irfaa=zeros(nyo_,ns_,Nh_+1,M0);
param_=zeros(M0,np);
%%
for im=1:M0
    delta0=param((im-1)*nthin+1,1:np)';
    if ind_label_constraints
        ind_perm=zeros(ns_,1);
        for iim=1:ns_
            ind_perm(iim)=2-(delta0(label_constraints(1,iim))<=delta0(label_constraints(2,iim)));
        end
        delta0=delta0(squeeze(ndx_label_permute(:,ind_perm(1),ind_perm(2),ind_perm(3))));
    end
    param_(im,:)=delta0';
    %eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] = ' solution_routine_name '2(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    %[retcode,lnlv,pyta_ij,Za,Qa,Pm,Z10a,Q10aa,p1m,Sm,sv,muy_ij_a,Sigmay_ij_a,y10m] = DSGE_MS_Kim_Filter_pp_(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1);
    retcode0=retcode0+(retcode==0);
    %     Zm=array2mat(Za,sv);
    %     z0b=z0_;
    %     z0p=repmat(z0_,1,ns_);
    %     s0p=s0*ones(ns_,1);
    %     z1p=zeros(nz,ns_);
    %     s0=s0_;
    irfa=zeros(nyo_,ns_,Nh_+1);
    % define the array with the discrete stae allocations over the relevant
    % horizon
    saa=zeros(ns_,Nh_+1,2); % no. dscrete states, horizon, base and perturbed
    saa(:,:,1)=1; % this is the baseline
    saa(:,:,2)=repmat(s1p,1,Nh_+1); % this the perturbed state
    % define objects for the ys and zs
    yaa=zeros(nyo,Nh_+1,2);
    zaa=zeros(nz,Nh_+1,2);
    %%
    for is=1:ns_
        %define the 
        for ih=1:Nh_+1
            for ik=1:2
                if ih>1
                    % update of the z's
                    s0=saa(is,ih-1,ik);
                    z0=squeeze(zaa(:,ih-1,ik));
                    zaa(:,ih,ik)=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*quadc1(z0);
                end
                s1=saa(is,ih,ik);
                z1=squeeze(zaa(:,ih,ik));
                yaa(:,ih,ik)=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1);
            end
            % now compute the impulse responses (perturbed - baseline)
            irfa(:,is,ih)=Trm_*squeeze((yaa(:,ih,2)-yaa(:,ih,1)));
        end
    end
    irfaa(:,:,:,im)=irfa;
    clc;
    im/M0
end
%
save('regime_irfs_80','irfaa');
% make graphs
delta0=mean(param(:,1:np))'; 
%%

% cumulate impulse responses for DC and DY 
% multiply by 400
% do not plot IRFs for spreads
scalar_factor=1;
scale_by_sigmas=1;
irfaa_=irfaa;

sigv=delta0([8 10 12])-delta0([7 9 11]); % to scale the impulse responses by size of MS variances

irfaa_(2:3,:,:,:)=cumsum(irfaa(2:3,:,:,:));
[nyo_,ns_,Nh_,M0]=size(irfaa_);
Nh_=Nh_-1;
irfaa__=mean_std_quantiles(scalar_factor*irfaa_,qv);
nh=12;
str_var_=str_var;
str_var_{2}='C';
str_var_{3}='Y';
if scale_by_sigmas==0
    sigv=ones(nss,1);
end

for is=1:ns_
        ymin=min(min(squeeze(irfaa__(:,is,1:nh+1,3))/sigv(is)));
        ymax=max(max(squeeze(irfaa__(:,is,1:nh+1,5))/sigv(is)));  
        figure(is);
    for in=1:(nyo_-2)        
        subplot((nyo_-2)/2,2,in);
        yyymat=squeeze(irfaa__(in,is,1:nh+1,[1 3 4 5]))/sigv(is);
        plot((0:nh)',yyymat,'LineWidth',3);
        ylabel(str_var_(in),'FontSize',15);
        xlabel('horizon','FontSize',12);
        xlim([0 nh]);
        ylim([ymin ymax]);
        if in==1
            title(['response to a one-off regime change in ' s_str(is)],'FontSize',12);
        end
    end
    figure_filename=['figure_IRF_oneoff_regime_change_' int2str(is)];
    saveas(is,figure_filename,'fig');
    print(is,'-dpsc2',figure_filename,'-r2400');
    print(is,'-dpdf',figure_filename,'-r2400');   
end
close all;
