clear; clc; close all;
%% section 0: general inputs
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results and perform various computations
load(['../' model_name '_results_postproc']);
% 1.1 compute one step ahead first and second moments
% this computation is done by extrapolating filtered variables
% caution: it is slow
%% Section 1: some inputs
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
% 
%% Section 2: pull premia
recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
ymin=scalar_factor*min([filpremia(:);smopremia(:)]);
ymax=scalar_factor*max([filpremia(:);smopremia(:)]);
y_recession_dates=repmat([0 ymax ymax 0]',length(recession_dates0)/2,1);
FS_datesv=datesv;
%% Section 3: pull premia from subsamples
% subsample I
load '../subsamples/subsample_1966Q1_1986Q4/premia_subsample.mat';
spm_SSI=mean(spa,3); % smoothed premia 
fpm_SSI=mean(fpa,3); % filtered premia
SSI_datesv=datesv;
% subsample II
load '../subsamples/subsample_1987Q1_2009Q1/premia_subsample.mat';
spm_SSII=mean(spa,3); % smoothed premia 
fpm_SSII=mean(fpa,3); % filtered premia
SSII_datesv=datesv;

%% Section 4: make graphs
datesv=FS_datesv;
nfig=1;
figure(nfig);
for in=1:numel(n4);
    subplot(2,1,in);
    plot(datesv,scalar_factor*squeeze(filpremia(:,in,1)),'LineWidth',1);
    %axis([datesv(1) datesv(end) ymin ymax]);
    hold on;
    % SSI
    plot(SSI_datesv,scalar_factor*fpm_SSI(:,in),'LineWidth',1);
    hold on;
    %SSII
    plot(SSII_datesv,scalar_factor*fpm_SSII(:,in),'LineWidth',1);
    hold on;
    title(['filtered premia ' int2str(n4(in)) ' quarters']);
    legend('full sample','1966Q1-1986Q4','1987Q1-2009Q1','Location','Best');
end
filename0='filtered_premia_with_subsamples';
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
%close(nfig);
% smoothed premia
nfig=nfig+1;
figure(nfig);
for in=1:numel(n4);
    subplot(2,1,in);
    plot(datesv,scalar_factor*squeeze(smopremia(:,in,1)),'LineWidth',1);
    %axis([datesv(1) datesv(end) ymin ymax]);
    hold on;
    % SSI
    plot(SSI_datesv,scalar_factor*spm_SSI(:,in),'LineWidth',1);
    hold on;
    %SSII
    plot(SSII_datesv,scalar_factor*spm_SSII(:,in),'LineWidth',1);
    hold on;
    title(['filtered premia ' int2str(n4(in)) ' quarters']);
    legend('full sample','1966Q1-1986Q4','1987Q1-2009Q1','Location','Best');
end
filename0='smoothed_premia_with_subsamples';
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
%close(nfig);



