clear; clc; close all;
%% section 0: general inputs
model_name='RATTS_2020';
Nh=1;
M00=1e+3;
Nh_=40; % horizon for IRF computations
qv0=[.025 .5 .975]';
%% section 1 load results and perform various computations
load(['../../' model_name '_results_postproc']);
% 1.1 compute one step ahead first and second moments
% this computation is done by extrapolating filtered variables
% caution: it is slow
%% Section 1: some inputs
qv=qv0;
M0=M00;
Mthin=M/M0;
[nz,nz2,ncs]=size(B_i);
ns_=log(ncs)/log(2);
ndx_label_permute=DSGE_MS_ndx_label_permute_(np,nss); % bug corrected 2013/10/07
% 
%% Section 2: pull premia
recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
ymin=scalar_factor*min([filpremia(:);smopremia(:)]);
ymax=scalar_factor*max([filpremia(:);smopremia(:)]);
y_recession_dates=repmat([0 ymax ymax 0]',length(recession_dates0)/2,1);
%
nfig=1;
figure(nfig);
%subplot(2,1,1);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot1=plot(datesv,scalar_factor*[squeeze(filpremia(:,1,3:end)) squeeze(filpremia(:,2,3:end))]);
axis([datesv(1) datesv(end) ymin ymax]);
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2,'LineStyle','--');
set(plot1(2),'Color','r','LineWidth',3,'LineStyle','-');
set(plot1(3),'Color','r','LineWidth',2,'LineStyle','--');
set(plot1(4),'Color','b','LineWidth',2,'LineStyle','--');
set(plot1(5),'Color','b','LineWidth',3,'LineStyle','-');
set(plot1(6),'Color','b','LineWidth',2,'LineStyle','--');
title('Filtered premia','FontSize',20);
filename0='filtered_premia_bands';
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
%
nfig=nfig+1;
figure(nfig);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot1=plot(datesv,scalar_factor*[squeeze(smopremia(:,1,3:end)) squeeze(smopremia(:,2,3:end))]);
axis([datesv(1) datesv(end) ymin ymax]);
set(gca,'fontsize',20);
set(plot1(1),'Color','r','LineWidth',2,'LineStyle','--');
set(plot1(2),'Color','r','LineWidth',3,'LineStyle','-');
set(plot1(3),'Color','r','LineWidth',2,'LineStyle','--');
set(plot1(4),'Color','b','LineWidth',2,'LineStyle','--');
set(plot1(5),'Color','b','LineWidth',3,'LineStyle','-');
set(plot1(6),'Color','b','LineWidth',2,'LineStyle','--');
title('Filtered premia','FontSize',20)
filename0='smoothed_premia_bands';
saveas(nfig,filename0,'fig');
print('-dpdf','-r2400',filename0);
print('-depsc2','-r2400',filename0);
close(nfig);
save premia datesv scalar_factor filpremia smopremia;
