%% sensitivity experiment II: fix gamma to 15 and check effects on ifit/forecast of short term rate and on premia (exhprs)
% I will work with posterior mean, and moments obtained by simulation will
% be conditioned on this value of the parameters
clear; clc; close all;
clear; clc;
addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
load ../../../RATTS_2020_results.mat;
load ../../forecasts/Yo_mv;
Yo_mv=Yo;
load ../../forecasts/Yo;

delta0=mean(param(:,1:np))';
delta1=delta0;
delta1(27)=15;
deltam=[delta0 delta1];
order=1;

M=1e+3;
nh=40;
nh_=20;
% Number of predetermined variables
n1 = 9 ;
% Number of non-predetermined variables
n2 = 9 ;
% Position of observable in non-predetermined vector
% pie,deltaC,deltaY, r
% NOTE: it does not take into account the yield
n3 = [1,8,9,5];
% Maturities used in estimation (in quarters)
n4 = [12,40];   % 3 and 5 years
%
ns=8;
nz=n1;
nz2=5;
ny=length(n3)+length(n4);
nme=ny;
nyields=length(n4);

% inputs
T=length(datesv);
dataa=zeros(nz+ny,T,nh+1,2,M);
Rhoa=zeros(ny,ny,1+nh,2,M);
filpremia=zeros(T,nyields,2,M);
smopremia=zeros(T,nyields,2,M);

%
%T0=find(datesv==2009);
%
for im=1:M
    for ipar=1:2
        deltav=deltam(:,ipar);
        %deltav=delta0;
        [~,y,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] =       RATTS_2020_modsol_Klein_2(order,deltav,n1,n2,n3,n4);
        [retcode_,y_,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_] = RATTS_2020_modsol_Klein_(1,deltav,n1,n2,n3,n4);
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
        [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
            DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,deltav);
        [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
            DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
        %
        filpremia(:,:,ipar,im)=pm*premia(n4,:)';
        smopremia(:,:,ipar,im)=pm*premia(n4,:)';
        %
        solution_matrices=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,a_i_,A1_i_);
        %
        pv0=pv;
        %
        for it=1:T
            Z_tt=squeeze(Za(it,:,:));
            Qa_tt=squeeze(Qa(it,:,:,:));
            pi_tt=pm(it,:)';
            % now get a draw from initial state
            sv0=zeros(1+nh,1);
            pv=pi_tt;
            %s0=draw_multinom(pi_tt,1,ns,0);
            %s0=sv0(1);
            %
            for ih=0:nh
                s0=draw_multinom(pv,1,ns,1);
                pv=ctp(s0,:)';
                sv0(1+ih)=s0;
            end
            % now pick the starting point
            z0=Z_tt(:,sv0(1))+0*chol(Qa_tt(:,:,sv0(1)))*randn(nz,1);
            % specify continuous shocks
            em=[zeros(nz2+nme,1) randn(nz2+nme,nh)];
            dataa(:,it,:,ipar,im) = DSGE_MS_dynamic_simulation_new(solution_matrices,z0,em,sv0,1);
            %}
        end
        
        % here simulate data to compute correlations. Use very high sample size
        % to approx theoretical moments
        % simulate discrete state vector
        sv0=zeros(1+1,1);
        pv=pv0;
        for it=1:T+1
            s0=draw_multinom(pv,1,ns,1);
            pv=ctp(s0,:)';
            sv0(it)=s0;
        end
        % continuous shocks
        em=randn(nz2+nme,T);
        z0=zeros(n1,1);
        % simulate data
        Y_=DSGE_MS_dynamic_simulation(solution_matrices,z0,em,sv0,1)';
        Cova__=mk_sdca(Y_(:,nz+1:end),nh);
        diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
        Cora__=Cova__;
        for ih=1:nh+1
            Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
        end
        %Sigma_y_(:,:,:,im,2)=Cova__;
        %sig_y_(:,im,2)=sqrt(diag(squeeze(Sigma_y_(:,:,1,im,2))));
        Rhoa(:,:,:,ipar,im)=Cora__;
    end
    clc;
    im/M
end
save workspace
%%
% compute data autocovariances using Yo (213 x 6), containing all values
% (no NaNs there)

Yo_var_str={'Pi','Dc','Dy','I','R12','R40'};
Cova=mk_sdca(Yo,nh);
        diagsigma=diag(1./sqrt(diag(Cova(:,:,1))));
        Cora=Cova;
        for ih=1:nh+1
            Cora(:,:,ih)=diagsigma*Cova(:,:,ih)*diagsigma;
        end

qv=[.05 .1 .25 .5 .75 .9 .95]';
dataa_=mean_std_quantiles(dataa,qv);
Rhoa_=mean_std_quantiles(Rhoa,qv);
filpremia_=mean_std_quantiles(filpremia,qv);
smopremia_=mean_std_quantiles(smopremia,qv);

% charts with forecasts
nfig=0;

% forecast/fitted
hv_=[0 1 4 12]; % forecast horizon
for ih=1:length(hv_)
nfig=nfig+1;
figure(nfig);
h_=hv_(ih);
for in=1:ny
    ym=400*[Yo(h_+1:end,in) squeeze(dataa_(nz+in,1:end-h_,1+h_,:,1))];
    subplot(3,2,in);
    plot1=plot(datesv(h_+1:end),ym);
    set(plot1(1),'Color','b','LineWidth',1,'LineStyle','-');
    set(plot1(2),'Color','r','LineWidth',2,'LineStyle','-');
    set(plot1(3),'Color','g','LineWidth',2,'LineStyle','-');
    xlabel(Yo_var_str(in));
    if in==ny
        legend({'actual','baseline','alternative'},'NumColumns',6);
        legend('boxoff')
    end
end
filename=['gamma_sensitivity_actual_forecasts_' int2str(h_)];
sgtitle([strrep(filename,'_',' ')  ' steps ahead']);
orient(nfig,'landscape');
print(nfig,'-fillpage',filename,'-dpdf');
%print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');
end 

% now correlations
ndx_qreport=[1 7];
nfig=nfig+1;
figure(nfig);

hv=(0:nh)';
for in=1:ny
   % ym=[squeeze(Cora(in,in,:)) squeeze(reshape(squeeze(Rhoa_(in,in,:,:,[1 2+ndx_qreport])),nh+1,6,1)) ];
    ym=[squeeze(Cora(in,in,:)) squeeze(Rhoa_(in,in,:,1,[1 2+ndx_qreport]))  squeeze(Rhoa_(in,in,:,2,[1 2+ndx_qreport])) ];
   
    
    subplot(3,2,in);
    plot1=plot(hv,ym);
    set(plot1(1),'Color','k','LineWidth',2,'LineStyle','-');
    set(plot1(2),'Color','b','LineWidth',1,'LineStyle','-');
    set(plot1(3),'Color','b','LineWidth',1,'LineStyle',':');
    set(plot1(4),'Color','b','LineWidth',1,'LineStyle',':');
    set(plot1(5),'Color','r','LineWidth',1,'LineStyle','-');
    set(plot1(6),'Color','r','LineWidth',1,'LineStyle',':');
    set(plot1(7),'Color','r','LineWidth',1,'LineStyle',':');
    xlabel(Yo_var_str(in));

     if in==ny
        legend({'data','baseline mean','baseline lower','baseline upper',...
            'alternative mean','alternative lower','alternative upper'},'NumColumns',2,'Location','SouthWest');
        legend('boxoff')
    end
end
filename=['gamma_sensitivity_correlations'];
sgtitle(strrep(filename,'_',' '));
orient(nfig,'landscape');
print(nfig,'-fillpage',filename,'-dpdf');
%print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');

% now smoothed premia

ndx_qreport=[1 7];
nfig=nfig+1;
figure(nfig);

hv=(0:nh)';
for in=1:nyields
    ym=400*[squeeze(smopremia_(:,in,1,[1 2+ndx_qreport])) ... 
            squeeze(smopremia_(:,in,2,[1 2+ndx_qreport]))];
    subplot(2,1,in);
    plot1=plot(datesv,ym);
    set(plot1(1),'Color','b','LineWidth',2,'LineStyle','-');
    set(plot1(2),'Color','b','LineWidth',1,'LineStyle',':');
    set(plot1(3),'Color','b','LineWidth',1,'LineStyle',':');
    set(plot1(4),'Color','r','LineWidth',2,'LineStyle','-');
    set(plot1(5),'Color','r','LineWidth',1,'LineStyle',':');
    set(plot1(6),'Color','r','LineWidth',1,'LineStyle',':');
    xlabel(['exhprs ' int2str(n4(in)) 'qrts']);

     if in==nyields
        legend({'baseline mean','baseline lower','baseline upper',...
            'alternative mean','alternative lower','alternative upper'},'NumColumns',3,'Location','SouthWest');
        legend('boxoff')
    end
end
filename=['gamma_sensitivity_smopremia'];
sgtitle(strrep(filename,'_',' '));
orient(nfig,'landscape');
print(nfig,'-fillpage',filename,'-dpdf');
%print(nfig,'-dpdf',filename);
saveas(nfig,filename,'fig');


