clear; clc; close all;
directories={'gamma','gampsi','h','iota'};
nh=40;
nh_=12; % shorter horizon for reporting
nyo=6;
nz=9;
T=213;
qv=[.05 .1 .25 .5 .75 .9 .95]';
nmod=2;
ndir=length(directories);
rmsea=nan(  nyo,nh,nmod,ndir);
ea=   nan(T,nyo,nh,nmod,ndir);
dataaa_=zeros(nz+nyo,T,nh+1,2,2+length(qv),ndir);
for id=1:ndir
    eval(['load ' directories{id} filesep 'workspace.mat;']);
    dataa_=mean_std_quantiles(dataa,qv);
    for in=1:nyo
        for ih=1:nh
            for imod=1:nmod
                ev=Yo(1+ih:end,in)-squeeze(dataa_(nz+in,1+ih:end,1+ih,imod,1))';
                ea(1+ih:end,in,imod,id)=ev;
                rmsea(in,ih,imod,id)=sqrt(mean(ev.^2));
            end
            
        end        
    end
    dataaa_(:,:,:,:,:,id)=dataa_;
    id/ndir
end
%% make charts and save them
% one chart for each experiment

str_var={'pi','dc','dy','I','R12','R40'};
str_mode={'baseline','alternative'};
nfig=0;
for idir=1:ndir
    nfig=nfig+1;
    figure(nfig);
    for in=1:ny
        subplot(3,2,in);
        plot1=plot(1:nh_,400*squeeze(rmsea(in,1:nh_,:,idir)),'LineWidth',3);
        title(str_var(in));
        if in==ny
            legend(str_mode,'Location','SouthEast');
        end
    end
    sgtitle(['sensitivity experiment ' directories{idir} ': RMSEs comparisons']);
    orient(nfig,'landscape');
    filename0=['sens_' directories{idir}];
    print(nfig,'-fillpage',filename0,'-dpdf');
    saveas(nfig,filename0,'fig');
end


%% make charts and save them in 4 different files
