clear; clc; close all;
directories={'gamma','gampsi','h','iota'};
load ../../RATTS_2020_results.mat;
% now prepare the elements of the simulation
ngrid=21;
delta0=mean(param(:,1:np))';
ndir=length(directories);
delta1m=repmat(delta0,1,ndir);
% describe different experiments
experiments_ndxm=[27 15; 27  delta0(28); 30 0; 24 .7];
% now construct the grid for each of the experiments
gridm=zeros(ngrid,ndir);
for idir = 1:ndir
    ip1=experiments_ndxm(idir,1);
    p1=experiments_ndxm(idir,2);
    gridm(:,idir)=linspace(delta0(ip1),p1,ngrid)';
end
% now I have prepared the gridm, I run the computations
outputa=zeros(ngrid,ndir,3); % to include lnprior, lnlike, lnpost
for idir=1:ndir
    ip1=experiments_ndxm(idir,1);
    delta1=delta0;
    for igrid=1:ngrid
        delta1(ip1)=gridm(igrid,idir);
        [~,~,lnprior1]=DSGE_repar1(delta1,Rm,0,prior_type_ndxv);
        lnprior1=sum(lnprior1(sim1ndx));
        % solve model and compute lnlike
        eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta1,n1,n2,n3,n4);']);
        [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
        [retcode,lnlv,~,~,~] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf);
        lnl1=sum(lnlv(Tini+1:end));
        outputa(igrid,idir,1)=lnprior1;
        outputa(igrid,idir,2)=lnl1;
        outputa(igrid,idir,3)=lnprior1+lnl1;
        clc
        
    disp(round(100*[idir/ndir igrid/ngrid]));
    end
end
%%
str_output={'lnprior','lnlike','lnpost'};
nfig=1;
figure(nfig);
for idir=1:ndir
    ip1=experiments_ndxm(idir,1);
    for icol=1:3
        subplot(ndir,3,3*(idir-1)+icol);
        xv=gridm(:,idir);
        yv=squeeze(outputa(:,idir,icol));
        plot1=plot(xv,yv,'LineWidth',3);
        if xv(1)>xv(end)
            set(gca, 'XDir','reverse');
        end
        if idir==1
        title(str_output{icol});
        end
        xlabel(parameter_name{ip1})
    end
end
sgtitle('sensitivity analyses: lnprior, lnlikelihood, and lnposterior');
filename0=['sens_lnl'];
print(nfig,'-fillpage',filename0,'-dpdf');
saveas(nfig,filename0,'fig');
