clear; clc; close all;
Tsim=1e+4; % sample size to use in simulation based moments computations
M_=1e+3; % number of simulations being used for the computations
directories={'gamma','gampsi','h','iota'};
load ../../RATTS_2020_results.mat;
% now prepare the elements of the simulation
delta0=mean(param(:,1:np))';
ndir=length(directories);
delta1m=repmat(delta0,1,ndir);
% describe different experiments
experiments_ndxm=[27 15; 27  delta0(28); 30 0; 24 .7];
nss_=2^nss;
nz=n1;
nz2=5;
nme=nyo;
% now prepare the alternative parameter values
for idir=1:ndir
    ip1=experiments_ndxm(idir,1);
    p1=experiments_ndxm(idir,2);
    delta1m(ip1,idir)=p1;
end
% now construct unconditional mean and standard deviations for all observables
moma=zeros(nyo,2,2+ndir); % rows are variables, columns are mean and std, pages are data, baseline, and 4 experiments 
% start with the data
Yo_=Yo;
load ../forecasts/Yo_mv.mat;
Yo_mv=Yo;
Yo=Yo_;
for in=1:nyo
    yv=rmmissing(Yo_mv(:,in));
    moma(in,1,1)=mean(yv);
    moma(in,2,1)=std(yv);
end
% now compute the moments bysimulation using baseline and experiments
momaa=zeros(nyo,2,ndir,M_);
for idir=1:(1+ndir) % baseline + ndir experiments
    if idir==1
        deltav=delta0;
    else
        deltav=delta1m(:,idir-1);
    end
    % solve the model using deltav and construct SS matrices
    [~,y,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] =       RATTS_2020_modsol_Klein_2(2,deltav,n1,n2,n3,n4);
    [retcode_,y_,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_] = RATTS_2020_modsol_Klein_(1,deltav,n1,n2,n3,n4);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,deltav);
    
    % now run filter and smoother to get to an initial condition
    [retcode,lnlv_,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo_mv(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf,1,1);
    
    solution_matrices=v2struct(a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,a_i_,A1_i_);

        
        
        % now use simulation machinery      
    
    
    
    
    for im=1:M_
        
        
        % here simulate data to compute correlations. Use very high sample size
        % to approx theoretical moments
        % simulate discrete state vector
        sv0=zeros(1+Tsim,1);
        pv0=pv;
        for it=1:Tsim+1
            s0=draw_multinom(pv0,1,nss_,1);
            pv0=ctp(s0,:)';
            sv0(it)=s0;
        end
        % continuous shocks
        em=randn(nz2+nme,Tsim);
        z0=zeros(n1,1);
        % simulate data
        Y_=DSGE_MS_dynamic_simulation(solution_matrices,z0,em,sv0,1)';
        Y_=Y_(:,nz+1:end);
        momaa(:,1,idir,im)=mean(Y_   )';
        momaa(:,2,idir,im)=mean(Y_.^2)';
        clc;
        disp(round(100*[idir/(ndir+1) im/M_])); 
    end
    
    
    
    
    %{
    
        % here simulate data to compute correlations. Use very high sample size
        % to approx theoretical moments
        % simulate discrete state vector
        sv0=zeros(1+1,1);
        pv=pv0;
        for it=1:T+1
            s0=draw_multinom(pv,1,ns,1);
            pv=ctp(s0,:)';
            sv0(it)=s0;
        end
        % continuous shocks
        em=randn(nz2+nme,T);
        z0=zeros(n1,1);
        % simulate data
        Y_=DSGE_MS_dynamic_simulation(solution_matrices,z0,em,sv0,1)';
        Cova__=mk_sdca(Y_(:,nz+1:end),nh);
        diagsigma=diag(1./sqrt(diag(Cova__(:,:,1))));
        Cora__=Cova__;
        for ih=1:nh+1
            Cora__(:,:,ih)=diagsigma*Cova__(:,:,ih)*diagsigma;
        end
    %}
    
    
            
    
end  
momaa_=mean(momaa,4);
momaa_(:,2,:)=sqrt(momaa_(:,2,:)-momaa_(:,1,:).^2);
moma(:,:,2:end)=momaa_;
% express all in % per annum
moma=400*moma;
%%
Yo_name_str={'pi','dc','dy','I','R12','R40'};
mom_str={'mean','std'};
%directories_=cat(2,'baseline', directories); 
directories_={'post mean','\gamma=15','\gamma=\psi','h=0','\iota=.7'};
nfig=0;
for ifig=1:2
    nfig=nfig+1;
    figure(nfig);
    for in=1:nyo
        subplot(3,2,in);
        plot(moma(in,ifig,1)*ones(ndir+1,1),'LineWidth',2,'LineStyle','--');
        hold on 
        plot(squeeze(moma(in,ifig,2:end)),'*');
        if in==nyo
            legend('data','simulated');
            legend boxoff;
        end
        set(gca,'xtick',[1:5],'xticklabel',directories_);
        %set(gca,'visible','off');
        hold off
        ylim([0 1.1*max(moma(:))]);
        xlim([0.8 5.2]);
        title(Yo_name_str(in));
    end
    sgtitle(['unconditional moments: ' mom_str{ifig}]);
    % save file
    filename0=['unconditional_' mom_str{ifig}];
    print(nfig,'-fillpage',filename0,'-dpdf');
    saveas(nfig,filename0,'fig');
end
