clear; clc; close all; 
load '../../RATTS_2020_results.mat';
Nh=12;
str_var=[];
for in=1:numel(n3)
    str_var{in}=y_str{n3(in)};
end
for in=1:numel(n4);
    str_var{numel(n3)+in}=['R' int2str(n4(in))];
end
str_var=str_var';
Yo_mean=400*mean(Yo)';
Yo_std=400*std(Yo)';
delta0=mean(param(:,1:np))';
eval(['[retcode_,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
[mu_z,mu_y,Sigma_z,Sigma_y,Rho_z,Rho_y] = DSGE_MS_moments(y_,a_i,A1_i(:,:,1),A2,B_i,c_j,C1_j(:,:,1),C2,D,pv,Nh);
mu_y=400*mu_y;
sig_y=400*sqrt(diag(squeeze(Sigma_y(:,:,1))));
nsss=400*y_;
table_uncond_moms=table(str_var,Yo_mean,nsss,mu_y,Yo_std,sig_y);
%% now compute moments with sigma_z set to low volatility state
delta0(12)=delta0(11);
eval(['[retcode_,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
[a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
[mu_z_,mu_y_,Sigma_z_,Sigma_y_,Rho_z_,Rho_y_] = DSGE_MS_moments(y_,a_i,A1_i(:,:,1),A2,B_i,c_j,C1_j(:,:,1),C2,D,pv,Nh);
mu_y_=400*mu_y_;
sig_y_=400*sqrt(diag(squeeze(Sigma_y_(:,:,1))));
nsss_=400*y_;
table_uncond_moms_zAL=table(str_var,Yo_mean,nsss,mu_y,mu_y_,Yo_std,sig_y);

str_var=strrep(str_var,'_','\_');

table_comparison=table(nsss,nsss_,mu_y,mu_y_,sig_y,sig_y_,'RowNames',str_var);

%% generate latex tables
input.data=table_comparison;
% Switch transposing/pivoting your table:
input.transposeTable = 1;
% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
% Formatting-string to set the precision of the table values:
% For using different formats in different rows use a cell array like
% {myFormatString1,numberOfValues1,myFormatString2,numberOfValues2, ... }
% where myFormatString_ are formatting-strings and numberOfValues_ are the
% number of table columns or rows that the preceding formatting-string applies.
% Please make sure the sum of numberOfValues_ matches the number of columns or
% rows in input.tableData!
%
input.dataFormat = {'%4.2f'}; % three digits precision for first two columns, one digit for the last

% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';

% Column alignment in Latex table ('l'=left-justified, 'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'c';

% Switch table borders on/off:
input.tableBorders = 1;
% LaTex table caption:
input.tableCaption = ['Comparison unconditional moments, posterior mean vs permanently low sigmaZ'];
% LaTex table label:
input.tableLabel = 'unconditional moments';

% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 1;

% call latexTable:
latex= latexTable(input);
latex=strrep(latex,'[H!]','[h!]');
latex=strrep(latex,'_','\_');

if exist([input.tableLabel '.tex'],'file');
    system(['rm ' input.tableLabel '.tex']);
    
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;

