% Programme to set-up the RATTS model 
% with regime switching shocks
% Version with three switching variables 
% and non-expected utility
% VERSION RATTS_integrated
% Gianni Amisano & Oreste Tristani
% 
% Date: March 2013
% With Trabandt-Uhlig utility, simpler state space representation (no discrete states)
% and a stochastic trend for technology growth 
% differs from previous versions for a new specification of the Taylor
% rule. 
% The variables are ordered as follows:
% x = [lag_I lag_Pi lag_C lag_Y xi_t z_t pol_t mu_t G_t ];
% y = [Pi_t C_t J_t Y_t I_t Lam_t dum_t deltaC deltaY]; 
clear; clc; close all;
index_prior_proc=0;
index_model_run=1;
index_post_proc=1;
model_name='RATTS_2020';
%%
addpath(genpath('/cmc/scratch/m1gga00/matlab_code/RATTS_2020_routines'));

%{
if isunix && ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/research/matlab_code'));
end
if index_prior_proc
    retcode = DSGE_MS_prior_processing_2019(model_name);
end
%}
io_dir=pwd
if index_model_run
    retcode = DSGE_MS_model_run_2021(model_name,io_dir); % this uses new model run routine
end
if index_post_proc
    retcode = DSGE_MS_post_processing_2021(model_name,io_dir);
end
