clc; close all; clear;
load ../../RATTS_2020_results;
seed0=123456;
Tini_=0;
order=2;
N=1e+4;
M_=1e+0;
nu=0; % if nu >0, we use a Student-t as candidate
ind_regularize=0; % if we want to regularize
%
if isunix && ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/research/matlab_code'));
end
rng('default');
rng(seed0);
[nz,~,ncs]=size(B_i);
ns_=log(ncs)/log(2);
lnla=zeros(T,3,M_);
essm=zeros(T,M_);nthin=M/M_;
tic;
for im=1:M_
    delta0=mean(param(:,1:np))';
    %delta0=param(nthin*im,1:np)';
    % solve the model
    eval(['[retcode,y_,gx,hx,gxx,hxx,gss,hss,eta,etastd] = ' solution_routine_name '(order,delta0,n1,n2,n3,n4);']);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,pm,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,delta0);
    %
    % regularize
    if ind_regularize
        D_=D;
        D=diag([.2 .2 .2 .05 .1 .1].*std(Yo(1:end-1,:)));%regularized
    end
    %}
    
    %A2=0*A2;
    %C2=0.0*C2;
    %;
    % compute the likelihood using the approx model
    [retcode,lnlv_Kim,Za,Qa,Pm] = DSGE_MS_Kim_Filter_mv(Yo(:,subset_y),a_i,A1_i,A2,B_i,c_j(subset_y,:),C1_j(subset_y,:,:),C2(subset_y,:),D(subset_y,:),Sigma_zz,ctp,pv,ind_ekf);
    Yo_am=1-isnan(Yo); % this is to create matrix with zero elements for elements of Yo which are NA
    T_=vec2vech_(nz);
    [T,nyo]=size(Yo);
    [nz,nz2,ncs]=size(B_i);
    nz1=nz-nz2;
    DD=D*D';
    wm_=zeros(T,N);
    lnlv_smc_lin=zeros(T,1); % prepare container for log likelihood (vector) using SMC+linearizaion
    lnlv_smc=zeros(T,1);% prep container for log likelihood (vector) using SMC
    essv=zeros(T,1); % prepare container for ESS vector
    BB_i=zeros(nz,nz,ncs);
    for ics=1:ncs
        BB_i(:,:,ics)=B_i(:,:,ics)*B_i(:,:,ics)';
    end
    Q0=zeros(nz,nz);
    A1=zeros(nz,nz);
    C1=zeros(nyo,nz);
    for ics=1:ncs
        Q0=Q0+BB_i(:,:,ics)*pv(ics);
        A1=A1+A1_i(:,:,ics)*pv(ics);
        C1=C1+C1_j(:,:,ics)*pv(ics);
    end
    Q0=reshape((eye(nz^2,nz^2)-kron(A1,A1))\Q0(:),nz,nz);
    [mu_z,mu_y,Sigma_z,Sigma_y,Corr_z,Corr_y] = DSGE_MS_moments(y_,a_i,A1,A2,B_i,c_j,C1,C2,D,pv,0);
    
    z0m=repmat(mu_z,1,N)+chol(Q0)'*randn(nz,N);
    s0v=draw_multinom(pv,N,ncs,1);
    z1m=zeros(nz,N); % where to store draws for z_{t+1}
    s1v=zeros(N,1);  % ditto for s_{t+1}
    lpa=zeros(T,N,4); % to store elements for likelihood evaluation
    za=zeros(T,nz,N); % to store all z particles
    Sm=zeros(T,N); % to store all s particles
    
    %%
    for it=1:T
        % here select dimensions which are relevant at observation t
        ndx_ynm=find(Yo_am(it,:)'>0); %series that have non missing values
        yt_=Yo(it,ndx_ynm)'; % pick the data
        for in=1:N
            s0=s0v(in);% pick s_t = i
            p10=ctp(s0,:)'; % pick row of TPM corresponding to s_{t-1}, i.e. p(s_t|s_{t-1})
            z0=z0m(:,in); % pick n'th particle
            z10=a_i(:,s0)+A1_i(:,:,s0)*z0+A2*vech_(z0*z0'); % one step ahead cond mean
            Q10=BB_i(:,:,s0); % one step ahead conditional variance
            Q10=(Q10+Q10')/2; % regularize...
            D1i=T_*dk2v(z10); % derivative of vech_(z10*z10')
            lpytv=zeros(ncs,1); % container for p^(y_t|y_{t-1},x_{t-1},theta)
            z11m=zeros(nz,ncs); % storage for E^(z_t|y_{1:t},x_{t-1},s_t,theta)
            Q11a=zeros(nz,nz,ncs); % storage for V^(z_t|y_{1:t},x_{t-1},s_t,theta)
            % apply KF to each possible s_t
            for jcs=1:ncs
                C1_j_=C1_j(:,:,jcs)+C2(:,:)*D1i; % linearized slope in meq
                c_j_=c_j(:,jcs)+C2*(quadc1(z10)-D1i*z10); % linearized intercept in meq
                K0j=Q10*C1_j_'; % cov^(z_t,y_t|z_{t-1}.s_t,theta)
                Sigmay_j=C1_j_*K0j+DD; % V^(y_t|z_{t-1}.s_t,theta)
                Sigmay_j=(Sigmay_j+Sigmay_j')/2; %regularize...
                muy_j=c_j_+C1_j_*z10;% E^(y_t|z_{t-1}.s_t,theta)
                if numel(yt_) % if there are observations in y_t
                    muy_j_=muy_j(ndx_ynm);
                    Sigmay_j_=Sigmay_j(ndx_ynm,ndx_ynm);
                    K0j_=K0j(:,ndx_ynm);
                    lpytv(jcs)=mvn_logpdf(yt_,muy_j_,Sigmay_j_); % this is logp^(y_t|z_{t-1}.s_t,theta)
                    %[retcode,lpytv(jcs)]=GaussianPdfMatrix1_(yt_,muy_j_,Sigmay_j_); % this is log
                    if retcode == 0
                        return
                    end
                    Kj_=K0j_/Sigmay_j_; % Kalman Gain, conditioned on s_t
                    z11m(:,jcs)=z10+Kj_*(yt_-muy_j_);
                    Q11j=Q10-Kj_*K0j_';
                else
                    % this is in the case no updating actually takes place
                    % p_ij=zeros(ncs,ncs);
                    z11m(:,jcs)=z10;
                    Q11j=Q10;
                end
                Q11a(:,:,jcs)=(Q11j+Q11j')/2;
            end
            % compute probs for discrete state
            % now discrete part of the filter
            lpyt_max=max(lpytv); % scale factor for likelihood
            p11=p10.*exp(lpytv-lpyt_max); % p^(s_t|y_{1:t},x_{t-1},theta) unnormalized
            lnlt=sum(p11); %
            p11=p11/lnlt; % p^(s_t|y_{1:t},x_{t-1},theta), normalized
            if numel(yt_) % learning only when yt~=[0]
                lpa(it,in,1)=log(lnlt)+lpyt_max;
            end
            % now draw discrete state and take its log probability
            s1=draw_multinom(p11,1,ncs,1);
            lpst_=log(p11(s1)); % log p^(s_t|y_{1:t},x_{t-1},theta)
            lpst =log(ctp(s0,s1)); % log p(s_t|s_{t-1},theta)
            % now draw z_t from p^(z_t|y_{1:t},x_t,theta ); % either use
            % student t or Gaussian centered on moments coming from KF
            z1=z10;
            if nu>0
                %z1(nz1+1:end)=mvt_draw(z11m(nz1+1:end,s1),((nu-2)/nu)*squeeze(Q11a(nz1+1:end,nz1+1:end,s1)),nu,1);
                z1(nz1+1:end)=z11m(nz1+1:end,s1)+sqrt((nu-2)/nu)*chol(squeeze(Q11a(nz1+1:end,nz1+1:end,s1)))'*mvtrnd(eye(nz2),nu,1)';
                % evaluate p^(z_t|y_{1:t},x_t,theta ) at draw
                lpzt_  = mvt_logpdf(z1(nz1+1:end),z11m(nz1+1:end,s1),squeeze(Q11a(nz1+1:end,nz1+1:end,s1)),nu);
            else
                % here use Gaussian
                z1(nz1+1:end)=z11m(nz1+1:end,s1)+chol(squeeze(Q11a(nz1+1:end,nz1+1:end,s1)))'*randn(nz2,1);
                %[~,lpzt_] = GaussianPdfMatrix1_(z1(nz1+1:end),z11m(nz1+1:end,s1),squeeze(Q11a(nz1+1:end,nz1+1:end,s1)));
                lpzt_  = mvn_logpdf(z1(nz1+1:end),z11m(nz1+1:end,s1),squeeze(Q11a(nz1+1:end,nz1+1:end,s1)));
            end
            %
            lpxt_=lpst_+lpzt_; %log p^(x_t|y_{1:t},x_{t-1},theta)
            %[retcode,lpzt] = GaussianPdfMatrix1_(z1(nz1+1:end),z10(nz1+1:end),    squeeze(BB_i(nz1+1:end,nz1+1:end,s0)));
            lpzt  = mvn_logpdf(z1(nz1+1:end),z10(nz1+1:end),    squeeze(BB_i(nz1+1:end,nz1+1:end,s0)));
            %
            lpxt=lpst+lpzt; %log p(x_t|y_{1:t-1},x_{t-1},theta)
            if numel(yt_) % if thereare obss in y_t
                muyt=c_j(:,s1)+C1_j(:,:,s1)*z1+C2*quadc1(z1);
                %[retcode,lpyt]=GaussianPdfMatrix1_(yt_,muyt(ndx_ynm),DD(ndx_ynm,ndx_ynm));
                lpyt =mvn_logpdf(yt_,muyt(ndx_ynm),DD(ndx_ynm,ndx_ynm));
            else
                lpyt=0;
            end
            lpa(it,in,2:end) = [lpyt lpxt lpxt_];
            z1m(:,in)=z1;
            s1v(in)=s1;
            clc
            [in/N it/T im/M_]
        end
        lw=squeeze(lpa(it,:,2:4))*[1 1 -1]';
        w_=exp(lw-log_mean_exp(lw,3)-log(N)); %numerically more stable
        %w_=exp(lw)/sum(exp(lw));
        wm_(it,:)=w_;
        essm(it,im)=(1/sum(w_.^2))/N;
        draw = Resample_Kitagawa_draw(cumsum(w_),rand(1,1));
        z0m=z1m(:,draw);
        s0v=s1v(draw);
        za(it,:,:)=z0m;
        Sm(it,:)=s0v';
    end
    for it=1:T
        lnlv_smc(it)    =log_mean_exp(squeeze(lpa(it,:,2:4)),3)'*[1 1 -1]';
        lnlv_smc_lin(it)=log_mean_exp(squeeze(lpa(it,:,1)),3);
    end
    lnla(:,:,im)=[lnlv_Kim lnlv_smc_lin lnlv_smc ];
end
etime=toc;

%%

states_ndxm=[...
    1 2 3 4 ;...
    1 2 5 6 ;...
    1 3 5 7  ...
    ];

Pa_=zeros(T,ns_,2);

Fpm=zeros(T,ncs);
for is=1:ncs
    Fpm(:,is)=mean(Sm==is,2);
end


for is=1:ns_
    Pa_(:,is,1)=sum( Pm(:,states_ndxm(is,:)),2);
    Pa_(:,is,2)=sum(Fpm(:,states_ndxm(is,:)),2);

end


Za_=zeros(T,nz,2);
for is=1:ncs
    Za_(:,:,1)=Za_(:,:,1)+Za(:,:,is).*repmat(Pm(:,is),1,nz);
    Za_(:,:,2)=mean(za,3);
end

corrv=zeros(nz+ns_,1);
for iz=1:nz
    corrm=corr(squeeze(Za_(:,iz,:)));
    corrv(iz)=corrm(1,2);
end
for is=1:ns_
    corrm=corr(squeeze(Pa_(:,is,:)));
    corrv(nz+is)=corrm(1,2);
end



iswm=squeeze(sum(lnla(Tini_+1:end,:,:)))';
iswm_=iswm'*[ ...
       -1 -1   0;...
        0  1  -1;... 
        1  0   1;...
        ];

save(['smc_weights_latents_N_' int2str(N) '_M' int2str(M_)],'iswm','iswm_','lpa','lnla','Za_','Pa_','corrv');
    
