clear; clc; close all; 
%% main file to import inflation expectation data for RATTS model
% Import data from spreadsheet
% Script for importing data from the following spreadsheet:
%
%    Workbook: /Users/giovanniamisano/Desktop/inflation_expectations/USSurveyInflationExpectations.xls
%    Worksheet: Sheet1
%
% Auto-generated by MATLAB on 24-May-2021 18:42:48
% Setup the Import Options and import the data
opts = spreadsheetImportOptions("NumVariables", 3);
% Specify sheet and range
opts.Sheet = "Sheet1";
opts.DataRange = "A2:C164";
% Specify column names and types
opts.VariableNames = ["Date", "BlueChip10yinfl", "SPF10yinfl"];
opts.VariableTypes = ["double", "double", "double"];
% Import the data
table = readtable("USSurveyInflationExpectations.xls", opts, "UseExcel", false);
% Convert to output type
iem = table2array(table);
% Clear temporary variables
clear opts
% dates vector
datesv_ie=1967.25+(0:(size(iem,1)-1))'*.25;
iem(iem==-999)=NaN;
iev=4*iem(:,2);
iev(99:end)=4*iem(99:end,3);
save RATTS_inflation_expectations datesv_ie iev table;