clear; clc; close all; 
%% main file to import inflation expectation data for RATTS model
% Import data from spreadsheet
% Script for importing data from the following spreadsheet:
%
%    Workbook: /Users/giovanniamisano/Desktop/inflation_expectations/USSurveyInflationExpectations.xls
%    Worksheet: Sheet1
%
% Auto-generated by MATLAB on 24-May-2021 18:42:48
% Setup the Import Options and import the data
opts = spreadsheetImportOptions("NumVariables", 3);
% Specify sheet and range
opts.Sheet = "Sheet1";
opts.DataRange = "A2:C164";
% Specify column names and types
opts.VariableNames = ["Date", "BlueChip10yinfl", "SPF10yinfl"];
opts.VariableTypes = ["double", "double", "double"];
% Import the data
table = readtable("USSurveyInflationExpectations.xlsx", opts, "UseExcel", false);
% Convert to output type
iem = table2array(table);
% Clear temporary variables
clear opts
% dates vector
datesv_ie=1967.25+(0:(size(iem,1)-1))'*.25;
iem(iem==-999)=NaN;
iev=4*iem(:,2);
iev(99:end)=4*iem(99:end,3);
% import from updated, SPF from Philly Fed
opts = spreadsheetImportOptions("NumVariables", 5);
% Specify sheet and range
opts.Sheet = "INFLATION";
opts.DataRange = "A2:E208";
% Specify column names and types
opts.VariableNames = ["YEAR", "QUARTER", "INFPGDP1YR", "INFCPI1YR", "INFCPI10YR"];
opts.VariableTypes = ["double", "double", "double", "double", "double"];
% Import the data
SPFinflationexpectationsPhillyFed_Table = readtable("SPF_inflation_expectations_Philly_Fed.xlsx", opts, "UseExcel", false);
% Convert to output type
SPFinflationexpectationsPhillyFed = table2array(SPFinflationexpectationsPhillyFed_Table);
% Clear temporary variables
clear opts
% old data goes from 1967Q2 to 2007q4

datesv_ie_=(1967.25:.25:2021.75)';
iem_=nan(length(datesv_ie_),3);
iem_(find(datesv_ie==datesv_ie(1)): find(datesv_ie==datesv_ie(end)),1)=iev;
iem_(find(datesv_ie_==1970): find(datesv_ie_==2021.50),2)=SPFinflationexpectationsPhillyFed(:,5);
iem_(1:98,3)   =iem_(1:98  ,1); % the third column of iem_ contains the updated spliced series
iem_(99:end,3) =iem_(99:end,2);
%save RATTS_inflation_expectations datesv_ie iev table;
save RATTS_inflation_expectations_2021q3 datesv_ie iev table datesv_ie_ iem_ SPFinflationexpectationsPhillyFed_Table;


