clear; clc; close all;
str_var={'infl','dc','dy','ffr','y12','y40'};
% read old data set with sample size 1950q1-2009q1
[dm1,~]=xlsread('RATTS_data_2009Q1_small.xlsx',1,'b14:n250');
datesv1=dm1(:,4);
datam1=dm1(:,[9 8 6 10 11 13]); % ordering is  different in the old data set

% read new data set with sample size 1950q1-20019q1 (data on c and y end)
[dm2,~]=xlsread('dsge_data',1,'m15:u291');
datesv2=dm2(:,1);
datam2=dm2(:,[2 3 4 5 7 9]);
figure(1);
for in=1:6
    subplot(3,2,in);
    plot(datesv1,datam1(:,in));
    hold on;
    plot(datesv2,datam2(:,in));    
    hold off;
    title(str_var(in));
end

% now compute correlations across common sample
% (1950q1 to 2009q1, which corresponds to obs no. 237 
cv=zeros(6,1);
for in=1:6
    cm=[datam1(:,in) datam2(1:237,in)];
    cm(any(isnan(cm), 2), :) = [];
    cm=corrcoef(cm);
    cv(in)=cm(1,2);
end
% figure with all rates (ffm, y04, y12, y20, y40) pickef from dm2, matrix
% with all the new data series
figure(2);
plot(datesv2,dm2(:,5:9));
% compute moments for all rates from 1973Q3 onwards (this is when the 10 year zc bond starts)
% find out where we got that series in the old database
mom2=zeros(8,2);
mom2(:,1)=mean(dm2(87:end,2:end))';
mom2(:,2)=std(dm2(87:end,2:end))';
% now check exactly what is going on with the y40 series
y40m=zeros(length(datesv2),4);
y40m(1:length(datesv1),1)=datam1(:,end);
y40m(:,2)=datam2(:,end);
% in order to reconstruct period from 1961q2 (obs 46) to 1971q2 (obs 86) regress new
% series on old and take fitted values for missing obss 
% alternatively can rescale, which is the same as using the regression
% estimated only using observation 87
yv=y40m(87:237,1);
xv=y40m(87:237,2);
beta=xv\yv;
y40m(:,3)=y40m(:,2);
y40m(46:86,3)=y40m(46:86,1)*beta;
%% read data that I reconstructed from FEDS200628 paper 
[dm3,~]=xlsread('RATTS_2019_y40q',1,'b3:c237'); %read data from 1961:q2 to 2019:q4
datesv3=dm3(:,1);
y40m(:,4)=y40m(:,2);
y40m(46:86,4)=dm3(1:41,2);


% now define the new dataset (with the interpolated y40 for the period
% 1961q2-1971q2
datesv=datesv2;
datam=datam2;
datam(:,end)=y40m(:,4); % use the series that I reconstructed from FEDS200628 (using coeffs)
% now write to dataset
save('RATTS_newdata_2019','datesv','datam');
%   write csv, then transform it externally in xlsx file appendi
csvwrite('RATTS_newdata_2019.csv',[datesv datam],1);
str_var_={'obs','datesv'};
for in=1:6
    str_var_{in+2}=str_var{in};
end
% define table with labels to be written in 'xlsx' format.
T=array2table([(1:length(datesv))' datesv datam],'VariableNames',str_var_);
writetable(T,'RATTS_newdata_2019.xlsx');
%clc; close all; clear;
%[datam,str_var_]=xlsread('RATTS_newdata_2019');

figure(3);
plot(datesv2,datam2(:,end))
hold on;
plot(dm3(:,1),dm3(:,2))
hold off;