clear;clc;close all;
addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
% 4 way premia comparison (exhprs,EH_premia,DS,ACM)
%
%load results from model
M_=1e+4;
clev=.95;
load ../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/RATTS_2020_results.mat
load ../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/forecasts/forecasts.mat
load ../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/forecasts/Yo_mv.mat;
load ../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/premia_with_bands/premia.mat;
load ../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/forecasts/RS_premia.mat;
% compute model premia
model_premia=400*([Yo(:,5)-EHdatam(:,1) Yo(:,6)-EHdatam(:,2)]);
% compute exhprs
exhprs=400*squeeze(filpremia(:,:,1));
% compute DS premia
RS_premia= 400*mean(squeeze(Yfa(:,5:6,1,:)-Yfa_EH(:,5:6,1,:)),3);
RS_premia_=400*     squeeze(Yfa(:,5:6,:,:)-Yfa_EH(:,5:6,:,:));
% Quarterly ACM premia
[ACMvar,ACMlabels,ACMraw]=xlsread(...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/forecasts/ACMTermPremium.xlsx',...
    'ACM Monthly','A1:AE710');
% dd=datetime(cell2str(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
dd=datetime(string(ACMraw(2:end,1)),'InputFormat','dd-MMM-yyyy');
ACMlabels = ACMlabels(1,2:end) ;
% timeline = datetime(year(dd(1)),6,30):calmonths(3):datetime(year(dd(end)),month(dd(end)),30);
timeline = datetime(1966,3,31):calmonths(3):datetime(2019,12,31);
timeline = timeline';
ACMvarQ = zeros(length(timeline),size(ACMvar,2));
for i_yy = 1966:2019
    for i_qq = 1:4
        ACMvarQ(4*(i_yy-1966)+i_qq,:) = ACMvar(year(dd)==i_yy & month(dd)==3*i_qq,:) ;
    end
end
% ACMvarQ(end-1,:) = ACMvar(year(dd)==2020 & month(dd)==3,:) ;
% ACMvarQ(end,:) = ACMvar(year(dd)==2020 & month(dd)==6,:) ;


% here compute exhprs
% inputs
T=length(datesv);
nyields=length(n4);
filpremia=zeros(T,nyields,M_);
smopremia=zeros(T,nyields,M_);
%


nthin=M/M_;
for im=1:M_
    deltav=param(nthin*im,1:np)';
    %deltav=delta0;
    [~,y,gx,hx,gxx,hxx,gss,hss,eta,etastd,premia] =       RATTS_2020_modsol_Klein_2(2,deltav,n1,n2,n3,n4);
    [retcode_,y_,gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_] = RATTS_2020_modsol_Klein_(1,deltav,n1,n2,n3,n4);
    [a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,tpa,~,ctp,pv,s_vm,emv] = DSGE_MS_state_space_matrices_simple(gx,hx,gxx,hxx,gss,hss,eta,etastd,deltav);
    [a_i_,A1_i_,A2_,B_i_,c_j_,C1_j_,C2_,D_,Sigma_zz_,tpa_,pm_,ctp_,pv_,s_vm_,emv_] = ...
        DSGE_MS_state_space_matrices_simple(gx_,hx_,gxx_,hxx_,gss_,hss_,eta_,etastd_,deltav);
    [retcode,lnlv,pyta_ij,Za,Qa,pm,P01a,Z10a,Q10aa,p1m,sm,simstate,muy_ij_a,Sigmay_ij_a,y10m,zm] = ...
        DSGE_MS_Kim_Filter_pp_mv(Yo,a_i,A1_i,A2,B_i,c_j,C1_j,C2,D,Sigma_zz,ctp,pv,1,1,1);
    %
    filpremia(:,:,im)=400*pm*premia(n4,:)';
    smopremia(:,:,im)=400*pm*premia(n4,:)';
    clc;
    im/M_
end
%
%% premia comparisons, charts and tables
% first compute the po
qv=[(1-clev)/2; 1-(1-clev)/2]; % construct sizes of quantiles
filpremiaa_6619=mean_std_quantiles(filpremia,qv);
smopremiaa_6619=mean_std_quantiles(smopremia,qv);
RS_premiaa_6619=mean_std_quantiles(RS_premia_,qv); % already multiplied by 400

nfig=0;
% comparison ACM vs exhprs
nfig=nfig+1;
figure(nfig)
ACMvarQ_=ACMvarQ(1:end-3,[13 20]);
fig_yv=[ACMvarQ_(:); filpremiaa_6619(:)];
ylimv=[min(fig_yv(:)) 1.1*max(fig_yv(:))];
xlimv=[datesv(1) datesv(end)];
%
recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
%
nfig=0;
nfig=nfig+1;
figure(nfig);
for ib=1:nyields
    subplot(2,1,ib)
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;
    plot1=plot(datesv,[ACMvarQ_(:,ib) squeeze(filpremiaa_6619(:,ib,[1 3 4]))]);
    set(plot1(1),'LineWidth',2,'color','b','LineStyle','-');
    set(plot1(2),'LineWidth',2,'color','r','LineStyle','-');
    set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
    set(plot1(4),'LineWidth',1,'color','r','LineStyle','--');
    if ib==nyields
        legend({'NBER','ACM','exhprs mean','exhprs low','exhprs up'},'Numcolumns',5);
        legend boxoff;
    end
    xlim(xlimv);
    ylim(ylimv);
    hold off;
end
sgtitle('ACM premia and MS-DSGE exhprs','FontSize',16);
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/premia_comparison_exhprs_ACM_long_sample.pdf','-dpdf');

% ACM and RS premia (with bands)

nfig=nfig+1;
figure(nfig);
fig_yv=[ACMvarQ_(:); RS_premiaa_6619(:)];
ylimv=[min(fig_yv(:)) 1.1*max(fig_yv(:))];
xlimv=[datesv(1) datesv(end)];
%
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
for ib=1:nyields
    subplot(2,1,ib)
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;
    plot1=plot(datesv,[ACMvarQ_(:,ib) squeeze(RS_premiaa_6619(:,ib,1,[1 3 4]))]); 
    % notice that above I pick RS premia computed by conditioned on filtered mean of discrete state
    % choosing 2 as 3rd dimension of RS_premiaa_6619 would draw also discrete state from filtered distribution (a little more jagged
    % confidence bands)
    %
    set(plot1(1),'LineWidth',2,'color','b','LineStyle','-');
    set(plot1(2),'LineWidth',2,'color','r','LineStyle','-');
    set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
    set(plot1(4),'LineWidth',1,'color','r','LineStyle','--');
    if ib==nyields
        legend({'NBER','ACM','RS mean','RS low','RS up'},'Numcolumns',5);
        legend boxoff;
    end
    xlim(xlimv);
    ylim(ylimv);
    hold off;
end
sgtitle('ACM premia and MS-DSGE RS term premia','FontSize',16);
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/premia_comparison_RS_ACM_long_sample.pdf','-dpdf');



%%
% make chart combinig the bottom panels of the previous 2 charts, i.e. with
% the comparisons (ACM-exhprs) (ACM-RS premia) for the 10 year maturity.
% this is actually the chart that ended up in the paper
nfig=nfig+1;
figure(nfig);
subplot(2,1,1)
ym_fig=squeeze(filpremiaa_6619(:,2,[1 3 4]));
xlimv=datesv([1 end]);
ylimv=[min(ym_fig(:)) 1.1*max(ym_fig(:))];

y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot1=plot(datesv,ym_fig);
set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
set(plot1(2),'LineWidth',1,'color','r','LineStyle','--');
set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
legend({'NBER','model mean','model 2.5 %.','model 97.5 %'},'Numcolumns',5,'Location','NorthWest');

legend boxoff;
xlim(xlimv);
ylim(ylimv);
hold off;
title('Excess holding period returns, 10 year bond','FontSize',16);

% second panel
subplot(2,1,2)
ym_fig=[ACMvarQ_(:,2) squeeze(RS_premiaa_6619(:,2,1,[1 3 4]))];
xlimv=datesv([1 end]);
ylimv=[min(ym_fig(:)) 1.1*max(ym_fig(:))];
y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
yyaxis left
plot1=plot(datesv,ym_fig(:,1));
ylim(ylimv);
yyaxis right
plot2=plot(datesv,ym_fig(:,2:end));
set(plot1(1),'LineWidth',2,'color','b','LineStyle','-');
set(plot2(1),'LineWidth',2,'color','r','LineStyle','-');
set(plot2(2),'LineWidth',1,'color','r','LineStyle','--');
set(plot2(3),'LineWidth',1,'color','r','LineStyle','--');
legend({'NBER','ACM','model mean','model 2.5 %','model 97.5 %'},'Numcolumns',5,'Location','NorthWest');
legend boxoff;
xlim(xlimv);
hold off;
title('Term premia, 10 year bond','FontSize',16);
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/premia_comparison_exhprs_RS_ACM_long_sample_10_yr.pdf','-dpdf');
%%
% now chart with exhprs+AMC+RS premia for both maturities
nfig=nfig+1;
figure(nfig);
fig_yv=[ACMvarQ_(:); filpremiaa_6619(:); RS_premiaa_6619(:)];
ylimv=[min(fig_yv(:)) 1.1*max(fig_yv(:))];
xlimv=[datesv(1) datesv(end)];
%
y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
for ib=1:nyields
    subplot(2,1,ib)
    fill(recession_dates,y_recession_dates,[.9 .9 .9]);
    hold on;
    plot1=plot(datesv,[ACMvarQ_(:,ib) squeeze(filpremiaa_6619(:,ib,[1 3 4])) squeeze(RS_premiaa_6619(:,ib,1,1))]); 
    % notice that above I pick RS premia computed by conditioned on filtered mean of discrete state
    % choosing 2 as 3rd dimension of RS_premiaa_6619 would draw also discrete state from filtered distribution (a little more jagged
    % confidence bands)
    %
    set(plot1(1),'LineWidth',2,'color','b','LineStyle','-');
    set(plot1(2),'LineWidth',2,'color','r','LineStyle','-');
    set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
    set(plot1(4),'LineWidth',1,'color','r','LineStyle','--');
    set(plot1(5),'LineWidth',1,'color','k','LineStyle','-');
    if ib==nyields
        legend({'NBER','ACM','exhprs mean','exhprs low','exhprs up','RS premia'},'Numcolumns',6);
        legend boxoff;
    end
    xlim(xlimv);
    ylim(ylimv);
    hold off;
end
sgtitle('ACM premia, MS-DSGE EXHPRs and RS term premia','FontSize',16);
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/premia_comparison_exhprs_RS_ACM_long_sample.pdf','-dpdf');
%%
% construct the correlation matrix
% exhprs premia_vs_EH RS_premia ACM
cm1=corr([exhprs(:,1) RS_premia(1:size(exhprs,1),1)  ACMvarQ_(1:size(exhprs,1),1)]);
cm2=corr([exhprs(:,2) RS_premia(1:size(exhprs,1),2)  ACMvarQ_(1:size(exhprs,1),2)]);
corm=cm1;
for im=2:3
    for jm=1:im-1
    corm(im,jm)=cm2(im,jm);
    end
end
for im=1:3
    corm(im,im)=NaN
end
%
% now produce the latex table
%
column_label={'exhprs','RS\_premia','ACM'};
row_label=column_label;
input.data=corm;
input.tableColLabels =column_label;
input.tableRowLabels =row_label;
input.transposeTable = 0;
% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
input.dataFormat = {'%1.3f',3}; % three digits precision for first two columns, one digit for the last
% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';
% Column alignment in Latex table ('l'=left-justified,'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'r';
% Switch table borders on/off:
input.tableBorders = 1;
% LaTex table caption:
input.tableCaption = ['Correlation matrix across premia'];
% LaTex table label:
input.tableLabel = 'Premia_correlation_matrix';
% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 0;
% call latexTable:
latex = latexTable(input);
latex=strrep(latex,'H!','htbp');
%latex=strrep(latex,'{table}','{sidewaystable}');
%latex=strrep(latex,'_','\_');
if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;
system ('mv *.tex ../output');
%%

