%% comparison of ML all models v1 v2 v3 vp1 vp2 vp3 
% short sample and long sample
% 06/08/2021
% load 12 estimates: 
clear; clc; close all;
if isunix & ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/ricerca/matlab_code'));
end
%% load all estimates
Datesv=(1966:.25:2009)';
Datesv_new=(1966:.25:2019)';
%%
str_models={'vp2s','vp2l','vp3s','vp3l', 'onepistars','onepistarl','noMSzs','noMSzl'}; 
str_models_= strrep(str_models,'_','\_');
%%
% LOAD strings describing where results sit;
results_location_str = ...
    { ...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_full_sample_missing_short_rate/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp3/estimation_1966_2009_missing_short_rate/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp3/estimation_full_sample_missing_short_rate/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2_variants/one_pistar_66_on/estimation_6609/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2_variants/one_pistar_66_on/estimation_6619/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2_variants/only_z/66_09/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2_variants/only_z/66_19/extensive_postprocessing/mg_likelihood/RATTS_2020_ML.mat', ...
    };
nmod=numel(results_location_str); % defines number of models 
%% now define recipients and load results (might be slow) 
MLa=zeros(9,3,nmod); %storing matrix with synthesis of results (9 cols = mean, std, low q and high q post and prior + calibrated value
covm=zeros(9,nmod);
for imod = 1:nmod
    eval(['load ' results_location_str{imod} ';']);
    MLa(:,:,imod)=MLvec;
    covm(:,imod)=coverage;
    %clc;
    ['loading model ' num2str(imod) ' of ' num2str(nmod)]
%
end


%% tables with estimate results
row_label={'baseline','cal. meas. errors','no MS in $\pi^*$','no MS in $z$'};
%{
row_label=reshape(str_models,2,[])';
row_label=strrep(row_label(:,1),'s','');
%}
column_label={'1966-2009','1966-2019'}';
input.data=reshape(squeeze(MLa(4,1,:)),2,[])';
input.tableColLabels =column_label;
input.tableRowLabels =row_label;
input.transposeTable = 0;
% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
input.dataFormat = {'%4.1f',2}; % three digits precision for first two columns, one digit for the last
% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';
% Column alignment in Latex table ('l'=left-justified,'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'c';
% Switch table borders on/off:
input.tableBorders = 1;
% LaTex table caption:
input.tableCaption = ['Marginal likelihood comparisons '];
% LaTex table label:
input.tableLabel = ['Marginal_likelihood_comparisons_vp2_vp3_onepistar_only_z'];
% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 0;
% call latexTable:
latex = latexTable(input);
latex=strrep(latex,'H!','htbp');
%latex=strrep(latex,'{table}','{sidewaystable}');
%latex=strrep(latex,'_','\_');
if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;
%% Table with results using the DS ratio
tablem=input.data;

load('Dickey_Savage_par_pair_7_8.mat');
lpor=[-1 1]*log(squeeze(ksa(1,:,:)));
tablem(end-1,2)=tablem(1,2)+lpor(2);
load('Dickey_Savage_par_pair_11_12.mat');
lpor=[-1 1]*log(squeeze(ksa(1,:,:)));
tablem(end,:)=tablem(1,:)+lpor;
%
input.data=tablem;
input.tableLabel = ['Marginal_likelihood_comparisons_vp2_vp3_onepistar_only_z_Dickey_Savage'];
latex = latexTable(input);
latex=strrep(latex,'H!','htbp');
%latex=strrep(latex,'{table}','{sidewaystable}');
%latex=strrep(latex,'_','\_');
if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;
system('mv *.tex ../output');





