clear; clc; close all;
if isunix & ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/ricerca/matlab_code'));
end
%% load all estimates
Datesv=(1966:.25:2009)';
Datesv_new=(1966:.25:2019)';
%%
str_models={'vp2_66_09','vp2_66_19'};
str_models_= strrep(str_models,'_','\_');
nmod=length(str_models);
%%
% LOAD strings describing where results sit;
results_location_str = ... 
    { ...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/forecasts/forecasts.mat', ...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_full_sample_missing_short_rate/extensive_postprocessing/forecasts/forecasts.mat', ...
    };
%% define recession dates for shading 

recession_dates0=[1969.75 1970.75 1973.75 1975.0 1980.0 1980.5 1981.5 1982.75 1990.75 1991.0 2001.0 2001.75 2008 2009]';
recession_dates=reshape(repmat(recession_dates0,1,2)',2*length(recession_dates0),1);
%% now define recipients and load results (might be slow) 
M=5e+3;
npar=45; % number of elements stored in param
np=40; % number of parameters in the model
nsimpar=35; % number of parameters being actually simulated
%smopremiaa=zeros(numel(Datesv_new),2,5,nmod); % storing smoothed premia, post mean, std and qv for each model
%{
Yoa=zeros(numel(Datesv_new),6,nmod); % store observables seen by all models
parama=zeros(M,npar,nmod); % storing the paramet draws for each model 
%}
% notice that param includes also lnprior lnl accpt prob etc, hence npar =
% 45, not np = 40;
%priorparama=zeros(M,np,nmod); % storing prior draws for all models
%testa=zeros(np,9,nmod); %storing matrix with synthesis of results (9 cols = mean, std, low q and high q post and prior + calibrated value
%cvP0a=zeros(nsimpar,nsimpar,nmod); % storing the matrix used to draw from MH candidate cv*P0
smpllimv=zeros(2,nmod); % to store sample size start and end for each of the models
Saa_mg=zeros(numel(Datesv_new),3,5,nmod); % to store the marginal state allocations
forecast_array_=zeros(15,213,41,5,nmod);

for imod = 1:nmod
    eval(['load ' results_location_str{imod} ';']);
    smpllimv(:,imod)=datesv([1 end]);
    forecast_array_(:,:,:,:,imod)=forecast_array;
    clc;
    ['loading model ' num2str(imod) ' of ' num2str(nmod)]
%
end
%% now load SPF expectations
load ../../RATTS_inflation_expectations/RATTS_inflation_expectations_2021q3.mat;
% here I load datesv_ie_ and iem_ 
%% now load SPF short term rate 10 year expectations

%load ../../Philly_Fed_short_term_rate_expectations/st_rate_10y_expq.mat;
%% make charts: inflation expectations
nfig=1;
figure(nfig);
for imod=1:nmod
    subplot(nmod,1,imod);
    plot(datesv,400*squeeze(forecast_array_(10,:,[2 21 41],1,imod)),'LineWidth',2);
    xlim(datesv([1 end]));
    title(str_models_{imod});
    sgtitle({'Model-consistent inflation expectations'});
    if imod==1
        legend('1 step ahead','20','40','FontSize',8,'NumColumns',3);
        legend boxoff;
    end
end
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/pi_exp_different_horizons_vp2_models','-dpdf');
%saveas(nfig,filename0,'fig');
% now comparison with SPF with bands
nfig=nfig+1;
figure(nfig);
for imod=1:nmod
    subplot(nmod,1,imod);
    % here construct +- 1 sigma bands
    ym_fig=400*squeeze(forecast_array_(10,:,41,1,imod))';
    ym_sig=400*squeeze(forecast_array_(10,:,41,2,imod))'/sqrt(M);
    ym_fig_=[ym_fig ym_fig-4*ym_sig ym_fig+4*ym_sig];
    plot1=plot(datesv,ym_fig_,'LineWidth',2);
    set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
    set(plot1(2),'LineWidth',1,'color','r','LineStyle','--');
    set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
    xlim(datesv([1 end]));
        hold on;
        plot(datesv_ie_,iem_(:,3),'LineWidth',3,'LineStyle','--');
        xlim(datesv([1 end]));
        hold off;
    title(str_models_{imod});
    sgtitle({'Model-consistent and SPF inflation expectations '});
    if imod==1
        legend('Model mean','Model upper','Model lower','Survey','FontSize',8,'NumColumns',4);
        legend boxoff;
    end    
end
%
orient(nfig,'portrait');
%filename0=;
print(nfig,'-fillpage','../output/pi_exp_model_survey_vp2_models_with_bands','-dpdf');
%saveas(nfig,filename0,'fig');

% now figure with the conditional std
nfig=nfig+1;
figure(nfig);
    ym_sig=400*squeeze(forecast_array_(10,:,41,2,:))';
    plot1=plot(datesv,ym_sig,'LineWidth',2);
    set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
    set(plot1(2),'LineWidth',1,'color','k','LineStyle','--');
    xlim(datesv([1 end]));
    title({'Model-consistent 10 year ahead conditional standard deviation'});
        legend(str_models_,'FontSize',8,'NumColumns',nmod);
        legend boxoff;
    
orient(nfig,'portrait');
%filename0=;
print(nfig,'-fillpage','../output/pi_10yr_cond_std','-dpdf');
%saveas(nfig,filename0,'fig');
% now comparison with SPF without bands
nfig=nfig+1;
figure(nfig);
for imod=1:nmod
    subplot(nmod,1,imod);
    % here construct +- 1 sigma bands
    ym_fig=400*squeeze(forecast_array_(10,:,41,1,imod))';
    plot1=plot(datesv,ym_fig,'LineWidth',2);
    set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
    xlim(datesv([1 end]));
    hold on;
    plot(datesv_ie_,iem_(:,3),'LineWidth',2,'LineStyle','--','color','b');
    xlim(datesv([1 end]));
    hold off;
    title(str_models_{imod});
    sgtitle({'Model-consistent and SPF inflation expectations '});
    if imod==1
        legend('Model','Survey','FontSize',8,'NumColumns',4);
        legend boxoff;
    end
end
orient(nfig,'portrait');
%filename0=;
print(nfig,'-fillpage','../output/pi_exp_model_survey_vp2_models_without_bands','-dpdf');
%saveas(nfig,filename0,'fig');
%% make chart for baseline vp2 6609 model (with NBER shading),
%to be inserted in the paper 
% without bands
nfig=nfig+1;
figure(nfig);
ym_fig=400*squeeze(forecast_array_(10,:,41,1,1))';
ylimv=[1 1.05*max(ym_fig)]';
y_recession_dates=repmat([ylimv(1) ylimv(2) ylimv(2) ylimv(1)]',length(recession_dates0)/2,1);
fill(recession_dates,y_recession_dates,[.9 .9 .9]);
hold on;
plot1=plot(datesv,ym_fig,'LineWidth',3);
set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
xlim(datesv([1 end]));
ylim(ylimv);
hold on;
plot(datesv_ie_,iem_(:,3),'LineWidth',3,'LineStyle','--','color','b');
xlim(datesv([1 end]));
hold off;
sgtitle({'Model-consistent and SPF inflation expectations '});
legend('NBER','Model','Survey','FontSize',12,'NumColumns',4);
legend boxoff;
grid on;
set(gca,'FontSize',20);
orient(nfig,'landscape');
%filename0=;
print(nfig,'-fillpage','../output/pi_exp_model_survey_vp2_6609_without_bands','-dpdf');
% with bands
nfig=nfig+1;
figure(nfig);
% here construct +- 1 sigma bands
ym_fig=400*squeeze(forecast_array_(10,:,41,1,1))';
ym_sig=400*squeeze(forecast_array_(10,:,41,2,1))'/sqrt(M);
ym_fig_=[ym_fig ym_fig-2*ym_sig ym_fig+2*ym_sig];
plot1=plot(datesv,ym_fig_,'LineWidth',2);
set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
set(plot1(2),'LineWidth',1,'color','r','LineStyle','--');
set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
xlim(datesv([1 end]));
hold on;
plot(datesv_ie_,iem_(:,3),'LineWidth',3,'LineStyle','--');
xlim(datesv([1 end]));
hold off;
title({'Model-consistent and SPF inflation expectations '});
legend('Model mean','Model upper','Model lower','Survey','FontSize',8,'NumColumns',4);
legend boxoff;
grid on;
set(gca,'FontSize',20);
orient(nfig,'landscape');
%filename0=;
print(nfig,'-fillpage','../output/pi_exp_model_survey_vp2_6609_with_naive_bands','-dpdf');
%% short term rate expectations
nfig=nfig+1;
figure(nfig);
for imod=1:nmod
    subplot(nmod,1,imod);
    plot(datesv,400*squeeze(forecast_array_(13,:,[2 21 41],1,imod)),'LineWidth',2);
    xlim(datesv([1 end]));
    title(str_models_{imod});
    sgtitle({'Model-consistent short term rate expectations'});
    if imod==1
        legend('1 step ahead','20','40','FontSize',8,'NumColumns',3);
        legend boxoff;
    end
end
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/t_rate_exp_different_horizons_vp2_models','-dpdf');
%saveas(nfig,filename0,'fig');
% now comparison with SPF
%{
nfig=nfig+1;
figure(nfig);
for imod=1:nmod
    subplot(nmod,1,imod);
    plot(datesv,400*squeeze(forecast_array_(13,:,41,1,imod)),'LineWidth',2);
    xlim(datesv([1 end]));
    hold on;
    plot(datesvq,st_rate_10y_expq,'*');
    xlim(datesv([1 end]));
    hold off;
    title(str_models_{imod});
    sgtitle({'Model-consistent and SPF short term rate expectations '});
    if imod==1
        legend('Model','Survey','FontSize',8,'NumColumns',2);
        legend boxoff;
    end
end
orient(nfig,'portrait');
filename0='../output/st_rate_exp_model_survey_vp_models';
print(nfig,'-fillpage',filename0,'-dpdf');
%saveas(nfig,filename0,'fig');
%}
%% now add chart with2 sigma bands using an estimate of the standard deviation of the conditional expectation
eval(['load ' results_location_str{1} ';']);
ym_sig=400*std(squeeze(mean(reshape(lt_pi_exp,size(lt_pi_exp,1),200,100),2)),[],2);
nsig=1;
nfig=nfig+1;
figure(nfig);
% here construct +- 1 sigma bands
ym_fig=400*squeeze(forecast_array_(10,:,41,1,1))';
ym_fig_=[ym_fig ym_fig-nsig*ym_sig ym_fig+nsig*ym_sig];
plot1=plot(datesv,ym_fig_,'LineWidth',2);
set(plot1(1),'LineWidth',2,'color','r','LineStyle','-');
set(plot1(2),'LineWidth',1,'color','r','LineStyle','--');
set(plot1(3),'LineWidth',1,'color','r','LineStyle','--');
xlim(datesv([1 end]));
hold on;
plot(datesv_ie_,iem_(:,3),'LineWidth',3,'LineStyle','--');
xlim(datesv([1 end]));
hold off;
title({'Model-consistent and SPF inflation expectations '});
legend('Model mean','Model upper','Model lower','Survey','FontSize',12,'NumColumns',4);
legend boxoff;
grid on;
set(gca,'FontSize',20);
orient(nfig,'landscape');
%filename0=;
print(nfig,'-fillpage','../output/pi_exp_model_survey_vp2_6609_with_bands','-dpdf');

