% code to make charts with IRFs to MS states 
% uses output of scripts in the folder
% '/cmc/scratch/m1gga00/sandbox/RATTS_revisions/RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/equity'
clear; clc; close all;
str_dir='../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/equity/';
results_location_str = ... 
    { ...
    [str_dir 'MS_IRFs_ini111_swiothers_temp.mat'], ...
    };
str_models={'swi temp'}
ndx_sel_var= [11 13 14 22 19 28 24 21 30]';
ndx_sel_sta=3; % pick 
qv_=[.16 .84];
nh_=40;
%
nh=80;
nvar=30;
nvar_=length(ndx_sel_var);
% prep container for relevant stuff
irfaa_=zeros(nvar,nh+1,3,2,2+numel(qv_));
% load relevant stuff
    eval(['load ' results_location_str{1} ';']);
    irfaa_(:,:,:,:,:)=400*mean_std_quantiles(irfa,qv_);
%%
str_var_=strrep(str_var,'_','\_');
% now to harmonize with notation  in the paper
str_var__=str_var_;
str_var__{11}='\pi_t';
str_var__{12}='\Delta c_t';
str_var__{13}='\Delta y_t';
str_var__{19}='Rn_t';
str_var__{21}='ERPn_t';
str_var__{22}='Rbar_t';
%% generate chart 
nfig=1;
is=ndx_sel_sta(1);
itype=1;
figure(nfig);
for in=1:nvar_
    in1=ndx_sel_var(in);
    ylimv=squeeze(irfaa_(in1,1:(nh_+1),is,:,[1 3 4]));
    ylimv=[min(ylimv(:)) max(ylimv(:))];
    subplot(3,3,in);
    plot1=plot((0:nh_)',squeeze(irfaa_(in1,1:(nh_+1),is,itype,[1 3 4])));
    set(plot1(1),'LineWidth',2,'color','r','Linestyle','-');
    set(plot1(2),'LineWidth',1,'color','k','Linestyle','--');
    set(plot1(3),'LineWidth',1,'color','k','Linestyle','--');
    ylim(ylimv);
    title(str_var__{in1});
end
%
orient(nfig,'portrait');
filename0='../output/IRFS_MS_z_selected_variables_swiothers_type1';
print(nfig,'-fillpage',filename0,'-dpdf');
