% code to report sensitivity analysis (h=0, gamma = psi) in section C of the appendix
% Gianni 01.05.2022
clear; clc; close all;
if isunix & ismac==0
    addpath(genpath('/cmc/scratch/m1gga00/matlab_code'));
elseif ismac    
    addpath(genpath('/Users/giovanniamisano/Documents/gianni/ricerca/matlab_code'));
end
%% load all estimates
datesv=(1966:.25:2019)';
%%
str_compm={'baseline','no habits'; 'baseline', 'power utility'};
M=1e+3;
qv=[.05 .1 .25 .5 .75 .9 .95]';
%%
% LOAD strings describing where results sit;
results_location_str = ... 
    { ...
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/sensitivity/h/workspace.mat', ...      
    '../../../RATTS_2020_asy_prior_2021/vp2/estimation_1966_2009_missing_short_rate/extensive_postprocessing/sensitivity/gampsi/workspace.mat' ...
    };
nmod=numel(results_location_str); % defines number of models 
T=length(datesv);
filpremiaa=zeros(T,2,2*nmod,M);
%% now define recipients and load results (might be slow) 
for imod = 1:nmod
    eval(['load ' results_location_str{imod} ';']);
    clc;
    filpremiaa(:,:,(imod-1)*2+1:imod*2,:)=filpremia;
    ['loading model ' num2str(imod) ' of ' num2str(nmod)]
end
%%
filpremiaa_=mean_std_quantiles(filpremiaa,qv);
nfig=1;
figure(nfig);
for ib=1:nyields
    subplot(2,1,ib);
    plot1=plot(datesv,400*squeeze(filpremiaa_(:,ib,[1 2 4],1)));
    title([int2str(n4(ib)) '-period filtered expected excess holding period returns']);
    set(plot1(1),'LineWidth',2,'color','k','LineStyle','-');
    set(plot1(2),'LineWidth',2,'color','b','LineStyle','-');
    set(plot1(3),'LineWidth',2,'color','r','LineStyle','-');
    if ib==nyields
        legend({'baseline','no habits','power utility'},'Numcolumns',1,'Location','NorthWest','FontSize',12);
        legend boxoff;
    end
    xlim(datesv([1 end]));
    set(gca,'FontSize',16);
end
orient(nfig,'portrait');
print(nfig,'-fillpage','../output/exhprs_h_gampsi.pdf','-dpdf');

