clear;clc;close all;
load('../../../RATTS_2020_asy_prior_2021/vp3/estimation_1966_2009_missing_short_rate/extensive_postprocessing/SMC/smc_weights_latents_N_500000_M1.mat');
%%

lcolor_strv={'b','r'};
lstyle_strv={'-','--'};

znames_str={'r_{t-1}','\pi_{t-1}','c^~_{t-1}','y^~_{t-1}','\xi_t',...
    'z_t','\eta_t','\mu_t','G_t'};
snames_str={'prob high \pi^*','prob high \sigma_{\eta}','prob high \sigma_{z}'};
T=size(Za_,1);
datesv=1966+((0:(T-1))/4)';
nz=length(znames_str);
ns=length(snames_str);
nfig=0;
%
nfig=nfig+1;
figure(nfig);
for iz=1:nz
    subplot(4,3,iz);
    plot1=plot(datesv,squeeze(Za_(:,iz,:)));
    set(plot1(1),'LineWidth',2);
    set(plot1(2),'LineWidth',2);
    %title(strrep(znames_str(iz),'_','\_'));
    title(znames_str(iz));
    if iz==1
        legend({'EKF+Kim','SMC'},'numColumns',2);
        legend boxoff;
    end
    xlim(datesv([1 end]));
    set(gca,'FontSize',16);
end
%
for is=1:ns
    subplot(4,3,nz+is);
    plot1=plot(datesv,1-squeeze(Pa_(:,is,:)));
    set(plot1(1),'LineWidth',2);
    set(plot1(2),'LineWidth',2);
    %title(strrep(snames_str(is),'_','\_'));
    title(snames_str(is));
    xlim(datesv([1 end]));
    set(gca,'FontSize',16);
end
sgtitle('Comparison filtered latent states, EKF+Kim v. SMC')
filename0='../output/latent_comparisons_smc_v_ekf_kim';
orient('landscape');
saveas(nfig,filename0,'fig');
print(nfig,'-dpdf','-r2400',filename0,'-fillpage');
% now make chart and table with comparison of likelihoods
nfig=nfig+1;
figure(nfig);
plot1=plot(datesv,lnla,'LineWidth',2);
set(gca,'FontSize',20);
xlim(datesv([1 end]));
legend({'EKF+Kim','EKF+SMC','SMC'},'numColumns',3,'Location','SouthWest','FontSize',12);
legend boxoff;
filename0='../output/likelihood_comparisons_smc_v_ekf_kim';
orient('landscape');
saveas(nfig,filename0,'fig');
print(nfig,'-dpdf','-r2400',filename0,'-fillpage');
% now table
tablem=corr(lnla)
row_label={'EKF+Kim','EKF+SMC','SMC'}';
%{
row_label=reshape(str_models,2,[])';
row_label=strrep(row_label(:,1),'s','');
%}
column_label={'Kim+EKF','EKF+SMC','SMC'}';
input.data=tablem;
input.tableColLabels =column_label;
input.tableRowLabels =row_label;
input.transposeTable = 0;
% Determine whether input.dataFormat is applied column or row based:
input.dataFormatMode = 'column'; % use 'column' or 'row'. if not set 'colum' is used
input.dataFormat = {'%1.2f',3}; % three digits precision for first two columns, one digit for the last
% Define how NaN values in input.tableData should be printed in the LaTex table:
input.dataNanString = '-';
% Column alignment in Latex table ('l'=left-justified,'c'=centered,'r'=right-justified):
input.tableColumnAlignment = 'c';
% Switch table borders on/off:
input.tableBorders = 1;
% LaTex table caption:
input.tableCaption = ['Likelihood computations comparisons: Kim+EKF, EKF+SMC, full SMC'];
% LaTex table label:
input.tableLabel = ['smc_likelihood_comparisons_vp3'];
% Switch to generate a complete LaTex document or just a table:
input.makeCompleteLatexDocument = 0;
% call latexTable:
latex = latexTable(input);
latex=strrep(latex,'H!','htbp');
%latex=strrep(latex,'{table}','{sidewaystable}');
%latex=strrep(latex,'_','\_');
if exist([input.tableLabel '.tex'],'file')
    system(['rm ' input.tableLabel '.tex']);
end
diary([input.tableLabel '.tex']);
disp(char(latex));
diary off;
system('mv *.tex ../output');